static char rcsid[]="$Id: SkampiVersion.c,v 3.1 1999/10/18 16:19:26 skampi Exp skampi $";
#include <stdio.h>
#ifndef WIN
 #include <sys/utsname.h>
#endif
#include "mpi.h"
/* SKaMPI Special Karlsruher MPI-Benchmark
   R. Reussner, 04.12.1996 
   31.01.97   version2

   last change:
@MODULE: skampi
This is the main module. It contains main() and the most global
variables. (Other specific globals can be found in mw.c.)
The debug-switches here are valid for all other modules if you
use skosfile.
{
}
*/

/* check the io possibilities of the node with rank 0 */
/* #define NO_IO_CHECK  */  

#include <stdlib.h> 
#include <math.h>
#include <time.h>
#include <ctype.h>
#include <string.h>

#define D(A)  /* datalist */
#define O(A) A /* Output, delete the "A" to suppress output on stdout */
#define D1(A)  /* Parser, etc. */
#define D2(A) 
#define D4(A) 
#define D7(A)   /* for Gather_Send */
#define D8(A)   /* for node_times in p2p.c */
#define D9(A)   /* for time_suite_default in skampi_params.c */
#define D10(A)  /* for debugging node_times */
#define D11(A)   /* for debugging autodist */
#define D13(A)  /* for debugging user defined types */
#define D14(A)  /* for blocks parameter in skampi_params.c */
#define D15(A)   /* for debugging user defined types in autodist */
#define D16(A)  /* for debugging user defined types in skampi_types */
#define D17(A)  /* datatypes in mw.c */
#define D18(A)  /* last argument in autodist.c */
#define  DIFFERENT_SEND_RECV_TYPES 


/* #define DATABUGS */

/* #define DEBUG_NODE_TIMES */

/* Globals */

MPI_Op
  _skampi_reduce_op;

MPI_Comm
  _current_comm;


int 
  _skampi_myid,
  numprocs,
  max_msg_len = 0x100000,
  _skampi_buffer_size = 0;

int
  _skampi_reduce_buffer_size = 0;

/* initialized in skampi_tools.c, init_skalib used in skampi_types. */
int
  intsize,
  longintsize,
  doublesize,
  longdoublesize;

char 
  expl_text[0x1100],
  _skampi_msg[0x800],
  *log_file_name,
  *out_file_name,
  *_skampi_buffer, 
  *_skampi_buffer_2,
  *_skampi_reduce_buffer,
  processor_name[MPI_MAX_PROCESSOR_NAME],
  old_log_file_name[0x100],
  new_out_file_name[0x100];


double
  _critical_min_time;

MPI_Comm 
  default_communicator;

/* $Id: sk_dta.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* data declarations for skampi
   -header file-
   R. Reussner, 16.01.1997

   last change:

   Note: when changing this data_structure, adaptions in 
   sk_dta.c have to be made!
   
   for rsplit: level 1 documentation (-> ../doc/skampili.tex )
               default level for skosfile



*/

/*@1in../doc/data-ds.c*/
typedef struct
{
  double
    result_cleaned,          /* result (meanvalue) of cleaned 
				measurements at arg */
    result_all    ,          /* result (meanvalue) of all 
				measurements at arg */
    standard_error_cleaned,  /* standard standard error of 
				cleaned measurements */
    standard_error_all;  /* standard standard error of all measurements */
/*    result_sum;  */    /* sum of all results measured at arg */
  int
    count_cleaned,       /* number of cleaned measurements performed at arg */
    count_all,           /* number of all measurements performed at arg */
    arg;    	         /* value of the x axis as argument for the
			    measurements performed */
  long int
    arg_bytes;
#ifndef SEQ
  double *node_times;    /* in this array the execution times on each
			    node of the function_to_be_measured are
			    stored */
  int nodes;             /* size of above array */
  int used_nodes;         /* truee iff output node array valid */
#endif /*SEQ*/
}data_t;
/*@1no*/
data_t *init_data (data_t *data, int nodes);
data_t *copy_data (data_t *dest, data_t *source);
void free_data (data_t *data, int mode);

enum {STATIC, DYNAMIC};            /* for mode in free_list
				    STATIC == not freeing the descriptor
				    DYNAMIC == freeing the descriptor */





#define DL_LINE_LEN  (MAX_PROCESSORS*8+256)   /* max length of one line read from a file */
			
/*@1in../doc/one-list-ele-ds.c*/
/* one list element */
typedef struct DATA_ELE
{
  data_t data;        /* results of measurement */
  struct DATA_ELE         /* double-linked list */
    *prev,
    *next;
}list_item_t;

/*@1in../doc/list-ds.c*/
/* descriptor of list */
typedef struct DATA_LIST
{
  list_item_t
    *list_start,               /* Start of data_list */
    *list_end,                 /* actual end of data_list */
    *list_last;                /* last access */
  unsigned number;             /* number of elements */
}data_list_t;
/*@1no*/
enum {DL_NO_ERROR, DL_NO_ELEM, DL_NO_MEM};  /* error codes */
enum {END,START,LAST};             /* for mode in read_ele */


#define append(l,dataptr,error) add(l,END,0,dataptr,error)

/* Prototypes */

/* Initializes descriptor */
data_list_t *init_list(data_list_t *l);

/* add can also used as insert: add inserts (arg,result) at pos at
   END/START (mode) in l and returns new list.
   errorcode returned in error */
data_list_t *add (data_list_t *l,  int mode, int pos, data_t *data,
		  int *error);

/* reads data in l at pos at (END/START) (mode) and returns
   NULL in error case */
data_t *read_ele (data_list_t *l, int mode, int pos, data_t *data, int *error);

/* reads data in l at pos from list_item and returns
   NULL in error case */
data_t *read_item_ele (data_list_t *l, list_item_t *list_item, int pos, 
		       data_t *data, int *error);

/* returns address of a list item, used for interaction with the 
priority queue and in postprocessing */
list_item_t *item_addr (data_list_t *l, int mode, int pos, int *error);

/* returns address of a list item, relative from list_item */
list_item_t *item_addr_at_item (data_list_t *l, list_item_t *list_item, 
				int pos, int *error);

/* returns number of elements stored in l */
int number_of_elements (data_list_t *l);

/* TRUE iff item ist last (first) element of a list */
int is_end (list_item_t *item);
int is_start (list_item_t *item);

/* removes element at pos from END/START (mode) in l and returns errorcode */
data_list_t *remove_ele (data_list_t *l,  int mode, int pos);

/* frees all ressources used by l */
void free_data_list (data_list_t *l, int mode);

/* statistical functions */
double variance (data_list_t *l);
double median (data_list_t *l);
double average (data_list_t *l);
double maximum (data_list_t *l, int *arg);
double minimum (data_list_t *l, int *arg);
data_list_t *average_of_lists (data_list_t **l);
/* file i/o */
int write_to_file (data_list_t *l, FILE *file);
data_list_t *read_from_file (data_list_t *l, FILE **file, int *error);










#include <stdio.h>
/* the different patterns */
enum{P2P, MASTER_WORKER, COLLECTIVE, SIMPLE, SEQMEAS};  /* patterns */
enum{NODES, LENGTH, CHUNK, NO_VARIATION};      /* variation */
enum{FIXED_LIN, FIXED_LOG, DYN_LIN, DYN_LOG};  /* x_scales */
enum{SKIP, TODO, DONE, FAILED};                
enum{MEASURE_MAX, MEASURE_MIN};                /* which_to_measure in 
						  p2p_pattern_data_t */
enum{ONE, ARRAY};                              /* for ms->kind_type_meas */
/* for entries in the work_array:
 SKIP: has been done in previous run / user do not want to measure
 TODO: has not been measured yet, but has to
 DONE: already measured in this (!) run 
 FAILED: this measurement has failed in previous run
*/

#ifndef SEQ
/* this structure describes one complete test 
 IN are parameters reached in, OUT are given back */

/*@1in../doc/p2p-ds.c*/
/* bundle of data reached in the p2p_pattern */
typedef struct
{
  /* Pointer to function measured by server */
  MPI_Status (* server_op) (int, int, MPI_Comm, MPI_Datatype); 
  
  /* Pointer to client function */
  MPI_Status (* client_op) (int, int, MPI_Comm, MPI_Datatype); 
  /* second int is just dummy, so that client_op has the same type as 
     server_op */

  int which_to_measure;  /* which node should be used for measurement ?
			    the one with the max. latencie or the one
			    with the min. */

  /* both _node variables are filled in the routine p2p_find_max_min
     of module p2p.c */
  int max_node;          /* number of the node with max. latencie */
  int min_node;          /* ... with min. latentcie */

  int len;               /* the actual message length IN */
  int def_nodes;         /* the number of nodes used for this measurement IN */
  MPI_Comm communicator; /* Communicator used for measurement IN */

  data_t *result;        /* Measured results OUT */

  double dummy_time;     /* dummy time for that communicator an pattern */
  double dummy_time_se;  /* and its standard error */
}p2p_pattern_data_t;
/*@1no*/

/*@1in../doc/mw-ds.c*/
/* bundle of data reached in the mw_pattern */
typedef struct
{
  void (* master_receive_ready) (int, int len, MPI_Comm, MPI_Datatype); 
  int  (* master_dispatch)      (int now, int work, int chunks, 
				 int len, MPI_Comm, MPI_Datatype); 
  void (* master_worker_stop)   (int worker, int len, MPI_Comm, MPI_Datatype); 
  int  (* worker_receive)       (int len, MPI_Comm, MPI_Datatype); 
  void (* worker_send)          (int len, MPI_Comm, MPI_Datatype); 

  MPI_Comm communicator; /* Communicator used for measurement IN */

  int len;               /* message length IN */
  int def_nodes;         /* the number of nodes used for this measurement IN */
  int chunks;            /* Number of work pieces IN */
  data_t *result;        /* Measured results  OUT */
  double dummy_time;     /* dummy time for that communicator and pattern IN */
  double dummy_time_se;  /* and its standard error IN */
}mw_pattern_data_t;
/*@1no*/

/*@1in../doc/col-ds.c*/
typedef struct
{
  /* preparations for the routine_to_measure, only at the server site. 
     this function is not measured */
  void (* init_routine_to_measure) (int len, MPI_Comm, MPI_Datatype, 
				    MPI_Datatype); 
							
  /* this function is measured */  
  void (* routine_to_measure) (int len, MPI_Comm, MPI_Datatype, MPI_Datatype);  

  /* preparations for the routine_to_measure on the client site. 
     this function is not measured */
  void (* init_client_routine) (int len, MPI_Comm, MPI_Datatype, MPI_Datatype);

  void (* client_routine) (int len, MPI_Comm, MPI_Datatype, MPI_Datatype);
  int len;               /* message length */
  int def_nodes;         /* the number of nodes used for this measurement IN */
  MPI_Comm communicator; /* Communicator used for measurement */

  data_t *result;        /* Measured results */
  double dummy_time;     /* dummy time for that communicator an pattern */
  double dummy_time_se;  /* and its standard error */
}col_pattern_data_t;
/*@1no*/
#endif /*SEQ*/

/*@1in../doc/simple-ds.c*/
typedef struct
{
  void (* routine_to_measure) (void); 
  data_t *result;        /* Measured results OUT */
  double dummy_time;     /* dummy time for that communicator an pattern IN */
  double dummy_time_se;  /* and its standard error IN */
}simple_pattern_data_t;
/*@1no*/

/*@1in../doc/seqmeas-ds.c*/
typedef struct
{
  /* preparations for the routine_to_measure. This function is not measured */
  void (* init_routine_to_measure) (int arg); 
  /* This function is measured */
  void (* routine_to_measure) (int arg); 
  int arg;               /* argument where to measure */
  data_t *result;        /* Measured results OUT */
  double dummy_time;     /* dummy time for that communicator an pattern IN */
  double dummy_time_se;  /* and its standard error IN */
}seqmeas_pattern_data_t;
/*@1no*/

/*@1in../doc/meas-ds-1.c*/
typedef struct
{
  char *name;    /* name of this measurement IN */
  int pattern;   /* which pattern should be applied IN */
#ifndef SEQ 
  MPI_Comm communicator;
  MPI_Datatype send_datatype; /* The type used for sending in 
				 measurements IN */
  MPI_Datatype recv_datatype; /* The type used for receiving in
				 measurements IN */
  char *send_datatype_name; /* The send type used for 
			       measurements as string IN */
  int send_datatype_size;   /* The size of the send type in bytes 
			       (please _never_ 0) 
			       IN */
  MPI_Aint send_datatype_extent;
  char *recv_datatype_name; /* The recv type used for measurements 
			       as string IN */
  int recv_datatype_size;   /* The size of the type in bytes 
			       (please _never_ 0) 
			       IN */
  MPI_Aint recv_datatype_extent;
  int basetype_number; /* The number of the basetype for sending and receiving
			       as in the parameter file IN */

  int send_datatype_number; /* The number of the datatype used for sending 
			       (relative the basetype) 
			       as in the parameter file IN */
  int recv_datatype_number; /* The number of the datatype used for  
			       receiving (relative the basetype) 
			       as in the parameter file IN */
  int send_kind_type_meas; /* Describes the kind of a measurement concerning
			 the datatype:
			 ONE: one datatype is constructed with
			 size = message length (e.g., vector) I.e., 
			 dynamic datatypes.
			 ARRAY: An array of 'small' datatypes is used for
			 measurements. Here the message-length is
			 the number of elements in such an array. 
			 The size of this array is message_length * 
			 size(datatype). 
			 I.e., fixed sized datatypes.
			 */
  int recv_kind_type_meas;
#endif /*SEQ*/
/*@1in../doc/meas-ds-2.c*/
  int variation;  /* NODES, LENGTH, CHUNK */
  int x_scale;    /* FIXED_LIN, FIXED_LOG, DYN_LIN, DYN_LOG */
  int x_start;  /* lowest argument, start of the variation */
  int x_end;    /* max. argument, never succeeded by variation */
  int x_start_bytes; /* above values in bytes */
  int x_end_bytes;
  double x_stepwidth; /* semantic:
		      FIXED_LIN: x stepwidth between to measurements 
		      all other x_scales: first stepwidth 
		      */
  int x_max_steps;
  int x_min_dist; /* semantic:
		      FIXED__: no meaning
		      DYN_LIN: smallest stepwidth 
		      DYN_LOG: smallest stepwidth of the first two steps
		      */
  int x_max_dist; /* semantic:
		      FIXED__: no meaning
		      DYN__: highest stepwidth */

  double
    time_suite,  /* max. allowed time for a suite of measurements in minutes IN */ 
    act_time_suite; /* actual used time for one suite in minutes OUT */


  int multiple_of; /* every argument is a mutliple of this value (or 0) IN */
/*@1in../doc/meas-ds-3.c*/
  int max_rep;   /* max. number of calls of measurements in a pattern IN */
  int min_rep;   /* min. number of calls of measurements in a pattern IN */

  int node_times;  /* true iff execution times per node should be stored
		      IN */

  double
    standard_error, /* the max. allowed standard error: used to determine
		       the end of measurements at one arg */		 
    /* time_meas can overides standard_error, in case that time_meas
       exceeded but the standarderror of the measurement has not been
       fallen below "standard_error" 

       time_suite can override x_max_steps and x_end, in case of time
       time_suite exceeded, and not all measurements have been done.
       */


    time_meas, /* max. allowed time for a measurement in minutes IN */ 
    cut_quantile; /* quantile to cut of the results of a
		     single measurements IN */ 

  /*@1in../doc/meas-ds-4.c*/
  data_list_t *result_list; /* list of results
			       OUT */

  /* default values */
  int nodes;

  /* routines for allocating and freeing ressources:
     memsize = the size in bytes (!) of the memory declared in params.memory 
     nor = number of repetitions (usually max_rep)
     nom = number of measurements (usually x_max_steps)
     now = number of processes ind this communicator */

  long (*server_init) (int nor, int nom, int nop);
  void (*server_free) (void);
#ifndef SEQ
  long (*client_init) (int nor, int nom, int nop);
  void (*client_free) (void);
#endif /*SEQ*/
  /*@1in../doc/meas-ds-5.c*/
  union          /* patternspecific data_structures IN */
  {
#ifndef SEQ
    p2p_pattern_data_t        p2p_data;
    mw_pattern_data_t         mw_data;
    col_pattern_data_t        col_data;
    simple_pattern_data_t     simple_data;
#else
    simple_pattern_data_t     simple_data;
    seqmeas_pattern_data_t    seqmeas_data;
#endif /*SEQ*/
  }data;
}measurement_t;
/* skalib_const.h

   user adjustable constants of the library skalib

   R. Reussner, 04.03.1999

   this file included by skampi_error.h

*/


#define MAX_PROCESSORS 1024 /* the maximun number of processors 
			       skampi can run on */

#ifndef SEQ
#define PARAMETER_FILE ".skampi" /* name of the parameter file */
#define FINISHED_MSG "skampi finished.\n"  /* last string in log and output file,
					    in case of success */
#define OUTFILE "skampi.out"  /* only as a default value */
#define LOGFILE "skampi.log"  /* only as a default value */
#else
#define PARAMETER_FILE ".skalib-ex" /* name of the parameter file */
#define FINISHED_MSG "skalib-ex finished.\n" /* last string in log and output file,
					      in case of success */
#define OUTFILE "skalib-ex.out" /* only as a default value */
#define LOGFILE "skalib-ex.log" /* only as a default value */

#endif /*SEQ*/

/* note that the name of teh logfile and the output file are usually
   set in the parameter file */

#define LINE_LEN (MAX_PROCESSORS*8+256)  /* max len. of lines in opened files,
					    should be equal to DL_LINE_LEN in 
					    datalist.h */
#define FN_LEN 0x100                 /* max len of filenames (incl path)  */

#define WISHED_RESOLUTION 1000000.0  /* the resolution wished in 
					1 / WISHED_RESOLUTION sec.
					here 1 microsec.
					should be a double */

#ifdef SEQ
#include <time.h>
#define MEASURE_TIME clock()
#else
#define MEASURE_TIME MPI_Wtime()
#endif /*SEQ*/

#define DEF_CHUNKS 6
#define DEF_MESSAGE_LEN 256
#define CACHE_WARMUP 0 /* number of single measurements to perform to warm
			  up the cache. Not measured 
			  We do not want to warm up the cache anymore.
			  We explicitely clear the cache since version 2.7 
			  */
#define CACHE_WARMUP_DEFAULT CACHE_WARMUP
/* default values used if corresponding entries in parameter file are not
   filled */
#define RUN_NAME_DEFAULT "StandardSuite"
#define MEM_DEFAULT 4096 /* 4 MB available assumed */
#define MAX_REP_DEFAULT 20 
#define MIN_REP_DEFAULT 4
#define MAX_STEPS_DEFAULT 16
#define STANDARD_ERROR_DEFAULT 0.05
#define TIME_MEAS_DEFAULT ((double)INVALID)
#define TIME_SUITE_DEFAULT ((double)INVALID)
#define CUT_QUANTILE_DEFAULT 0.25
#define MULTIPLE_OF_DEFAULT 4 
#define BLOCKS_DEFAULT 10
#define BLOCKSIZE_DEFAULT 7     /* must be >= 3 */
#define VECTORSTRIDE_DEFAULT 11 /* must be >= BLOCKSIZE_DEFAULT */

#define MAX_BASETYPE_SIZE 50 /* tha max. number of elements of a basetype */
#define MAX_BASETYPES 10 /* when changing this value look at 
			    the definition of _basetype_size,
			    and think about the different ranges of the 
			    number argument in create_datatype 
			    look at 
			    . params_t in skampi_params.h
			    . init_params in skampi_params.c
			    */

/* $Id: autodist.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* automatic x-axis adaption for skampi
   -header file-
   R. Reussner, 16.01.1997
   using priority queues

   last change:

*/

typedef data_t *(* tbm_t) (measurement_t *ms,int arg, data_t *data);

void
measure_suite (measurement_t *ms, tbm_t tbm);
/* $Id: automeasure.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* Automatic repetition of a single measurement
   -header-
   R. Reussner, 26.01.1997

*/

int  am_init        (int size);
#ifndef SEQ
int  am_control_end (measurement_t *ms, int arg, double time, 
		     int partner, double node_time, MPI_Comm communicator);
#else
int  am_control_end (measurement_t *ms, int arg, double time, 
		     int partner);
#endif /*SEQ*/
void am_fill_data   (measurement_t *ms, int arg, double dummy_time, 
		     double du_ti_se, data_t *data);
void am_free        (void);
/* $Id: skampi_tools.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* several tools for skampi
   -header-

   R. Reussner, 23.01.1997, 05.02.1997


*/
#define TEXT_LINES 0x1000          /* number of lines for parameters of
				     type text */
#define HEADER_LINES 8           /* number of lines in a meas. header 
				  (routines: read/write_header, 
				  measurement_data_to_string) */

typedef char *text_t[TEXT_LINES + 1];  /* NULL-terminated pointer-array */

void initialize_data(char *buf, long int length);

text_t *insert_in_text (char *line, text_t *text, int pos);
char   *read_from_text (char *line, text_t *text, int pos);
void   free_text        (text_t *text, int mode);
void   write_text_to_file (text_t *text, char *s,FILE **file);

FILE   *write_header (FILE *file, text_t *text, char *name);
FILE   *read_header  (FILE *file, text_t *text);

void   write_head_of_outfile (FILE **file, char *no_runs);


char *measurement_data_to_string (measurement_t *ms, char *string);
void measurement_data_to_gpl_command_file (measurement_t *ms);
void measurement_data_to_tex_module (measurement_t *ms);



int  *read_old_log_file (char *log_file_str, int *work_array,
			 measurement_t *ms, int number_of_measurements);

int  write_to_log_file (char *msg);
int  output_file_complete (FILE *file);
int  output_file_postprocessed (FILE *file);

char *new_name (char *name);
void create_log_file (void);
void create_output_file (int *new_run);
int number_of_output_files (char *name);
char *new_name (char *name);

double linear_interpolate (double arg_inter, double arg1, double arg2, 
			   double res1, double res2);

void init_skalib (measurement_t **measurements_array, 
		  int **work_array, int *number_of_measurements);
void perform_measurements (measurement_t *measurements_array, 
		  int *work_array, int *number_of_measurements);

double clock_resolution(void);








/* $Id: $ */
/* Routines to handle userdefined datatypes in SKaMPI -header file-
   Jesper Larsson Traeff, R. Reussner, 29.02.00
@MODULE: skampi_types
This module contains routines to construct the user defined bastype 
and several other user defined types, which depend on this basetype. The 
destruction of all user defined types is also provided.
The source code is provided in skampi_types.c. 
{
}
*/

/*@1indoctypes-constants.tex*/
#define SUBARRAYOFFSET 3
/*@1no*/
void create_basetype      (int number,char *s);
void free_basetype        (int number);
int  create_datatype      (int number, int bt_number, int len, 
			   MPI_Datatype *d, char **name, int *size, 
			   MPI_Aint *extent, int *is_one, int *is_col);
void free_datatype        (int number, MPI_Datatype *d);
void adjust_last_argument (int datatype_number, int bt_number,
			   MPI_Datatype d, long int *len);
int are_bt_same_size      (int bt1, int bt2);


/* $Id: skampi_params.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* parameterparser for skampi -header-
  
   R. Reussner, 04.01.1997

   for rsplit: level 1 documentation (-> ../doc/skampili.tex )
               default level for skosfile

*/
/* skampi_tools.h is need */
#define MAX_LINE_LEN 0x200        /* max. length of a line of the parameter
				     file */
/*@1in../doc/modes-enum.c*/				     
enum{NO_MODE, USER_MODE, MEM_MODE, STEPS_MODE, NETWORK_MODE, NODE_MODE, 
       MACHINE_MODE, COMMENT_MODE, OUTFILE_MODE, LOGFILE_MODE, MAX_REP_MODE,
       MIN_REP_MODE, STANDARD_ERROR_MODE,POST_MODE, MEASUREMENTS_MODE,
       ABSOLUTE_MODE, TIME_MEAS_MODE, TIME_SUITE_MODE, CUT_QUANTILE_MODE,
       MULTIPLE_OF_MODE, BT1_MODE, BT2_MODE, BT3_MODE, BT4_MODE, BT5_MODE, 
       BT6_MODE, BT7_MODE, BT8_MODE, BT9_MODE, BT10_MODE, BLOCKS_MODE,
       BLOCKSIZE_MODE, VECTORSTRIDE_MODE, CACHE_WARMUP_MODE, NAME_MODE
/*@1no*/
};
/*@inonesourcefile/params_source.c*/

/*@1in../doc/params-ds.c*/
typedef struct 
{
  text_t user;
  text_t out_file;
  text_t log_file;
  text_t machine;
  text_t network;
  text_t node;
  #ifndef SEQ
  text_t basetypes[MAX_BASETYPES];
  #endif
  unsigned memory;
  unsigned max_steps_default;
  unsigned max_rep_default;
  unsigned min_rep_default;
  unsigned multiple_of_default;
  double standard_error_default;
  double time_meas_default;
  double time_suite_default;
  double cut_quantile_default;
  int blocks;
  int blocksize;
  int vectorstride;
  int absolute;
  int post_proc;
  int cache_warmup;
  text_t comment;
  text_t measurements;
  text_t run_name;
/*@1no*/
}params_t;
measurement_t *read_parameters (char *parameter_file_name, 
				params_t *params, int *no_meas);

params_t *init_params    (params_t *params);
params_t *parse_parameter_file (FILE *parameter_file, params_t *params);





#define SKAMPI_VER 2.0   /* the actual version as a float */
#define SKAMPI_TAG 99 /* tags for messages of internal use of the benchmark */
#define MY_OVERHEAD 6  /* ibm sp2 laesst gruessen */
#define INVALID_ORG_TIME -1.0
#define STOP_SIGNAL -1.0

#define USE_COMMUNICATOR -1 /* for am_control_end in automeasure.c */
#define NO_COMMUNICATION -2 /* for am_control_end in automeasure.c */

#define MAX_ARGUMENT -1      /* indicates in measurement_t.x_end that x_end 
			       should be filled with the max number of nodes
			       / max message length during runtime */
#define DEFAULT -1           /* use the defualt value for this parameter
				(used for measurement.x_max/min_rep */

#define INVALID -2           /* do not regard the value of this parameter as
				valid */


#define MAX(a,b) (((a)<(b))?(b):(a))
#define MIN(a,b) (((a)>(b))?(b):(a))

#ifdef SEQ
#include <time.h>
#define SKALIB_CLOCKS_PER_SEC CLOCKS_PER_SEC
#else /*SEQ*/
#define SKALIB_CLOCKS_PER_SEC 1.0
#endif /*SEQ*/

#ifndef NULL
  #define NULL ((void *) 0)
#endif

#ifndef FALSE
  #define FALSE 0
#endif

#ifndef TRUE
  #define TRUE 1
#endif


/* error specific constants */
enum {NO_ERROR, USER, NO_MEM, FILE_OPEN, FILE_READ, FILE_WRITE, INTERN };

extern int skampi_error; /* texts for the errornummbers are stored in the
			    array error_text in the module skampi_err.c */

extern char *message; /* special errortext giving more exact information */

extern char *user_message; 
extern char pos_message[]; /* Position of  errorsymptom */

extern char eht[]; /* errorhelptext, only used as buffer, when creating the
		      error text. */


/* end == TRUE, then exit will be called! */
void output_error (int end);

/* As Makro, that  __LINE__ und __FILE__ are effektive */
#define ERROR(n,s) {sprintf(pos_message,"Line %d in Module %s.",__LINE__,__FILE__);skampi_error=(n);message=(s);}
/* $Id: skampi_mem.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* SKaMPI Special Karlsruher MPI-Benchmark
   -memory management-
   -header-

   R. Reussner, 07.02.1997

   last change:       
     . 03.03.98 changed all variables concerning the buffer 
       length from int to long int. 
       (due to problems on the alpha architecture) RR

*/


int allocate_mem (int memsize);
void free_mem (void);

long int mem_init_one_buffer (int nor, int nom, int nop);
long int mem_init_two_buffers (int nor, int nom, int nop);
long int mem_init_reduce_buffers (int nor, int nom, int nop);
long int mem_init_two_buffers_attach (int nor, int nom, int nop);
long int mem_init_two_buffers_attach_p2p (int nor, int nom, int nop);
long int mem_init_two_buffers_attach_mw (int nor, int nom, int nop);
long int mem_init_two_buffers_alltoall (int nor, int nom, int nop);
long int mem_init_two_buffers_gather (int nor, int nom, int nop);
long int mem_init_two_buffers_scatter (int nor, int nom, int nop);

void mem_release (void);
void mem_release_detach (void);

long int mem_init_mw_Waitsome (int nor, int nom, int nop);
long int mem_init_mw_Waitany (int nor, int nom, int nop);
long int mem_init_col_Waitall (int nor, int nom, int nop);







/* $Id: skampi_call.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* SKaMPI Special Karlsruher MPI-Benchmark
   calling routines: varying over length, number of nodes and chunks
   -header-

   R. Reussner, 05.02.1997

   last change:
*/

/* Prototypes */
int measure (measurement_t *ms); /* ms = measurement */
double min_time (void);

data_t *call_length (measurement_t *ms, int length, data_t *data);
#ifndef SEQ
data_t *call_nodes (measurement_t *ms, int nodes, data_t *data);
int create_communicator (MPI_Comm old_comm, int size, MPI_Comm *new_comm);
data_t *call_chunks (measurement_t *ms, int chunks, data_t *data);
#endif /*SEQ*/
data_t *call_simple (measurement_t *ms, data_t *data);
void fill_dummy_values (measurement_t *ms);
/* $Id: skampi_post.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* SKaMPI Special Karlsruher MPI-Benchmark
   -routines for postprocessing-
   -header-
   R. Reussner, 19.02.1997

   last change:
*/
int post_processing (char *input_file_name);

int combine_lists (data_list_t *result_list);
data_t *post_process (data_t *new_data, data_t *result_data);

/* $Id: any.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
#ifndef ANY
#define ANY
#include <stdio.h>

/* ============================== Debugging ================================ */
#define NDEBUGL 1

/* Level 0: always */
#if NDEBUGL >= 0
#define NDebug0(A) A
#else
#define NDebug0(A) 
#endif

/* Level 1: statistics and messages with minimal impact on speed */
#if NDEBUGL >= 1
#define NDebug1(A) A
#else
#define NDebug1(A) 
#endif

/* Level 2: Debugging and checks with tolerable volume of output */
#if NDEBUGL >= 2
#define NDebug2(A) A
#else
#define NDebug2(A) 
#endif

/* Level 3: Current focus */
#if NDEBUGL >= 3
#define NDebug3(A) A
#else
#define NDebug3(A) 
#endif

/* Level 4: Extreme detail */
#if NDEBUGL >= 4
#define NDebug4(A) A
#else
#define NDebug4(A) 
#endif

/* #define NFAILASSERT */
/* complain if condition is not true */
#ifdef NFAILASSERT
#define NAssert(c) if(!(c)){printf(\
   "\nAssertion violation %s:%u:" #c "\n", __FILE__, __LINE__); printf("%d", *(int*)0);}
#else
#define NAssert(c) if(!(c)){printf(\
   "\nAssertion violation %s:%u:" #c "\n", __FILE__, __LINE__);}
#endif


#define NAssert0(c) NDebug0(NAssert(c))
#define NAssert1(c) NDebug1(NAssert(c))
#define NAssert2(c) NDebug2(NAssert(c))
#define NAssert3(c) NDebug3(NAssert(c))
#define NAssert4(c) NDebug4(NAssert(c))


/* ============================== utility macros =========================== */

#define NAbs(x)    ((x) >= 0  ? (x) : -(x))

#define NMax(x, y) ((x) > (y) ? (x) :  (y))

#define NMin(x, y) ((x) > (y) ? (y) :  (x))

#define NRound(x)  (int)((x) + 0.5)

#endif

/* $Id: pqtypes.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */

#ifndef PQTYPES
#define PQTYPES
typedef double PqKey;
typedef list_item_t *PqData;
#define PQINFINITY      (0x7fffffff)
#define PQMINUSINFINITY (-PQINFINITY)
#define PQKEY MPI_INT
#endif
#ifndef PQ
#define PQ
/* sequential priority queue 
 * implemented using a D-Heap
 * Priority queue entris consist of a user defined arthmetic type 
 * PqKey which is linearly ordered by >
 * and a user defined type 
 * PqData
 * which must be a scalar or a struct without internal pointers
 */
typedef struct {
  PqKey  key;
  PqData data;
} PqItem;

/* ----------------- begin private --------------------------------- */

typedef struct {
   int length;
   int maxLength;
   PqItem item[1]; /* >^ actual length will be maxLength */
} Pq;

#if 0
static PqItem pqDummyItem;
#endif
/* ------------------ end private ---------------------------------- */

/* iniatlize a sequential Priority queue which is able to
 * accept up to maxLength items
 */
Pq *pqInit(int maxLength);

/* find minimum item */
#define pqMax(this) (this->item[0])
#define pqMaxKey(this)  (pqMax(this).key)
#define pqMaxData(this) (pqMax(this).data)

/* delete minimum item */
void pqDeleteMax(Pq *this);

/* insert item */
void pqInsert(Pq *this, PqItem item);
#define pqInsert2(this, k, d)                   \
(  pqDummyItem.key  = (k),                      \
   pqDummyItem.data = (d),                      \
   pqInsert((this), pqDummyItem)                \
)

/* how many items are in this Pq? */ 
#define pqLength(this) ((this)->length)
#define pqMaxLength(this) ((this)->maxlength)

void pqClose(Pq *this);

#endif
/* $Id: col.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* Collective-pattern -header -
   R. Reussner, 06.12.96

*/

/* Prototypes */
void col_pattern (measurement_t *ms);





/* $Id: mw.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* Master-Worker-pattern -header-
   R. Reussner, 06.12.1996


*/

/* Prototypes */
int mw_pattern (measurement_t *ms);









/* $Id: p2p.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* Ping-Pong-Pattern -header-
   DA
   R. Reussner, 24.11.96, 09.12.1996
   
   last change:
   03.12.96 cache warmups, 
   also testing message length 0
   
   */

int p2p_find_max_min (measurement_t *ms);
int p2p_pattern (measurement_t *ms);




/* $Id: simple.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* Simple-pattern -linkable version-
   R. Reussner, 04.12.96, 09.12.1996

   last change:
*/


/* Prototypes */
void simple_pattern (measurement_t *ms);

/* $Id: mw_test1.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* routines to be measured with the master_worker-pattern
   -header-
   R. Reussner, 06.12.1996

 
*/

/* Prototypes */
void mw_init_dummy (measurement_t *ms, data_t *data);
void mw_init_Waitsome (measurement_t *ms, data_t *data);
void mw_init_Waitany (measurement_t *ms, data_t *data);
void mw_init_Recv_AS (measurement_t *ms, data_t *data);
void mw_init_Send (measurement_t *ms, data_t *data);
void mw_init_Ssend (measurement_t *ms, data_t *data);
void mw_init_Isend (measurement_t *ms, data_t *data);
void mw_init_Bsend (measurement_t *ms, data_t *data);











/* $Id: col_test1.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* routines to measured wit the collective-pattern
   -header-
   
   R. Reussner, 06.12.1996

*/

void col_init_dummy           (measurement_t *ms, data_t *data);
void col_init_Bcast           (measurement_t *ms, data_t *data);
void col_init_Barrier         (measurement_t *ms, data_t *data);
void col_init_Reduce          (measurement_t *ms, data_t *data);
void col_init_Allreduce       (measurement_t *ms, data_t *data);
void col_init_Reduce_Bcast    (measurement_t *ms, data_t *data);
void col_init_Reduce_scatter  (measurement_t *ms, data_t *data);
void col_init_Reduce_Scatterv (measurement_t *ms, data_t *data);
void col_init_Alltoall        (measurement_t *ms, data_t *data);
void col_init_Alltoallv       (measurement_t *ms, data_t *data);
void col_init_Gather          (measurement_t *ms, data_t *data);
void col_init_Gather_Send_Recv(measurement_t *ms, data_t *data);
void col_init_Gather_Isend_Waitall(measurement_t *ms, data_t *data);
void col_init_Gatherv         (measurement_t *ms, data_t *data);
void col_init_Allgather       (measurement_t *ms, data_t *data);
void col_init_Allgatherv      (measurement_t *ms, data_t *data);
void col_init_Scatter         (measurement_t *ms, data_t *data);
void col_init_Scatterv        (measurement_t *ms, data_t *data);
void col_init_Scan            (measurement_t *ms, data_t *data);
void col_init_Comm_dup        (measurement_t *ms, data_t *data);
void col_init_Comm_split      (measurement_t *ms, data_t *data);
void col_init_memcpy          (measurement_t *ms, data_t *data);


/* $Id: p2p_test1.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* routines to be measured with the ping-pong-pattern
   
   R. Reussner, 09.12.1996

*/

void p2p_init_dummy            (measurement_t *ms, data_t *data);
void p2p_init_Send_Recv        (measurement_t *ms, data_t *data);
void p2p_init_Send_Irecv       (measurement_t *ms, data_t *data);
void p2p_init_Send_Iprobe_Recv (measurement_t *ms, data_t *data);
void p2p_init_Send_Recv_AT     (measurement_t *ms, data_t *data);
void p2p_init_Sendrecv         (measurement_t *ms, data_t *data);
void p2p_init_Sendrecv_replace (measurement_t *ms, data_t *data);
void p2p_init_Ssend_Recv       (measurement_t *ms, data_t *data);
void p2p_init_Bsend_Recv       (measurement_t *ms, data_t *data);
void p2p_init_Isend_Recv       (measurement_t *ms, data_t *data);
void p2p_init_Issend_Recv      (measurement_t *ms, data_t *data);











/* $Id: simple_test1.h,v 2.3 1999/07/23 10:13:02 skampi Rel skampi $ */
/* routines to be measured with the 
   simple-pattern
   -header-
   
   R. Reussner, 09.12.1996

*/


void simple_init_dummy (measurement_t *ms, data_t *data);
void simple_init_Wtime (measurement_t *ms, data_t *data);
void simple_init_2Wtime (measurement_t *ms, data_t *data);
void simple_init_Comm_size (measurement_t *ms, data_t *data);
void simple_init_Comm_rank (measurement_t *ms, data_t *data);
void simple_init_Iprobe (measurement_t *ms, data_t *data);
void simple_init_attach (measurement_t *ms, data_t *data);

/*
   @FUN:
   @DOES: initializes the data data with "zero data".
   @PARAMETERS: pointer to the data (can be NULL), and the size of 
   the node_times array (nodes).
   @RETURNES: the adress of the data, or
   NULL iff no memory available.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_t* init_data (data_t *data,int nodes)
{
  int
    was_null = FALSE;
#ifndef SEQ
  int
    i;
#endif /*SEQ*/
  D11(fprintf(stderr, "%d: in init_data -1, nodes %d\n",_skampi_myid, nodes);)
  if (data == NULL)
  {
    was_null = TRUE;
    if ((data = (data_t *) malloc (sizeof(data_t))) == NULL)
      return NULL;
  }
  D11(fprintf(stderr, "%d: in init_data -2\n",_skampi_myid);)
#ifndef SEQ
  if (nodes)
  {
    if ((data->node_times = (double *) malloc (sizeof(double) * nodes)) == NULL)
    {
      if (was_null)
	free (data);
      return NULL;
    }
  }
  else
    data->node_times = NULL;
  D11(fprintf(stderr, "%d: in init_data -3\n",_skampi_myid);)
  data->nodes = nodes;

  for (i = 0; i < nodes; i++)
    data->node_times[i] = 0.0;

  data->used_nodes = FALSE;
#endif /*SEQ*/
	 
  data->result_cleaned = data->result_all = data->standard_error_cleaned = 
    data->standard_error_all = 0.0;
  data->count_cleaned = data->count_all = data->arg = 0.0;
  data->arg_bytes = 0;

  return (data);
}

/*
   @FUN:
   @DOES: copies the source data sd to destination data dd 
   if the dd is NULL, it is also initialized. If sd is null, 
   nothing happens.
   If the sizes of the node_times arrays are not equal, 
   the array of sd will be freed and allocated again. 
   (All data in is lost, even if dd->nodes > sd->nodes.)
   @PARAMETERS: pointer to the sd and dd (can be NULL)
   @RETURNES: pointer to dd
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_t *copy_data (data_t *dd, data_t *sd)
{


#ifndef SEQ
  int 
    i;
#endif /*SEQ*/
  D11(fprintf(stderr, "%d: in copy_data -1\n",_skampi_myid);)
  if (sd == NULL)
    return (NULL);

#ifndef SEQ
  D11(fprintf(stderr, "%d: in copy_data -2\n",_skampi_myid);)
  if (dd == NULL)
  {
    if (init_data (dd,sd->nodes) == NULL)
      return (NULL);
  }
  D11(fprintf(stderr, "%d: in copy_data -3\n",_skampi_myid);)
  if (dd->node_times == NULL)
  {
    D11(fprintf(stderr, "%d: in copy_data -3a\n",_skampi_myid);)
    if (sd->nodes)
    {
      D11(fprintf(stderr, "%d: in copy_data -3aa\n",_skampi_myid);)
      if ((dd->node_times = (double *) malloc (sizeof(double) * sd->nodes)) 
	  == NULL)
	return NULL;
    }
    else
    {
      D11(fprintf(stderr, "%d: in copy_data -3ab\n",_skampi_myid);)
      dd->node_times = NULL;
    }
  }
  else
  {
    D11(fprintf(stderr, "%d: in copy_data -3b\n",_skampi_myid);)
    if (dd->nodes != sd->nodes)
    {
      D11(fprintf(stderr, "%d: in copy_data -3ba, ddnodes %d\n",
		  _skampi_myid, dd->nodes);)
      if (dd->nodes && dd->node_times)
	free (dd->node_times);
      D11(fprintf(stderr, "%d: in copy_data -3ba1\n",_skampi_myid);)
      if (sd->nodes)
      {
	D11(fprintf(stderr, "%d: in copy_data -3baa\n",_skampi_myid);)
	if ((dd->node_times = (double *) malloc (sizeof(double) * sd->nodes)) 
	    == NULL)
	  return NULL;
      }
      else
      {
	D11(fprintf(stderr, "%d: in copy_data -3bab\n",_skampi_myid);)
	dd->node_times = NULL;
      }
    }
  }
#endif /*SEQ*/

  D11(fprintf(stderr, "%d: in copy_data -4\n",_skampi_myid);)
  dd->result_cleaned = sd->result_cleaned;
  dd->standard_error_cleaned = sd->standard_error_cleaned;
  dd->count_cleaned = sd->count_cleaned;
  dd->result_all = sd->result_all;
  dd->standard_error_all = sd->standard_error_all;
  dd->count_all = sd->count_all;
  dd->arg = sd->arg;
  dd->arg_bytes = sd->arg_bytes;
#ifndef SEQ
  dd->nodes = sd->nodes;
  dd->used_nodes = sd->used_nodes;  
  
  D8(fprintf (stderr, "in copy_data %d: sd->nodes %d\n", 
	      _skampi_myid, sd->nodes);)
  D11(fprintf (stderr, "in copy_data %d: sd->nodes %d\n", 
	      _skampi_myid, sd->nodes);)
#else
  D8(fprintf (stderr, "in copy_data\n");)
#endif /*SEQ*/
#ifndef SEQ
  for (i = 0; i < sd->nodes; i++)
    dd->node_times[i] = sd->node_times[i];
#endif /*SEQ*/

  return (dd);
}

/*
   @FUN:
   @DOES: frees the data data.
   @PARAMETERS: pointer to the data (can be NULL), 
   mode: STATIC data has been declared statically, so do not free
   DYNAMIC: data has been allocated during runtime, so free
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void free_data (data_t *data, int mode)
{
  if (data !=NULL)
  {
#ifndef SEQ
    if (data->node_times !=NULL)
      free (data->node_times);
#endif /*SEQ*/
    if (mode == DYNAMIC)
      free (data);
  }
}










/* default values, overwritten in initialize_types (skampi_params.c) */
#define DEF_CHUNKS_VALUE 10
#define DEF_LEN_VALUE 0x100
#define DEF_NODES_VALUE 0
int 
  *_mw_index,
  *_worker_orders;

char 
  **_mw_buffer;

MPI_Status 
  *master_stati;

MPI_Request 
  *_mw_req;


int  master_init_Waitsome       (int mw_numprocs);
void master_free_Waitsome       (int mw_numprocs);
int  master_init_Waitany        (int mw_numprocs);
void master_free_Waitany        (int mw_numprocs);
int  master_init_attach         (int mw_numprocs);
void master_free_attach         (int mw_numprocs);
int  master_init_empty          (int mw_numprocs);
void master_free_empty          (int mw_numprocs);

void master_receive_ready_test  (int, int len, MPI_Comm, MPI_Datatype);
void master_receive_ready_empty (int, int len, MPI_Comm, MPI_Datatype);

int master_dispatch_dummy       (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);
int master_dispatch_Waitsome    (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);
int master_dispatch_Waitany     (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);
int master_dispatch_Recv_AS     (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);
int master_dispatch_Send        (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);
int master_dispatch_Ssend       (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);
int master_dispatch_Isend       (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);
int master_dispatch_Bsend       (int, int, int, int len, MPI_Comm, 
				 MPI_Datatype);

void master_worker_stop_wait    (int worker, int len, MPI_Comm, MPI_Datatype);
void master_worker_stop_recv    (int worker, int len, MPI_Comm, MPI_Datatype);
void master_worker_stop_test    (int worker, int len, MPI_Comm, MPI_Datatype);
void master_worker_stop_empty   (int worker, int len, MPI_Comm, MPI_Datatype);

int worker_receive_test         (int len, MPI_Comm comm, MPI_Datatype);

void worker_send_test           (int len, MPI_Comm communicator, MPI_Datatype);
void worker_send_empty          (int len, MPI_Comm communicator, MPI_Datatype);


/*
   @FUNS:
   @NAME: mw_init_...
   @DOES: initialize the measurement *ms (address for measrued results
   is data.)
   @PARAMETERS: above
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void 
mw_init_dummy (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_empty;
  ms->data.mw_data.master_dispatch = master_dispatch_dummy;

  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.mw_data.master_worker_stop = master_worker_stop_recv;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;
}

void 
mw_init_Waitsome (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_test; 
  /* not _Wait ? */
  ms->data.mw_data.master_dispatch = master_dispatch_Waitsome;

  ms->server_init = mem_init_mw_Waitsome;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.mw_data.master_worker_stop = master_worker_stop_wait;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;

}

void 
mw_init_Waitany (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_test;
  ms->data.mw_data.master_dispatch = master_dispatch_Waitany;

  ms->server_init = mem_init_mw_Waitany;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.mw_data.master_worker_stop = master_worker_stop_test;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;

}

void 
mw_init_Recv_AS (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_empty;
  ms->data.mw_data.master_dispatch = master_dispatch_Recv_AS;

  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.mw_data.master_worker_stop = master_worker_stop_recv;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;

}

void 
mw_init_Send (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_empty;
  ms->data.mw_data.master_dispatch = master_dispatch_Send;

  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.mw_data.master_worker_stop = master_worker_stop_recv;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;

}

void 
mw_init_Ssend (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_empty;
  ms->data.mw_data.master_dispatch = master_dispatch_Ssend;

  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.mw_data.master_worker_stop = master_worker_stop_recv;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;

}

void 
mw_init_Isend (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_empty;
  ms->data.mw_data.master_dispatch = master_dispatch_Isend;

  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.mw_data.master_worker_stop = master_worker_stop_recv;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;

}

void 
mw_init_Bsend (measurement_t *ms, data_t *data)
{
  ms->pattern = MASTER_WORKER;
  ms->data.mw_data.master_receive_ready = master_receive_ready_empty;
  ms->data.mw_data.master_dispatch = master_dispatch_Bsend;

  ms->server_init = mem_init_two_buffers_attach_mw;
  ms->server_free = mem_release_detach;
  ms->client_init = mem_init_two_buffers_attach_mw;
  ms->client_free = mem_release_detach;

  ms->data.mw_data.master_worker_stop = master_worker_stop_recv;
  ms->data.mw_data.worker_receive = worker_receive_test;
  ms->data.mw_data.worker_send = worker_send_test;
  ms->data.mw_data.communicator = MPI_COMM_WORLD;
  ms->data.mw_data.result = data;
  ms->data.mw_data.chunks = DEF_CHUNKS_VALUE;
  ms->data.mw_data.len = DEF_LEN_VALUE;
  ms->data.mw_data.def_nodes = DEF_NODES_VALUE;

}

/*
   @FUNS:
   @NAME master_...
   @DOES: call the MPI-Function to be measured. The reason not to call this
   MPI-Function directly is to achieve a function-header comman to all
   measured functions.
   @PARAMETERS: message length len, Communicator comminicator.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: the buffers set correctly, done with the routines called through
   ms->server_init /ms->client_init
   
*/
void 
master_receive_ready_test (int worker, int len, 
			   MPI_Comm communicator, MPI_Datatype data_type)
{  
  MPI_Irecv (_mw_buffer[worker - 1], 0, data_type, 
	     worker, MPI_ANY_TAG, 
	     communicator, _mw_req + worker - 1);
}

void 
master_worker_stop_wait (int worker, int len, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Wait (_mw_req + (worker - 1), 
	    master_stati + (worker - 1));
  MPI_Ssend (_skampi_buffer, 0, data_type, 
	     worker, 0, communicator);
}

void 
master_worker_stop_test (int worker, int len, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Ssend (_skampi_buffer, 0, data_type, 
	     worker, 0, communicator);
}


void 
master_worker_stop_recv (int worker, int len, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status
    status;
  MPI_Recv (_skampi_buffer, 0, data_type, 
	    worker, 1, communicator, &status);
  MPI_Ssend (_skampi_buffer, 0, data_type, 
	     worker, 0, communicator);
}


int 
worker_receive_test (int len, MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Recv (_skampi_buffer, len, data_type, 0, 
	    MPI_ANY_TAG, communicator, &status); 

  if (status.MPI_TAG == 0)  /* STOP working */
    return (FALSE);
  
  return (TRUE);
}

void 
worker_send_test (int len, MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Ssend (_skampi_buffer, 0, data_type, 
	     0, 1, communicator);
}

#if 0
int 
master_init_empty (int mw_numprocs)
{
  return (TRUE);
}


void 
master_free_empty (int mw_numprocs)
{
  return;
}
#endif
void 
master_receive_ready_empty (int worker, int len, 
			    MPI_Comm communicator, MPI_Datatype data_type)
{  
  return;
}

void 
master_worker_stop_empty (int worker, int len, 
			  MPI_Comm communicator, MPI_Datatype data_type)
{
  return;
}


void 
worker_send_empty (int len, MPI_Comm communicator, MPI_Datatype data_type)
{
  return;
}

int 
master_dispatch_dummy (int number_of_workers, int work, 
		       int chunks, int len, 
		       MPI_Comm communicator, MPI_Datatype data_type)
{
  return (1);
}


/* ---------------------- W a i t s o m e ----------------------- */
int 
master_dispatch_Waitsome (int number_of_workers, int work, 
			  int chunks,
			  int len, MPI_Comm communicator, 
			  MPI_Datatype data_type)
{
  int 
    i,
    worker,
    eingaenge;

  MPI_Waitsome (number_of_workers, _mw_req, &eingaenge, 
		_mw_index, master_stati);


  D1(fprintf (stderr, "master: eingaenge: %d at len %d\n", 
	      eingaenge, len);)

  
  for (i = 0; i < eingaenge; i++)
  {
    worker = _mw_index[i] + 1;

    /* posting new recv for this worker, because the old one has been used */
    MPI_Irecv (_mw_buffer[worker - 1], 0, data_type, 
	       worker, MPI_ANY_TAG, communicator, 
	       _mw_req + worker - 1);


    /* sending next chunk of work to this worker */
    MPI_Send (_skampi_buffer, len, data_type, 
	      worker, 1, communicator);

    D1(fprintf (stderr, "master: sending job_no %d to worker %d\n",\
	     work,worker);)
#if 0
    if (++work == chunks)
    {
      return (chunks);
    }
#endif
  }
  return (eingaenge);
}
#if 0
int 
master_init_Waitsome (int mw_numprocs)
{
  int 
    worker;
  
  /* size of array depends on number of processe started, so they are
     allocated dynamically */
  
  if (((_mw_index = (int *) malloc (sizeof(int) * 
		    (mw_numprocs - 1))) == NULL)
      || ((_mw_buffer = (char **) malloc (sizeof(char *) * 
			(mw_numprocs - 1))) == NULL)
      || ((_mw_req = (MPI_Request *) malloc (sizeof (MPI_Request) * 
		     (mw_numprocs - 1))) == NULL)
      || ((master_stati = (MPI_Status *) malloc (sizeof (MPI_Status) * 
			  (mw_numprocs - 1))) == NULL))
    
  {
    ERROR(NO_MEM,"mw_pattern");
    return (FALSE);
  }
  
  for (worker = 0; worker < mw_numprocs - 1; worker++)
    if ((_mw_buffer[worker] = 
	 (char *) malloc (max_msg_len)) == NULL)
    {
      ERROR(NO_MEM,"mw_pattern");
      return (FALSE);
    }


  return (TRUE);
}

void 
master_free_Waitsome (int mw_numprocs)
{
  int worker;

  free (_mw_index);
  free (_mw_req);
  free (master_stati);
  
  for (worker = 0; worker < mw_numprocs - 1; worker++)
    free (_mw_buffer[worker]);
  
  free (_mw_buffer);
}
#endif
/* ---------------------- W a i t a n y ----------------------- */

int 
master_dispatch_Waitany (int number_of_workers, 
			 int work, int chunks, int len, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  int 
    worker;

  MPI_Status
    status;

  MPI_Waitany (number_of_workers, _mw_req, 
	       &worker, &status);
  
  worker++;
    
  /* posting new recv for this worker, 
     because the old one has been used */
  MPI_Irecv (_mw_buffer[worker - 1], 0, data_type, worker, 
	     MPI_ANY_TAG, communicator, _mw_req + worker - 1);
  
  /* sending next chunk of work to this worker */
  MPI_Send (_skampi_buffer, len, data_type, 
	    worker, 1, communicator);

  D(fprintf (stderr, "master: sending job_no %d to worker %d\n",
	   work,worker);)
  
  return (1);
}
#if 0
int 
master_init_Waitany (int mw_numprocs)
{
  int 
    worker;
  /* size of array depends on number of processe 
     started, so they are allocated dynamically */
  
  if (((_mw_req = (MPI_Request *) malloc (sizeof (MPI_Request) * 
		  (mw_numprocs - 1))) == NULL)|| 
      ((_mw_buffer = (char **) malloc (sizeof(char *) * 
		     (mw_numprocs - 1))) == NULL))    
  {
    ERROR(NO_MEM,"mw_pattern");
    return (FALSE);
  }

  for (worker = 0; worker < mw_numprocs - 1; worker++)
    if ((_mw_buffer[worker] = 
	 (char *) malloc (max_msg_len)) == NULL)
    {
      ERROR(NO_MEM,"mw_pattern");
      return (FALSE);
    }

  return (TRUE);
}


void 
master_free_Waitany (int mw_numprocs)
{
  int worker;

  free (_mw_req);

  for (worker = 0; worker < mw_numprocs - 1; worker++)
    free (_mw_buffer[worker]);
  
  free (_mw_buffer);

}
#endif
/* --------------------------- Recv A n y S o ur c e ---------------- */
int 
master_dispatch_Recv_AS (int number_of_workers, 
			 int work, int chunks, int len, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  int 
    worker;

  MPI_Status
    status;

  MPI_Recv (_skampi_buffer, 0, data_type, MPI_ANY_SOURCE, 
	     MPI_ANY_TAG, communicator, &status);

  worker = status.MPI_SOURCE;

  /* sending next chunk of work to this worker */
  MPI_Send (_skampi_buffer, len, data_type, 
	    worker, 1, communicator);

  D(fprintf (stderr, "master: sending job_no %d to worker %d\n",
	   work,worker);)

  if (++work == chunks)
  {
    return (chunks);
  }
  
  return (1);
}

/* --------------------- Master sends: MPI_Send -------------------- */
int 
master_dispatch_Send (int number_of_workers, 
		      int work, int chunks, int len, 
		      MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status
    status;
  
  MPI_Recv (_skampi_buffer, len, data_type, (work % number_of_workers) + 1, 
	    1, communicator, &status);
  /* sending next chunk of work to this worker */
  MPI_Send (_skampi_buffer, len, data_type, (work % number_of_workers) + 1, 
	    1, communicator);

  D(fprintf (stderr, "master: sending job_no %d to worker %d\n",
	   work,(work % number_of_workers) + 1);)

  return (1);
}



/* --------------------- Master sends: MPI_Ssend -------------------- */
int 
master_dispatch_Ssend (int number_of_workers, 
		       int work, int chunks, int len, 
		       MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status
    status;
  
  MPI_Recv (_skampi_buffer, len, data_type, (work % number_of_workers) + 1, 
	    1, communicator, &status);
  /* sending next chunk of work to this worker */
  MPI_Ssend (_skampi_buffer, len, data_type, 
	     (work % number_of_workers) + 1, 
	    1, communicator);

  D(fprintf (stderr, "master: sending job_no %d to worker %d\n",
	   work,(work % number_of_workers) + 1);)

  return (1);
}
/* --------------------- Master sends: MPI_Isend -------------------- */
int 
master_dispatch_Isend (int number_of_workers, 
		       int work, int chunks, int len, 
		       MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Request
    req;

  MPI_Status
    status;
  
  MPI_Recv (_skampi_buffer, len, data_type, (work % number_of_workers) + 1, 
	    1, communicator, &status);
  /* sending next chunk of work to this worker */
  MPI_Isend (_skampi_buffer, len, data_type, 
	     (work % number_of_workers) + 1, 
	     1, communicator, &req);


  D(fprintf (stderr, "master: sending job_no %d to worker %d\n",
	   work,(work % number_of_workers) + 1);)

  return (1);
}

/* --------------------- Master sends: MPI_Bsend -------------------- */
int 
master_dispatch_Bsend (int number_of_workers, 
		       int work, int chunks, int len, 
		       MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status
    status;

  MPI_Recv (_skampi_buffer, len, data_type, (work % number_of_workers) + 1, 
	    1, communicator, &status);
  /* sending next chunk of work to this worker */
  MPI_Bsend (_skampi_buffer, len, data_type, 
	     (work % number_of_workers) + 1, 
	    1, communicator);

  D(fprintf (stderr, "master: sending job_no %d to worker %d\n",
	   work,(work % number_of_workers) + 1);)

  return (1);
}

#if 0
int 
master_init_attach (int mw_numprocs)
{
  int buflen =  max_msg_len * sizeof(char) 
    + MPI_BSEND_OVERHEAD + MY_OVERHEAD;
  MPI_Buffer_attach (_skampi_buffer, buflen);

  return (TRUE);
}

void 
master_free_attach (int mw_numprocs)
{
  int buflen =  max_msg_len * sizeof(char) 
    + MPI_BSEND_OVERHEAD + MY_OVERHEAD;
  MPI_Buffer_detach (_skampi_buffer, &buflen);
}
#endif








void measure_col_dummy       (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_broadcast       (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_barrier         (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Reduce          (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Allreduce       (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Reduce_Bcast    (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Reduce_scatter  (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Reduce_Scatterv (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Alltoall        (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Alltoallv       (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Gather          (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Gather_Send_client (int len, MPI_Comm communicator, MPI_Datatype, 
				 MPI_Datatype);
void measure_Gather_Recv_server (int len, MPI_Comm communicator, MPI_Datatype, 
				 MPI_Datatype);
void measure_Gather_Isend_client (int len, MPI_Comm communicator, 
				  MPI_Datatype, 
				  MPI_Datatype);
void measure_Gather_Waitall_server (int len, MPI_Comm communicator, 
				    MPI_Datatype, 
				    MPI_Datatype);
void measure_Gatherv         (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Scatter         (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Scatterv        (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Allgather       (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Allgatherv      (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Scan            (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Comm_dup        (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_Comm_split      (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);
void measure_memcpy          (int len, MPI_Comm communicator, MPI_Datatype, 
			      MPI_Datatype);

void init_measure_Reduce_scatter  (int len, MPI_Comm communicator, 
				   MPI_Datatype, 
				   MPI_Datatype);
void init_measure_Reduce_Scatterv  (int len, MPI_Comm communicator, 
				    MPI_Datatype, 
				    MPI_Datatype);
void init_measure_recvlens_displs (int len, MPI_Comm communicator, 
				   MPI_Datatype, 
				   MPI_Datatype);



/* global variables for this module */
static int displs[MAX_PROCESSORS], /* displacement array */
  recvlens[MAX_PROCESSORS];

MPI_Status 
  *_col_stati;

MPI_Request 
  *_col_req;


/*
   @FUNS:
   @NAME: col_init_...
   @DOES: the following col_init_... functions initialize the ms with
   the correct data to measure the specific collective MPI function.
   @PARAMETERS: measurement ms and the place to hold the measured 
   results (data).
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void 
col_init_dummy (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_col_dummy;
  ms->data.col_data.client_routine = measure_col_dummy;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Bcast (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_broadcast;
  ms->data.col_data.client_routine = measure_broadcast;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Barrier (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_barrier;
  ms->data.col_data.client_routine = measure_barrier;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Reduce (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_reduce_buffers;
  ms->server_free = mem_release;
  ms->client_init = mem_init_reduce_buffers;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Reduce;
  ms->data.col_data.client_routine = measure_Reduce;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Allreduce (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_reduce_buffers;
  ms->server_free = mem_release;
  ms->client_init = mem_init_reduce_buffers;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Allreduce;
  ms->data.col_data.client_routine = measure_Allreduce;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Reduce_Bcast (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_reduce_buffers;
  ms->server_free = mem_release;
  ms->client_init = mem_init_reduce_buffers;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Reduce_Bcast;
  ms->data.col_data.client_routine = measure_Reduce_Bcast;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Reduce_scatter (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_reduce_buffers;
  ms->server_free = mem_release;
  ms->client_init = mem_init_reduce_buffers;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = init_measure_Reduce_scatter;
  ms->data.col_data.init_client_routine = init_measure_Reduce_scatter;
  ms->data.col_data.routine_to_measure = measure_Reduce_scatter;
  ms->data.col_data.client_routine = measure_Reduce_scatter;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Reduce_Scatterv (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_reduce_buffers;
  ms->server_free = mem_release;
  ms->client_init = mem_init_reduce_buffers;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = init_measure_Reduce_Scatterv;
  ms->data.col_data.init_client_routine = init_measure_Reduce_Scatterv;
  ms->data.col_data.routine_to_measure = measure_Reduce_Scatterv;
  ms->data.col_data.client_routine = measure_Reduce_Scatterv;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Scan (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_reduce_buffers;
  ms->server_free = mem_release;
  ms->client_init = mem_init_reduce_buffers;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Scan;
  ms->data.col_data.client_routine = measure_Scan;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;  
  ms->data.col_data.result = data;
}

void 
col_init_Alltoall (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_alltoall;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_alltoall;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Alltoall;
  ms->data.col_data.client_routine = measure_Alltoall;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Alltoallv (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_alltoall;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_alltoall;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = init_measure_recvlens_displs;
  ms->data.col_data.init_client_routine = init_measure_recvlens_displs;
  ms->data.col_data.routine_to_measure = measure_Alltoallv;
  ms->data.col_data.client_routine = measure_Alltoallv;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Gather (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_gather;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_gather; /* probably better
						    mem_init_one_buffer */
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Gather;
  ms->data.col_data.client_routine = measure_Gather;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Gather_Send_Recv (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_gather;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_gather;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Gather_Recv_server;
  ms->data.col_data.client_routine = measure_Gather_Send_client;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Gather_Isend_Waitall (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_col_Waitall;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_gather; 
  /* mem_init_two_buffers_gather returns a slightly larger maximal
     message length compared to mem_init_col_Waitall (which returns
     the correct size). This does not matter since the message length
     of the server site is used. */
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Gather_Waitall_server;
  ms->data.col_data.client_routine = measure_Gather_Isend_client;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Gatherv (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_gather;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_gather; /* probably better
						    mem_init_one_buffer */
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = init_measure_recvlens_displs;
  ms->data.col_data.init_client_routine = init_measure_recvlens_displs;
  ms->data.col_data.routine_to_measure = measure_Gatherv;
  ms->data.col_data.client_routine = measure_Gatherv;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Allgather (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_gather;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_gather; 
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Allgather;
  ms->data.col_data.client_routine = measure_Allgather;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Allgatherv (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_gather;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_gather; 
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = init_measure_recvlens_displs;
  ms->data.col_data.init_client_routine = init_measure_recvlens_displs;
  ms->data.col_data.routine_to_measure = measure_Allgatherv;
  ms->data.col_data.client_routine = measure_Allgatherv;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Scatter (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_scatter;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_scatter;
 /* Note: we use the memory initalization of MPI_Gather. The pointers
    are used interchanged in measure_Scatter */
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Scatter;
  ms->data.col_data.client_routine = measure_Scatter;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Scatterv (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers_scatter;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers_scatter;
 /* Note: we use the memory initalization of MPI_Gather. The pointers
    are used interchanged in measure_Scatter */
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = init_measure_recvlens_displs;
  ms->data.col_data.init_client_routine = init_measure_recvlens_displs;
  ms->data.col_data.routine_to_measure = measure_Scatterv;
  ms->data.col_data.client_routine = measure_Scatterv;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}



void 
col_init_Comm_dup (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Comm_dup;
  ms->data.col_data.client_routine = measure_Comm_dup;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

void 
col_init_Comm_split (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_Comm_split;
  ms->data.col_data.client_routine = measure_Comm_split;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

/* ok, I know: memcpy tends to be seen not as beeing a real collective
   operation... . But it fits best in this pattern. (In simple there
   is no variation over a parameter.) */
void 
col_init_memcpy (measurement_t *ms, data_t *data)
{
  ms->pattern = COLLECTIVE;
  ms->server_init = mem_init_two_buffers;
  ms->server_free = mem_release;
  ms->client_init = mem_init_two_buffers;
  ms->client_free = mem_release;

  ms->data.col_data.init_routine_to_measure = NULL;
  ms->data.col_data.init_client_routine = NULL;
  ms->data.col_data.routine_to_measure = measure_memcpy;
  ms->data.col_data.client_routine = measure_col_dummy;
  ms->data.col_data.len = DEF_MESSAGE_LEN;
  ms->data.col_data.communicator = MPI_COMM_WORLD;
  ms->data.col_data.result = data;
}

/*
   @FUNS:
   @NAME: measure_...
   @DOES: call the MPI-Function to be measured. The reason not to call this
   MPI-Function directly is to achieve a function-header comman to all
   measured functions.
   @PARAMETERS: message length len, Communicator comminicator.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_buffer (_skampi_buffer_2 set correctly, done with
   mem_init_one_buffers or mem_init_two_buffers.
*/
void 
measure_col_dummy (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		   MPI_Datatype recv_datatype)
{
  /* just for dummy measurement */
  return;
}

void 
measure_broadcast (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		   MPI_Datatype recv_datatype)
{
  MPI_Bcast(_skampi_buffer, len, send_datatype, 0, communicator);
}

void 
measure_barrier (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		 MPI_Datatype recv_datatype)
{
  MPI_Barrier(communicator);
}

void 
measure_Reduce (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		MPI_Datatype recv_datatype)
{
  MPI_Reduce(_skampi_buffer, _skampi_buffer_2, len, send_datatype, 
	     _skampi_reduce_op, 0, communicator);
}


void 
measure_Allreduce (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		   MPI_Datatype recv_datatype)
{
  MPI_Allreduce(_skampi_buffer, _skampi_buffer_2, len, send_datatype, 
		_skampi_reduce_op, communicator);
}

void 
measure_Reduce_Bcast (int len, MPI_Comm communicator, MPI_Datatype send_datatype,
		      MPI_Datatype recv_datatype)
{
  MPI_Reduce(_skampi_buffer, _skampi_buffer_2, len, send_datatype, 
	     _skampi_reduce_op, 0, communicator);
  MPI_Bcast(_skampi_buffer, len, send_datatype, 0, communicator);  
}



void 
measure_Reduce_scatter (int len, MPI_Comm communicator, 
			MPI_Datatype send_datatype, MPI_Datatype recv_datatype)
{
  MPI_Reduce_scatter(_skampi_buffer, _skampi_buffer_2, recvlens, send_datatype, 
	     _skampi_reduce_op, communicator); 

}

void 
measure_Reduce_Scatterv (int len, MPI_Comm communicator, 
			 MPI_Datatype send_datatype, MPI_Datatype recv_datatype)
{
  MPI_Reduce(_skampi_buffer, _skampi_buffer_2, len, send_datatype, 
	     _skampi_reduce_op, 0, communicator);

  MPI_Scatterv (_skampi_buffer_2, recvlens, displs, send_datatype, 
		_skampi_buffer, len, send_datatype, 0, communicator);
  

  /* we use send_datatype twice in MPI_Scattev, sind in
     MPI_Reduce_scatter we also une a single datatype, and we usually
     want to compare their results recvlens are used here as send
     lengths */

}


void 
measure_Scan (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
	      MPI_Datatype recv_datatype)
{
  MPI_Scan (_skampi_buffer, _skampi_buffer_2, len, send_datatype, 
	    _skampi_reduce_op, communicator);
}

void 
measure_Alltoall (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		  MPI_Datatype recv_datatype)
{
  MPI_Alltoall (_skampi_buffer, len, send_datatype, 
		_skampi_buffer_2, len, recv_datatype, communicator);
}

void 
measure_Alltoallv (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		   MPI_Datatype recv_datatype)
{
  MPI_Alltoallv (_skampi_buffer, recvlens, displs, send_datatype, 
		 _skampi_buffer_2, recvlens, displs, recv_datatype, communicator);
  /* the first occurence of recvlens and displs should be read as
     sendlens and send displacements */

}

void 
measure_Gather (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		MPI_Datatype recv_datatype)
{
  MPI_Gather (_skampi_buffer, len, send_datatype, 
	      _skampi_buffer_2, len, recv_datatype, 0, communicator);

  /* in the above call the "0" is featuring as root  */
}

void 
measure_Gather_Recv_server (int len, MPI_Comm communicator, 
			    MPI_Datatype send_datatype, 
			    MPI_Datatype recv_datatype)
{
  int 
    i, 
    numprocs;
  
  MPI_Status
    status;

  D7(int myrank;)
  D7(MPI_Comm_rank(communicator, &myrank);)


  MPI_Comm_size(communicator,&numprocs);
  
  for (i = 1; i < numprocs; i++)
  {
    D7(fprintf(stderr,"proc %d: receiving from %d\n", myrank, i);)
    MPI_Recv (_skampi_buffer_2 + (i-1)*len, len, recv_datatype, 
	      i, 0, communicator, &status);
    D7(fprintf(stderr,"proc %d: received from %d\n", myrank, i);)
  }
  
}

void 
measure_Gather_Send_client (int len, MPI_Comm communicator, 
			    MPI_Datatype send_datatype, 
			    MPI_Datatype recv_datatype)
{
  D7(int myrank;)
  D7(MPI_Comm_rank(communicator, &myrank);)
  D7(fprintf(stderr,"proc %d: sending to root\n", myrank);)
  MPI_Send (_skampi_buffer, len, send_datatype, 
	    0, 0, communicator);
}

void 
measure_Gather_Waitall_server (int len, MPI_Comm communicator, 
			       MPI_Datatype send_datatype, 
			       MPI_Datatype recv_datatype)
{
  int 
    i, 
    numprocs;
  
  D7(int myrank;)
  D7(MPI_Comm_rank(communicator, &myrank);)

  MPI_Comm_size(communicator,&numprocs);
  
  for (i = 1; i < numprocs; i++)
  {
    D7(fprintf(stderr,"proc %d: receiving from %d\n", myrank, i);)
    MPI_Irecv (_skampi_buffer_2 + (i-1)*len, len, recv_datatype, 
	      i, 0, communicator, _col_req + (i - 1));
    D7(fprintf(stderr,"proc %d: received from %d\n", myrank, i);)
  }
  D7(fprintf(stderr,"proc %d: left loop, numprocs %d\n", myrank, numprocs);)
  MPI_Waitall (numprocs - 1, _col_req, _col_stati);
  
}

void 
measure_Gather_Isend_client (int len, MPI_Comm communicator, 
			     MPI_Datatype send_datatype, 
			     MPI_Datatype recv_datatype)
{
  MPI_Request
    req;

  D7(int myrank;)
  D7(MPI_Comm_rank(communicator, &myrank);)
  D7(fprintf(stderr,"proc %d: sending to root\n", myrank);)
  MPI_Isend (_skampi_buffer, len, send_datatype, 
	    0, 0, communicator, &req);

  /* We do not use a completion operation here, since the barrier sync
     after every col operation assures, that the wait all of the server
     is finished, when proceeded. */
}

void 
measure_Gatherv (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		 MPI_Datatype recv_datatype)
{
  MPI_Gatherv (_skampi_buffer, len, send_datatype, 
	       _skampi_buffer_2, recvlens, displs, recv_datatype, 0, 
	       communicator);

  /* in the above call the "0" is featuring as root  */
}


void 
measure_Allgather (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		   MPI_Datatype recv_datatype)
{
  MPI_Allgather (_skampi_buffer, len, send_datatype, 
		 _skampi_buffer_2, len, recv_datatype, communicator);
}

void 
measure_Allgatherv (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		    MPI_Datatype recv_datatype)
{
  MPI_Allgatherv (_skampi_buffer, len, send_datatype, 
		  _skampi_buffer_2, recvlens, displs, recv_datatype, 
		  communicator);
}


void 
measure_Scatter (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		 MPI_Datatype recv_datatype)
{
  MPI_Scatter (_skampi_buffer, len, send_datatype, 
	       _skampi_buffer_2, len, recv_datatype, 0, communicator);
}

void 
measure_Scatterv (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		  MPI_Datatype recv_datatype)
{
  MPI_Scatterv (_skampi_buffer, recvlens, displs, send_datatype, 
		_skampi_buffer_2, len, recv_datatype, 0, communicator);
}

void 
measure_Comm_dup (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		  MPI_Datatype recv_datatype)
{
  MPI_Comm new_comm;

  MPI_Comm_dup (communicator, &new_comm);
}

void 
measure_Comm_split (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		    MPI_Datatype recv_datatype)
{
  MPI_Comm new_comm;

  MPI_Comm_split (communicator, _skampi_myid % 2, 0, &new_comm);
}

void 
measure_memcpy (int len, MPI_Comm communicator, MPI_Datatype send_datatype, 
		MPI_Datatype recv_datatype)
{
  memcpy (_skampi_buffer, _skampi_buffer_2, len);
}


/* ------------ init_measure_... --------------- */

void 
init_measure_Reduce_scatter (int len, MPI_Comm communicator, 
			     MPI_Datatype send_datatype, 
			     MPI_Datatype recv_datatype)
{
  int i,
    nop;
  

  MPI_Comm_size (communicator, &nop);

  for (i = 0; i < nop;i++)
    recvlens[i] = (int) len / nop;

}

void 
init_measure_recvlens_displs (int len, MPI_Comm communicator, 
			      MPI_Datatype send_datatype, 
			      MPI_Datatype recv_datatype)
{
  int i,
    nop;
  

  MPI_Comm_size (communicator, &nop);

  for (i = 0; i < nop; i++)
  {
    recvlens[i] = (int) len;
    displs[i] = (int) i * len; 
  }
}

void 
init_measure_Reduce_Scatterv (int len, MPI_Comm communicator, 
			      MPI_Datatype send_datatype, 
			      MPI_Datatype recv_datatype)
{
  int i,
    nop;
  

  MPI_Comm_size (communicator, &nop);

  for (i = 0; i < nop; i++)
  {
    recvlens[i] = (int) len / nop;
    displs[i] = (int) i * (len / nop); 
  }
}

MPI_Status p2p_dummy             (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);

int init_empty  (int max_msg_len);
int init_attach (int max_msg_len);

void free_empty  (int max_msg_len);
void free_attach (int max_msg_len);

MPI_Status server_Send_Recv      (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Send_Iprobe_Recv (int msglen, int node, MPI_Comm com,
				  MPI_Datatype data_type);
MPI_Status server_Send_Irecv     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Send_Recv_AT   (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Isend_Recv     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Issend_Recv    (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Ssend_Recv     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Bsend_Recv     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Recv_Send      (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Iprobe_Recv_Send (int msglen, int node, MPI_Comm com,
				  MPI_Datatype data_type);
MPI_Status client_Irecv_Send     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Recv_AT_Send   (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Recv_Ssend     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Recv_Isend     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Recv_Issend    (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Recv_Bsend     (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);

MPI_Status server_Send           (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Isend          (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status server_Ssend          (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Recv           (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);

MPI_Status server_Sendrecv       (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);
MPI_Status client_Sendrecv       (int msglen, int node, MPI_Comm communicator,
				  MPI_Datatype data_type);

MPI_Status server_Sendrecv_replace (int msglen, int node, MPI_Comm com,
				  MPI_Datatype data_type);
MPI_Status client_Sendrecv_replace (int msglen, int node, MPI_Comm com,
				  MPI_Datatype data_type);

/*
   @FUNS:
   @NAME: p2p_init_...
   @DOES: the following p2p_init_... functions initialize the ms with
   the correct data, to measure the specific point-to-point MPI function.
   @PARAMETERS: measurement ms and the place to hold the measured 
   results (data).
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/

void 
p2p_init_dummy (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = p2p_dummy;
  ms->data.p2p_data.client_op = p2p_dummy;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Send_Recv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Send_Recv;
  ms->data.p2p_data.client_op = client_Recv_Send;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Send_Iprobe_Recv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Send_Iprobe_Recv;
  ms->data.p2p_data.client_op = client_Iprobe_Recv_Send;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Send_Irecv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Send_Irecv;
  ms->data.p2p_data.client_op = client_Irecv_Send;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}


void 
p2p_init_Send_Recv_AT (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Send_Recv_AT;
  ms->data.p2p_data.client_op = client_Recv_AT_Send;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}


void 
p2p_init_Ssend_Recv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Ssend_Recv;
  ms->data.p2p_data.client_op = client_Recv_Ssend;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Isend_Recv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Isend_Recv;
  ms->data.p2p_data.client_op = client_Recv_Isend;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Issend_Recv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Issend_Recv;
  ms->data.p2p_data.client_op = client_Recv_Issend;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Bsend_Recv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_two_buffers_attach_p2p;
  ms->client_init = mem_init_two_buffers_attach_p2p;
  ms->server_free = mem_release_detach;
  ms->client_free = mem_release_detach;
  ms->data.p2p_data.server_op = server_Bsend_Recv;
  ms->data.p2p_data.client_op = client_Recv_Bsend;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Sendrecv (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_two_buffers;
  ms->client_init = mem_init_two_buffers;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Sendrecv;
  ms->data.p2p_data.client_op = client_Sendrecv;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}

void 
p2p_init_Sendrecv_replace (measurement_t *ms, data_t *data)
{
  ms->pattern = P2P;
  ms->server_init = mem_init_one_buffer;
  ms->client_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_free = mem_release;
  ms->data.p2p_data.server_op = server_Sendrecv_replace;
  ms->data.p2p_data.client_op = client_Sendrecv_replace;
  ms->data.p2p_data.which_to_measure = MEASURE_MAX;
  ms->data.p2p_data.len = DEF_MESSAGE_LEN;
  ms->data.p2p_data.result = data;
  ms->data.p2p_data.communicator = MPI_COMM_WORLD;
}
#if 0
int 
init_empty (int max_msg_len)
{
  return (TRUE);
}

int 
init_attach (int msglen)
{
  int buflen =  msglen * sizeof(char) + 
    MPI_BSEND_OVERHEAD + MY_OVERHEAD;
  MPI_Buffer_attach (_skampi_buffer, buflen);

  return (TRUE);
}

void 
free_empty (int msglen)
{
  return;
}

void 
free_attach (int msglen)
{
  int buflen =  msglen * sizeof(char) + 
    MPI_BSEND_OVERHEAD + MY_OVERHEAD;
  MPI_Buffer_detach (_skampi_buffer, &buflen);
  return;
}
#endif

MPI_Status 
p2p_dummy (int msglen, int max_node, 
	   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  /* be dummy */
  return (status);
}

/*
   @FUNS:
   @NAME: server_...
   @DOES: call the MPI-Function to be measured by the 
   process 0 (sometimes named server). The reason not to call this
   MPI-Function directly is to achieve a function-header comman to all
   measured functions.
   @PARAMETERS: message length len, number of the node to communicate with,
   Communicator comminicator.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_buffer (_skampi_buffer_2 set correctly, done with
   mem_init_one_buffers or mem_init_two_buffers.
*/
MPI_Status 
server_Send_Recv(int msglen, int max_node, 
		 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Send (_skampi_buffer, msglen, data_type, 
	    max_node, 0, communicator);
  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    max_node, 1, communicator,
	    &status);

  return (status);
}

MPI_Status 
server_Send_Iprobe_Recv(int msglen, int max_node, 
			MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  int flag;

  MPI_Send (_skampi_buffer, msglen, data_type, 
	    max_node, 0, communicator);
  
  do {
    MPI_Iprobe (max_node, 1, communicator, 
		&flag, &status);
  }while (!flag);

  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    max_node, 1, communicator, &status);

  return (status);
}

MPI_Status 
server_Send_Irecv(int msglen, int max_node, 
		  MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  MPI_Request req;

  MPI_Send (_skampi_buffer, msglen, data_type, 
	    max_node, 0, communicator);
  MPI_Irecv (_skampi_buffer, msglen, data_type,
	     max_node, 1, communicator, &req);
  MPI_Wait (&req, &status);

  return (status);
}

MPI_Status 
server_Send_Recv_AT(int msglen, int max_node, 
		    MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Send (_skampi_buffer, msglen, data_type, 
	    max_node, 0, communicator);
  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    max_node, MPI_ANY_TAG, 
	    communicator, &status);

  return (status);
}

MPI_Status 
server_Bsend_Recv(int msglen, int max_node, 
		  MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Bsend (_skampi_buffer, msglen, data_type, 
	     max_node, 0, communicator);

  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    max_node, 1, communicator, &status);

  return (status);
}

MPI_Status 
server_Isend_Recv (int msglen, int max_node, 
		   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  MPI_Request req;

  MPI_Isend (_skampi_buffer, msglen, data_type, 
	     max_node, 0, communicator, &req);
  MPI_Wait (&req, &status);
  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    max_node, 1, communicator,&status);

  return (status);
}

MPI_Status 
server_Issend_Recv (int msglen, int max_node, 
		   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  MPI_Request req;

  MPI_Issend (_skampi_buffer, msglen, data_type, 
	     max_node, 0, communicator, &req);
  MPI_Wait (&req, &status);
  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    max_node, 1, communicator,&status);

  return (status);
}



/*
   @FUNS:
   @NAME: client_...
   @DOES: call the MPI-Function to be measured by the 
   processes not 0 (sometimes named clients). The reason not to call this
   MPI-Function directly is to achieve a function-header comman to all
   measured functions.
   @PARAMETERS: message length len, number of the node to communicate with,
   Communicator comminicator.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_buffer (_skampi_buffer_2 set correctly, done with
   mem_init_one_buffers or mem_init_two_buffers.
*/
MPI_Status 
client_Recv_Send (int msglen, int node, 
		  MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  
  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    0, 0, communicator, &status);
  
  MPI_Send (_skampi_buffer, msglen, data_type, 
	    0, 1, communicator);
  
  return (status);
}

MPI_Status 
client_Iprobe_Recv_Send (int msglen, int node, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  int flag;

  MPI_Iprobe (0, 0, communicator, &flag, &status);
  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    0, 0, communicator, &status);
  MPI_Send (_skampi_buffer, msglen, data_type, 
	    0, 1, communicator);
  
  return (status);
}

MPI_Status 
client_Irecv_Send (int msglen, int node, 
		   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  MPI_Request req;

  MPI_Irecv (_skampi_buffer, msglen, data_type, 
	     0, 0, communicator,
	    &req);
  MPI_Wait (&req, &status);

  MPI_Send (_skampi_buffer, msglen, data_type, 
	    0, 1, communicator);
  
  return (status);
}


MPI_Status 
client_Recv_AT_Send (int msglen, int node, 
		     MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    0, MPI_ANY_TAG, communicator, &status);
  MPI_Send (_skampi_buffer, msglen, data_type, 
	    0, 1, communicator);
  
  return (status);
}

MPI_Status 
client_Recv_Bsend (int msglen, int node, 
		   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    0, 0, communicator, &status);

  MPI_Bsend (_skampi_buffer, msglen, data_type, 
	     0, 1, communicator);
  
  return (status);
}


MPI_Status 
client_Recv_Isend (int msglen, int node, 
		   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  MPI_Request req;

  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    0, 0, communicator, &status);
  MPI_Isend (_skampi_buffer, msglen, data_type, 
	     0, 1, communicator, &req);
  MPI_Wait (&req, &status);
  
  return (status);
}

MPI_Status 
client_Recv_Issend (int msglen, int node, 
		   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  MPI_Request req;

  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    0, 0, communicator, &status);
  MPI_Issend (_skampi_buffer, msglen, data_type, 
	     0, 1, communicator, &req);
  MPI_Wait (&req, &status);
  
  return (status);
}

MPI_Status 
server_Ssend_Recv(int msglen, int max_node, 
		  MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Ssend (_skampi_buffer, msglen, data_type, 
	     max_node, 0, communicator);
  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    max_node, 1, communicator,
	    &status);

  return (status);
}

MPI_Status 
client_Recv_Ssend (int msglen, int node, 
		   MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Recv (_skampi_buffer, msglen, data_type, 0, 0, communicator,
	    &status);
  MPI_Ssend (_skampi_buffer, msglen, data_type, 0, 1, communicator);
  
  return (status);
}

MPI_Status 
server_Send(int msglen, int max_node, 
	    MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Send (_skampi_buffer, msglen, data_type, 
	    max_node, 0, communicator);

  return (status);
}

MPI_Status 
server_Isend(int msglen, int max_node, 
	     MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;
  MPI_Request req;

  MPI_Isend (_skampi_buffer, msglen, data_type, 
	     max_node, 0, communicator, &req);
  MPI_Wait (&req, &status);

  return (status);
}


MPI_Status 
server_Ssend (int msglen, int max_node, 
	      MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Ssend (_skampi_buffer, msglen, data_type, 
	     max_node, 0, communicator);

  return (status);
}

MPI_Status 
client_Recv (int msglen, int node, 
	     MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Recv (_skampi_buffer, msglen, data_type, 
	    0, 0, communicator, &status);
  
  return (status);
}

MPI_Status 
server_Sendrecv_replace (int msglen, int node, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Sendrecv_replace (_skampi_buffer, msglen, data_type, 
			node, 0, node, 1, communicator, &status);
  return (status);
}

MPI_Status 
client_Sendrecv_replace (int msglen, int node, 
			 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Sendrecv_replace (_skampi_buffer, msglen, data_type, 
			0, 1, 0, 0, communicator, &status);
  return (status);
}
MPI_Status 
server_Sendrecv (int msglen, int node, 
		 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Sendrecv (_skampi_buffer, msglen, data_type, node, 0, 
		_skampi_buffer_2, msglen, data_type, node, 1, 
		communicator, &status);
  return (status);
}

MPI_Status 
client_Sendrecv (int msglen, int node, 
		 MPI_Comm communicator, MPI_Datatype data_type)
{
  MPI_Status status;

  MPI_Sendrecv (_skampi_buffer, msglen, data_type, 0, 1, 
		_skampi_buffer_2, msglen, data_type, 0, 0, 
		communicator, &status);
  return (status);
}






void measure_dummy ();
void measure_Wtime ();
void measure_2Wtime ();
void measure_Comm_size ();
void measure_Comm_rank ();
void measure_Iprobe ();
void measure_attach ();
void measure_simple_test (void);

/*
   @FUNS:
   @NAME: simple_init_...
   @DOES: the following simple_init_... functions initialize the ms with
   the correct data, to measure the specific simple MPI function.
   @PARAMETERS: measurement ms and the place to hold the measured 
   results (data).
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/

void 
simple_init_dummy (measurement_t *ms, data_t *data)
{
  ms->pattern = SIMPLE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;
 
  ms->data.simple_data.routine_to_measure = measure_dummy;
  ms->data.simple_data.result = data;
}

void 
simple_init_Wtime (measurement_t *ms, data_t *data)
{
  ms->pattern = SIMPLE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;
  
  ms->data.simple_data.routine_to_measure = measure_Wtime;
  ms->data.simple_data.result = data;
}
void 
simple_init_2Wtime (measurement_t *ms, data_t *data)
{
  ms->pattern = SIMPLE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;
  
  ms->data.simple_data.routine_to_measure = measure_2Wtime;
  ms->data.simple_data.result = data;
}

void 
simple_init_Comm_size (measurement_t *ms, data_t *data)
{
  ms->pattern = SIMPLE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;
 
  ms->data.simple_data.routine_to_measure = measure_Comm_size;
  ms->data.simple_data.result = data;
}

void 
simple_init_Comm_rank (measurement_t *ms, data_t *data)
{
  ms->pattern = SIMPLE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;
 
  ms->data.simple_data.routine_to_measure = measure_Comm_rank;
  ms->data.simple_data.result = data;
}

void 
simple_init_Iprobe (measurement_t *ms, data_t *data)
{
  ms->pattern = SIMPLE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;
 
  ms->data.simple_data.routine_to_measure = measure_Iprobe;
  ms->data.simple_data.result = data;
}

void 
simple_init_attach (measurement_t *ms, data_t *data)
{
  ms->pattern = SIMPLE;
  ms->server_init = mem_init_one_buffer;
  ms->server_free = mem_release;
  ms->client_init = mem_init_one_buffer;
  ms->client_free = mem_release;
 
  ms->data.simple_data.routine_to_measure = measure_attach;
  ms->data.simple_data.result = data;
}

/*
   @FUNS:
   @NAME: measure_...
   @DOES: call the MPI-Function to be measured. The reason not to call this
   MPI-Function directly is to achieve a function-header comman to all
   measured functions.
   @PARAMETERS: message length len, Communicator comminicator.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: the routines pointed by ms->server_init ms->client_init
   are called.
*/
void 
measure_dummy ()
{
  return;
}

void 
measure_Wtime ()
{
  double _dummy;
  _dummy = MPI_Wtime();
}

void 
measure_2Wtime ()
{
  double _dummy;
  _dummy = MPI_Wtime();
  _dummy = MPI_Wtime();
}

void 
measure_Comm_size ()
{
  int _dummy;
  MPI_Comm_size (MPI_COMM_WORLD, &_dummy);
}

void 
measure_Comm_rank ()
{
  int _dummy;
  MPI_Comm_rank (MPI_COMM_WORLD, &_dummy);
}

void 
measure_Iprobe ()
{
  MPI_Status
    status;
  int 
    _dummy;

  MPI_Iprobe (1, 0, MPI_COMM_WORLD, &_dummy, &status);
}

void
measure_attach ()
{
  int buflen = MPI_BSEND_OVERHEAD + MY_OVERHEAD;

  MPI_Buffer_attach (_skampi_buffer, buflen);
  MPI_Buffer_detach (&_skampi_buffer, &buflen);
}
params_t 
  params;       /* the parameter block */

long int
  repetitions;


/* Prototypes */
int measure (measurement_t *ms); /* ms = measurement */
double min_time (void);
/*
   @FUN:
   @DOES: reads parameters, creates log_file, output_file, calls all
   selected measurements, logs measurements,
   calls postprocessing (if wanted).
   @PARAMETERS: standard command line (arc, argv)
   @RETURNES: 0 if success
   @SIDEEFFECTS: sets all global variables 
   @ASSUMES:nothing.
*/
int 
main(int argc, char **argv)
{
  /* characteristics of all measurements */
  measurement_t 
    *measurements_array = NULL;

  int
    number_of_measurements; /* to be filled in read_parameter_file */


  int 
    /* each entry of wark_array corresponds to a suite of measurements, 
       saying SKIP or TODO or DONE or FAILED */
    i,
    all_skip,
    *work_array = NULL;

  MPI_Init(&argc,&argv);      


  init_skalib (&measurements_array, &work_array, 
               &number_of_measurements);


    
  perform_measurements (measurements_array,  work_array, 
               &number_of_measurements);

  return (NO_ERROR);
}
/*
   @FUN:
   @DOES: initializes the data list l to the empty list.
   @PARAMETERS: pointer to the list l.
   @RETURNES: the adress of the list, or
   NULL iff no memory available.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_list_t *
init_list(data_list_t *l)
{
  if (l == NULL)
    if ((l = (data_list_t *) malloc (sizeof (data_list_t))) == NULL)
    {
#if 0
      *error = DL_NO_MEM;
#endif
      return (NULL);
    }

  l->list_start = l->list_end =l->list_last = NULL;
  l->number = 0;
  
  return (l);
}

/*
   @FUN:
   @DOES: adds data data element (*data) to the list *l at the position
   pos relative to start or list (mode == START), or end (mode == END), or
   to last accessed alement (mode == LAST).
   @PARAMETERS: (add. to above) *error, in which the error code is
   retuned.
   @RETURNES: pointer to list, or
   NULL in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/



data_list_t *
add (data_list_t *l, int mode, signed int pos, data_t *data, int *error)
{
  list_item_t
    *local_data = NULL,           /* stores new data */
    *local_ptr = NULL;            /* moving around in list */

  signed int i;

  if (l == NULL)           /* nothing allocated so far */
  {
    if ((l = (data_list_t *) malloc (sizeof (data_list_t))) == NULL)
    {
      *error = DL_NO_MEM;
      return (NULL);
    }
    init_list (l);
  }


  if ((local_data = (list_item_t *) malloc (sizeof (list_item_t))) == NULL)
  {
    *error = DL_NO_MEM;
    return (l);
  }

  if (init_data(&(local_data->data), numprocs) == NULL)
  {
    D8(fprintf (stderr, "in datalist: error init_data, numprocs %d\n", numprocs);)
    *error = DL_NO_MEM;
    return (l);
  }

  switch (mode)
  {
  case START:
    local_ptr = l->list_start;
    break;
  case LAST:
    local_ptr = l->list_last;
    break;
  case END:
    local_ptr = l->list_end;
    break;
  }


  /* findung right position in the list
     local_data is inserted BEHIND local_ptr,
     so local_ptr may be NULL (if local_ptr should be new start of list)
     but may NEVER exceed the list */
  if (pos >= 0)
  {
    for (i = 0; i < pos; i++)
      if (local_ptr->next == NULL)
	break;
      else
	local_ptr = local_ptr->next;
  }
  else
  {
    for (i = 0; i < (-1)*pos; i++)
      if ((local_ptr = local_ptr->prev) == NULL)
	break;
  }

  /* inserting new data */
  D8(fprintf (stderr, "datalist:add before copying data\n"\
	      "data->nodes %d, local_data->nodes %d", data->nodes, 
	      local_data->data.nodes);)
#ifdef DATABUGS

    local_data->data.node_times = NULL;
#endif
  if (copy_data (&(local_data->data), data) == NULL)
  {
    D8(fprintf (stderr, "datalist:error during copying data\n");)

    *error = DL_NO_MEM;
    return (l);
  }


  local_data->prev = local_ptr;
  local_data->next = NULL;
  D8(fprintf (stderr, "datalist:add after copying data\n");)
  if (local_ptr != NULL) /* not first element */
  {
    local_data->next = local_ptr->next;
    if (local_ptr->next != NULL)
      local_ptr->next->prev = local_data;

    local_ptr->next = local_data;
  }
  else
  {
    if (l->list_start != NULL)
      local_data->next = l->list_start->next;
    l->list_start = local_data;
  }


  /* updating descriptor information */
  l->number++;

  if ((mode == END) && (pos == 0))
    l->list_end = local_data;

  l->list_last = local_data;

  *error = DL_NO_ERROR;
  return (l);
}

/*
   @FUN:
   @DOES: reads data data element (*data) of the list *l at the position
   pos relative to start or list (mode == START), or end (mode == END), or
   to last accessed alement (mode == LAST).
   @PARAMETERS: (add. to above) *error, in which the error code is
   retuned.
   @RETURNES: pointer to list, or
   NULL in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_t *
read_ele (data_list_t *l, int mode, signed int pos,
	  data_t *data, int *error)
{
  list_item_t *local_ptr = NULL;
  signed int i;

  if (l == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }

  if (l->list_start == NULL || l->list_start == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }

  switch (mode)
  {
  case START:
    local_ptr = l->list_start;
    break;
  case LAST:
    local_ptr = l->list_last;
    break;
  case END:
    local_ptr = l->list_end;
    break;
  }


  /* findung right position in the list */
  if (pos >= 0)
  {
    for (i = 0; i < pos; i++)
      if (local_ptr->next == NULL)
	break;
      else
	local_ptr = local_ptr->next;
  }
  else
  {
    for (i = 0; i < (-1)*pos; i++)
      if (local_ptr->prev == NULL)
	break;
      else
	local_ptr = local_ptr->prev;
  }

  copy_data (data, &(local_ptr->data));

  l->list_last = local_ptr;

  return (data);
}

/*
   @FUN:
   @DOES: reads data data element (*data) of the list *l at the position
   pos relative to the element pointed to with local_ptr.
   @PARAMETERS: (add. to above) *error, in which the error code is
   retuned.
   @RETURNES: pointer to list, or
   NULL in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_t *
read_item_ele (data_list_t *l, list_item_t *local_ptr, signed int pos,
	       data_t *data, int *error)
{
  signed int i;

  if (l == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }

  if (l->list_start == NULL || l->list_start == NULL || local_ptr == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }
  D11(fprintf(stderr, "%d: in read_item_ele -1\n",_skampi_myid);)
  /* findung right position in the list */
  if (pos >= 0)
  {
    for (i = 0; i < pos; i++)
    {
      D11(fprintf(stderr, "%d: in read_item_ele -1a\n",_skampi_myid);)
      if (local_ptr->next == NULL)
	break;
      else
	local_ptr = local_ptr->next;
    }
  }
  else
  {
    for (i = 0; i < (-1)*pos; i++)
    {
      D11(fprintf(stderr, "%d: in read_item_ele -1b\n",_skampi_myid);)
      if (local_ptr->prev == NULL)
	break;
      else
	local_ptr = local_ptr->prev;
    }
  }
  D11(fprintf(stderr, "%d: in read_item_ele -2\n",_skampi_myid);)
  copy_data (data, &(local_ptr->data));
  D11(fprintf(stderr, "%d: in read_item_ele -3\n",_skampi_myid);)
  l->list_last = local_ptr;

  return (data);
}

/*
   @FUN:
   @DOES: returnes the adress of the data element of the list *l 
   at the position
   pos relative to start or list (mode == START), or end (mode == END), or
   to last accessed alement (mode == LAST).
   @PARAMETERS: (add. to above) *error, in which the error code is
   retuned.
   @RETURNES: pointer to list, or
   NULL in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
list_item_t *
item_addr (data_list_t *l, int mode, signed int pos, int *error)
{
  list_item_t *local_ptr = NULL;
  signed int i;

  if (l == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }

  if (l->list_start == NULL || l->list_start == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }

  switch (mode)
  {
  case START:
    local_ptr = l->list_start;
    break;
  case LAST:
    local_ptr = l->list_last;
    break;
  case END:
    local_ptr = l->list_end;
    break;
  }


  /* findung right position in the list */
  if (pos >= 0)
  {
    for (i = 0; i < pos; i++)
      if (local_ptr->next == NULL)
	break;
      else
	local_ptr = local_ptr->next;
  }
  else
  {
    for (i = 0; i < (-1)*pos; i++)
      if (local_ptr->prev == NULL)
	break;
      else
	local_ptr = local_ptr->prev;
  }

  l->list_last = local_ptr;

  return (local_ptr);
}

/*
   @FUN:
   @DOES: returnes the adress of the data element of the list *l 
   at the position
   pos relative to the element pointed to with local_ptr.
   @PARAMETERS: (add. to above) *error, in which the error code is
   retuned.
   @RETURNES: pointer to list, or
   NULL in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
list_item_t *
item_addr_at_item (data_list_t *l, list_item_t *local_ptr, signed int pos, 
		   int *error)
{
  signed int 
    i;

  if (l == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }

  if (l->list_start == NULL || l->list_start == NULL || local_ptr == NULL)
  {
    *error = DL_NO_MEM;
    return (NULL);
  }

  /* findung right position in the list */
  if (pos >= 0)
  {
    for (i = 0; i < pos; i++)
      if (local_ptr->next == NULL)
	break;
      else
	local_ptr = local_ptr->next;
  }
  else
  {
    for (i = 0; i < (-1)*pos; i++)
      if (local_ptr->prev == NULL)
	break;
      else
	local_ptr = local_ptr->prev;
  }

  return (local_ptr);
}

/*
   @FUN:
   @DOES: tests if *item is the last elemnt of its list
   @PARAMETERS: item of a list *item
   @RETURNES: TRUE iff last element
   @SIDEEFFECTS: none.
   @ASSUMES: item != NULL.
*/
int
is_end (list_item_t *item)
{
  return (item->next == NULL);
}

/*
   @FUN:
   @DOES: tests if *item is the first elemnt of its list
   @PARAMETERS: item of a list *item
   @RETURNES: TRUE iff first element
   @SIDEEFFECTS: none.
   @ASSUMES: item != NULL.
*/
int
is_start (list_item_t *item)
{
  return (item->prev == NULL);
}

/*
   @FUN:
   @DOES: returnes number of elements of the list *l.
   @PARAMETERS: above
   @RETURNES: above
   @SIDEEFFECTS: none
   @ASSUMES: nothing.
*/
int 
number_of_elements (data_list_t *l)
{
  if (l == NULL)
    return (0);
  else
    return (l->number);
}


/*
   @FUN:
   @DOES: removes data data element of the list *l at the position
   pos relative to start or list (mode == START), or end (mode == END), or
   to last accessed alement (mode == LAST).
   @PARAMETERS: above.
   @RETURNES: pointer to list, or
   NULL in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_list_t *
remove_ele (data_list_t *l, int mode, signed int pos)
{
  signed int i;
  list_item_t *local_ptr = NULL;

  if (l == NULL)
    return (NULL);

  if (l->list_start == NULL || l->list_start == NULL)
    return (NULL);

  switch (mode)
  {
  case START:
    local_ptr = l->list_start;
    break;
  case LAST:
    local_ptr = l->list_last;
    break;
  case END:
    local_ptr = l->list_end;
    break;
  }

  /* finding right position in the list */
  if (pos >= 0)
  {
    for (i = 0; i < pos; i++)
      if (local_ptr->next == NULL)
	break;
      else
	local_ptr = local_ptr->next;
  }
  else
  {
    for (i = 0; i < (-1)*pos; i++)
      if (local_ptr->prev == NULL)
	break;
      else
	local_ptr = local_ptr->prev;
  }

  if (local_ptr->next != NULL) /* if not last element */
    local_ptr->next->prev = local_ptr->prev;
  else /* so last ele */
  {
    if (local_ptr->prev != NULL)  /* if not first element */
      local_ptr->prev->next = NULL;
    l->list_end = local_ptr->prev;
  }

  if (local_ptr->prev != NULL)  /* if not first element */
    local_ptr->prev->next = local_ptr->next;
  else /* so first ele */
  {
    if (local_ptr->next != NULL) /* if not last element */
      local_ptr->next->prev = NULL;
    l->list_start = local_ptr->next;
  }

  free_data(&(local_ptr->data), STATIC);

  free (local_ptr);

  l->number--;

  return (l);
}
/*
   @FUN:
   @DOES: free-es all elements of the datalist *l and (only if 
   mode == DYNAMIC) also the memory pointed by l. If ths in not
   wanted (e.g. because l is adress of statically allocated variable)
   call with mode == STATIC.
   @PARAMETERS: above
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void 
free_data_list (data_list_t *l, int mode)
{
  if (l == NULL)
    return;

  if ((l->list_start == NULL) || (l->list_start == NULL))
    return;

  while ((l->list_start = l->list_start->next) != NULL)
  {
    free_data(&(l->list_start->prev->data), STATIC);
    free (l->list_start->prev);
  }

  /* freeing last element */
  free_data(&(l->list_end->data), STATIC);
  free (l->list_end);

  if (mode == DYNAMIC)
    free (l);
  else
    init_list (l);
}

/* ********* statistical routines **************** */


/*
   @FUN:
   @DOES: find the minimum of the list *l, returnes the argument, of the 
   minimal element (refers to cleaned).
   (needs the structure of the data stored in a list element)
   @PARAMETERS: above.
   @RETURNES: above.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
#define square(a) ((a)*(a))

double 
minimum (data_list_t *l, int *arg)
{
  list_item_t *local;
  double mini = -1.0;

  if (l != NULL)
  {
    if (l->list_start != NULL)
    {
      local = l->list_start;
      mini = local->data.result_cleaned;
      *arg = local->data.arg;
      while ((local = local->next) != NULL)
	if (local->data.result_cleaned < mini)
	{
	  mini = local->data.result_cleaned;
	  *arg = local->data.arg;
	}
    }
  }
  return (mini);
}

/*
   @FUN:
   @DOES: find the maximum of the list *l, returnes the argument, of the 
   maximal element (refers to cleaned).
   (needs the structure of the data stored in a list element)
   @PARAMETERS: above.
   @RETURNES: above.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
double 
maximum (data_list_t *l,int *arg)
{
  list_item_t *local;
  double maxi = -1.0; /* we assume only positive results !!! */

  if (l != NULL)
  {
    if (l->list_start != NULL)
    {
      local = l->list_start;
      maxi = local->data.result_cleaned;
      *arg = local->data.arg;
      while ((local = local->next) != NULL)
	if (local->data.result_cleaned > maxi)
	{
	  maxi = local->data.result_cleaned;
	  *arg = local->data.arg;
	}
    }
  }
  return (maxi);
}

/*
   @FUN:
   @DOES: returnes the variance of the list *l
   (needs the structure of the data stored in a list element)
   @PARAMETERS: above.
   @RETURNES: above.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
double 
variance (data_list_t *l)
{
  list_item_t *local;
  double sum=0.0,
    avg;

  if (l == NULL)
    return (-1.0);

  if (l->list_start == NULL)
    return (-1.0);

  avg = average (l);
  local = l->list_start;
  sum = square(local->data.result_cleaned - avg);
  while ((local = local->next) != NULL)
    sum += square(local->data.result_cleaned - avg);

  return (sum / (l->number - 1));
}

/*
   @FUN:
   @DOES: creates a new list, where the i-th data element it the
   average of all i-th elements of the datalists given in the 
   (NULL-terminated!) array of lists l.
   (needs the structure of the data stored in a list element)
   @PARAMETERS: above.
   @RETURNES: new list,
   NULL in case if error.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_list_t *
average_of_lists (data_list_t **l)
{
  data_list_t 
    *avg_list;

  double
    avg_cleaned = 0.0,
    avg_all = 0.0;

  int
    n = 0,
    i,
    j,
    list_error;

  data_t
    data;

  if ((avg_list = init_list (NULL)) == NULL)
    return (NULL);

  while (l[n] != NULL)
  {
    read_ele(l[n++], START, 0, &data, &list_error);
    avg_cleaned += data.result_cleaned;
    avg_all += data.result_all;
  }

  avg_cleaned /= n;
  avg_all /= n;

  data.result_cleaned = avg_cleaned;
  data.result_all = avg_all;

  append (avg_list, &data, &list_error);
  if (list_error != DL_NO_ERROR)
    return (NULL);

  for (i = 0; i < l[0]->number - 1; i++)
  {
    avg_cleaned = avg_all = 0.0;
    for (j = 0; j < n; j++)
    {
      read_ele(l[j], LAST, 1, &data, &list_error);
      avg_cleaned += data.result_cleaned;
      avg_all += data.result_all;
    }

    avg_cleaned /= n;
    avg_all /= n;

    data.result_cleaned = avg_cleaned;
    data.result_all = avg_all;

    append (avg_list, &data, &list_error);
    if (list_error != DL_NO_ERROR)
      return (NULL);

  }
  return (avg_list);
}


double 
median (data_list_t *l)
{ /* dummy */
  return (0.0);
}

/*
   @FUN:
   @DOES: returnes the average of the list *l. (refers to cleaned results)
   (needs the structure of the data stored in a list element)
   @PARAMETERS: above.
   @RETURNES: above.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
double 
average (data_list_t *l)
{
  list_item_t *local;
  double sum;

  if (l == NULL)
    return (-1.0);

  if (l->list_start == NULL)
    return (-1.0);

  local = l->list_start;
  sum = local->data.result_cleaned;
  while ((local = local->next) != NULL)
    sum += local->data.result_cleaned;
  
  return (sum / l->number);
}


/* ****************** file I/O ****************** */
/*
   @FUN:
   @DOES: writes data list *l to the file *file.
   @PARAMETERS: above
   @RETURNES: TRUE iff successful, FALSE otherwise
   @SIDEEFFECTS: none
   @ASSUMES: *file is valid handle of an open file.
*/
int 
write_to_file (data_list_t *l, FILE *file)
{
  list_item_t *local;

#ifndef SEQ
  int i;
#endif /*SEQ*/

  if (l == NULL)
    return (DL_NO_ELEM);

  /* note: the fprintf's format strings have to correspond to the 
     output printed in
     measurement_data_to_string in module skampi_tools.c */

  for (local = l->list_start; local != NULL; local = local->next)
  {
    fprintf (file,"%8ld %9.1f %8.1f %6d %9.1f %8.1f %6d",local->data.arg_bytes, 
	     local->data.result_cleaned,
	     local->data.standard_error_cleaned,
	     local->data.count_cleaned,
	     local->data.result_all,
	     local->data.standard_error_all,
	     local->data.count_all);
    /* output is written in microsec. */
    D(fprintf (stderr,"\nwft: nodes %d used_nodes %d\n",local->data.nodes,
	       local->data.used_nodes);)

#ifndef SEQ
    /* node times */
    if (local->data.nodes)
      if (local->data.used_nodes)
	for (i = 0; i < local->data.used_nodes; i++)
	  fprintf (file," %9.1f",local->data.node_times[i]);
#endif /*SEQ*/
    
    fprintf (file,"\n");

    D(printf ("%d %f\n",local->data.arg, local->data.result_cleaned);)
      
  }
  fprintf (file,"#eol\n");
  return (DL_NO_ERROR);
}

/*
   @FUN:
   @DOES: reads data list *l from the file **file.
   note: file is ** so that reading in file changes the filepointer,
   useful for reading consecutive lists in one file.
   @PARAMETERS: above
   @RETURNES: adress of the list read, NULL in case of error.
   @SIDEEFFECTS: none
   @ASSUMES: **file is valid handle of an open file.
*/
data_list_t * 
read_from_file (data_list_t *l, FILE **file, int *error)
{
  data_t 
    data;

  char 
    line[DL_LINE_LEN];
#ifndef SEQ
  char
    *node_times_str;
#endif /*SEQ*/

  double
#ifndef SEQ
    node_times[MAX_PROCESSORS],
#endif /*SEQ*/
    result_cleaned,
    standard_error_cleaned, 
    result_all, 
    standard_error_all;

  int 
    i,
    filled,                /* TRUE iff previous char in 
			      nodetimes_str has been != ' ' */
#ifndef SEQ
    no_node_times,         /* number of node times */
    last_entry,            /* last filled entry (node_time) in 
			      node_times_str */
#endif /*SEQ*/
    entries,               /* count number of columns to skip */
    arg_bytes,
    count_all,
    count_cleaned;

  if (l == NULL)           /* nothing allocated so far */
  {
    if ((l = (data_list_t *) malloc (sizeof (data_list_t))) == NULL)
    {
      *error = DL_NO_MEM;
      return (NULL);
    }
    init_list (l);
  }

  while (fgets (line, DL_LINE_LEN, *file) != NULL)  /* while not EOF */
  {
    D4(fprintf(stderr,"*** read_from_file *** line: %s\n",line);)
    if (strstr(line,"#eol"))  /* reached end of list */
      break;
    if (strstr (line,"#") == NULL && strlen (line) > 1)  
      /* if no comment line and has content */
    {
      sscanf (line,"%ld %lf %lf %d %lf %lf %d\n",&arg_bytes, &result_cleaned,
	      &standard_error_cleaned, &count_cleaned, 
	      &result_all, &standard_error_all, &count_all);


      /* skip the read entries */
      for (filled = FALSE, entries = i = 0; line[i] != 0; i++)
      {
#if 1
	if (line[i] == ' ')
	{
	  if (filled) /* do not count multiple blanks */
	    if (entries++ > 5)
	      break;
	  filled = FALSE;
	}
	else
	  filled = TRUE;
#else
	if (line[i] == ' ')
	  if (entries++ > 5)
	    break;
#endif
      }

#ifndef SEQ
      node_times_str = line + i;

      D4(fprintf(stderr,"*** read_from_file 1--*** line: %s\n",node_times_str);)
      for (filled = FALSE, last_entry = no_node_times = i = 0; 
	   node_times_str[i] != 0; i++)
      {
	if (node_times_str[i] == ' ')
	{
	  if (filled) /* do not count multiple blanks */
	  {
	    node_times_str[i] = 0;
	    node_times[no_node_times++] = atof (node_times_str + last_entry);
	    D4(fprintf(stderr,"*** read_from_file %d -2--*** line: %s\n",no_node_times, 
		       node_times_str+last_entry);)
	  }
	  filled = FALSE;
	  last_entry = i;
	}
	else
	  filled = TRUE;
      }

      /* insert last node_time if string was valid */
      if (node_times_str[0])
      {
	 node_times[no_node_times++] = atof (node_times_str + last_entry);
	 D4(fprintf(stderr,"*** read_from_file %d -3--*** line: %s\n",no_node_times, 
		    node_times_str+last_entry);)
      }

      init_data (&data, no_node_times);
#else /*SEQ*/
      init_data (&data, 0);
#endif /*SEQ*/

      data.arg = data.arg_bytes = arg_bytes;
      data.result_cleaned = result_cleaned;
      data.standard_error_cleaned = standard_error_cleaned;
      data.count_cleaned = count_cleaned;
      data.result_all = result_all;
      data.standard_error_all = standard_error_all;
      data.count_all = count_all;
#ifndef SEQ      
      for (i = 0; i < no_node_times; i++)
	data.node_times[i] = node_times[i];

      data.used_nodes = no_node_times;

      D4(fprintf(stderr,"*** read_from_file *** data: \n%f %d %d %f\n",
		 data.result_cleaned, data.arg, data.count_cleaned,
		 data.standard_error_cleaned);)
#endif /*SEQ*/

      append(l,&data,error);

      free_data(&data, STATIC);

      D4(fprintf(stderr,"** read_from_file after append**\n");)
      D4(write_to_file (l,stderr);)

    }
  }
  D4(fprintf(stderr,"*************** read_from_file ***************\n");)
  D4(write_to_file (l,stderr);)
    /* D4(*error = DL_NO_ERROR;) */
  return (l);
}


int skampi_error=NO_ERROR;

char *error_text[] =
{
  "no error",
  "user",
  "not enough free memory",
  "error opening file",
  "error reading file",
  "error writing file",
  "internal error"
};


char *message = "";
char *user_message = "";
char pos_message[0x100];
char eht[0x200];

/*
   @FUN:
   @DOES: prints error message (in skampi_error) to stderr and (only if 
   really_end == TRUE) aborts the running programm.
   @PARAMETERS:
   @RETURNES:
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void 
output_error (int really_end)
{

  fprintf (stderr,"\n%s\n\r %s\n\r %s\n\r %s\n\r"\
	  "The errorsymptom occured in\n\r %s\n\n\r", 
	   (really_end)?"Exiting program because of":"WARNING:",
	  error_text[skampi_error], message, user_message, pos_message);

  if (really_end)
  {
#ifndef SEQ
    MPI_Abort (MPI_COMM_WORLD,skampi_error);
#endif /*SEQ*/
    exit (skampi_error);       /* also closes files */
  }
}


/* #define WITH_NODES */  /* use user defined number of default nodes */


#define TEXT_APPEND   /* append same texts in params, not overwrite */

#define BSIZE 0x2000  /* size of lexem-buffer */
#define NONE -1
#define EOT  -2  /* end of text */
#define EOS  '\0'
#define DONE -3

/* tokenvalues */
#define INTEGER         256
#define FLOAT           257
#define STRING          258
#define TYPE            259
#define VARIATION       260
#define SCALE           261
#define MAX_REPETITION  262
#define MIN_REPETITION  263
/* #define NAME            264 */
#define START_ARGUMENT  265
#define END_ARGUMENT    266
#define STEPWIDTH       267
#define MAX_STEPS       268
#define MAX_DIST        269
#define MIN_DIST        270
#define STANDARD_ERROR  271
#define LENGTH_VAR      272
#define NODES_VAR       273
#define CHUNKS_VAR      274
#define NO_VAR          275
#define FIXED_LIN_SCALE 276
#define FIXED_LOG_SCALE 277
#define DYN_LIN_SCALE   278
#define DYN_LOG_SCALE   279
#define MAX_VALUE       280
#define DEFAULT_VALUE   281
#define DEFAULT_NODES   282
#define DEFAULT_CHUNKS  283
#define DEFAULT_MESSLEN 284
#define TIME_MEAS       285
#define TIME_SUITE      286
#define INVALID_VALUE   287
#define CUT_QUANTILE    288
#define MULTIPLE_OF     289
#define NODE_TIMES      290
#define YES             291
#define NO              292
#define SEND_DATATYPE   293
#define RECV_DATATYPE   294
#define BASETYPE        295


/* for symboltable */
#define STRMAX 0x2200        /* size of lexem-array */
#define SYMMAX 0x500         /* size of symboltable */

float tokenval;            /* value of symbol attribute */
int 
  pos = 0,
  lineno = 0;

/* type of symboltable */
struct entry
{
  char *lexptr;
  int token;
};

struct entry 
  symtable[SYMMAX]; /* symboltable */

/* symboltable */
int 
  lastchar = -1,   /* last used lexemposition */
  lastentry = 0;   /* last used symboltable entry */

/* lexer.c */
char 
  lexemes[STRMAX],
  lexbuf[BSIZE];

struct entry keywords[] =
{
  {"Type", TYPE},
  {"Variation", VARIATION},
  {"Scale", SCALE},
  {"Max_Repetition", MAX_REPETITION},
  {"Min_Repetition", MIN_REPETITION},
/*  {"Name", NAME}, */
  {"Start_Argument", START_ARGUMENT},
  {"End_Argument", END_ARGUMENT},
  {"Stepwidth", STEPWIDTH},
  {"Max_Steps", MAX_STEPS},
  {"Max_Distance", MAX_DIST},
  {"Min_Distance", MIN_DIST},
  {"Standard_error", STANDARD_ERROR},
  {"Length", LENGTH_VAR},
  {"Nodes", NODES_VAR},
  {"Chunks", CHUNKS_VAR},
  {"No_Variation", NO_VAR},
  {"Fixed_linear", FIXED_LIN_SCALE},
  {"Fixed_log", FIXED_LOG_SCALE},
  {"Dynamic_linear", DYN_LIN_SCALE},
  {"Dynamic_log", DYN_LOG_SCALE},
  {"Max_Value", MAX_VALUE},
  {"Default_Value", DEFAULT_VALUE},
  {"Default_Nodes", DEFAULT_NODES},
  {"Default_Chunks", DEFAULT_CHUNKS},
  {"Default_Message_length", DEFAULT_MESSLEN},
  {"Time_Measurement", TIME_MEAS},
  {"Time_Suite", TIME_SUITE},
  {"Invalid_Value", INVALID_VALUE},
  {"Cut_Quantile", CUT_QUANTILE},
  {"Multiple_of", MULTIPLE_OF},
  {"Node_Times", NODE_TIMES},
  {"yes", YES},
  {"no", NO},
  {"Yes", YES},
  {"No", NO},
  {"Send_Datatype_Number", SEND_DATATYPE},
  {"Receive_Datatype_Number", RECV_DATATYPE},
  {"Basetype_Number", BASETYPE},
  {NULL, 0}
};

int 
  lookahead;

/* eo global */

/* private */
char     *line_mode      (char *line, int *mode);
int      count_measurements (text_t *text);
void     send_text (text_t *text);
text_t   *recv_text (text_t *text);
int def_nodes,    /* used for the variables not varied over */
    def_chunks,
    def_len;


void set_basetypes (params_t *p);
int lexan(text_t *text); /* Scanner, pardon Entschluesseler */

char * token_to_str (int token);

/* interface to symboltable */
int insert (char *s, int tok);
int lookup (char *s);
void init_symboltable ();

/* interface scanner to text_t */
int read_next_char (text_t *text);
char *unread_next_char (int t, text_t *text);

/* parser */
void match (int t, text_t *text);

/* analyses entries of the @MEASUREMENTS-Section of the parameter-file */
/* grammar */
void parse           (measurement_t *ms, text_t *text);
void measurement     (measurement_t *ms, text_t *text);
void variation_style (measurement_t *ms, text_t *text);
void scale_style     (measurement_t *ms, text_t *text);
void int_or_max      (measurement_t *ms, text_t *text);
void int_or_default  (int *val, text_t *text);
void int_or_float    (double *val, text_t *text);
void yes_or_no       (int *val, text_t *text);
void float_or_default (double *val, text_t *text);
void float_or_default_or_invalid (double *val, text_t *text);

/* help */
void initialize_meas (measurement_t *ms, int index, int send_datatype, 
		      int recv_datatype, int basetype, text_t *text);


/*
   @FUN:
   @DOES: reads the parameter_file, fills params and returns 
   a filled measurements array, in *no_meas the number of
   measurements is given back 
   returnes NULL in case of error
   @PARAMETERS: name of parameter file, the params-struct which will be filled
   the number of measurements (*no_meas) (also filled here)
   @RETURNES: returnes to an array of *no_meas filled measurements in 
   case of success.
   @SIDEEFFECTS: in case of error it aborts the program.
   @ASSUMES: _skampi_myid set.
*/
measurement_t *
read_parameters (char *parameter_file_name, params_t *params, int *no_meas)
{
  FILE
    *parameter_file;

  measurement_t                  
    *ms;                  /* measurement array, later returned to caller */

  int
    i;                    /* for looping around */

  if (params == NULL)
  {
    ERROR(INTERN,"read_parameters called with *params == NULL");
    output_error (TRUE);
  }

#ifndef SEQ
  if (_skampi_myid == 0)
  {
#endif /*SEQ*/

    if ((parameter_file = fopen (parameter_file_name, "r")) == NULL)
    {
      sprintf (_skampi_msg,"opening parameter file %s.", parameter_file_name);
      ERROR (FILE_OPEN,_skampi_msg);
      output_error (TRUE);
    }
    
    init_params (params);
    
    if (parse_parameter_file (parameter_file, params) == NULL)
      output_error (TRUE);

#ifndef SEQ
    /* send params-struct */

    send_text (&(params->user));
    send_text (&(params->out_file));
    send_text (&(params->log_file));
    send_text (&(params->machine));
    send_text (&(params->network));
    send_text (&(params->node));
    #ifndef SEQ
    MPI_Bcast (&(params->blocks), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->blocksize), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->vectorstride), 1, MPI_INT, 0, 
	       default_communicator);
    for (i = 0; i < MAX_BASETYPES; i++)
      send_text (&(params->basetypes[i]));
    #endif
    MPI_Bcast (&(params->memory), 1, MPI_INT, 0, default_communicator);
    MPI_Bcast (&(params->max_steps_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->max_rep_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->min_rep_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->time_meas_default), 1, MPI_DOUBLE, 0, 
	       default_communicator);
    MPI_Bcast (&(params->time_suite_default), 1, MPI_DOUBLE, 0, 
	       default_communicator);
    MPI_Bcast (&(params->cut_quantile_default), 1, MPI_DOUBLE, 0, 
	       default_communicator);
    MPI_Bcast (&(params->multiple_of_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->post_proc), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->absolute), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->cache_warmup), 1, MPI_INT, 0, 
	       default_communicator);
    send_text (&(params->comment));
    send_text (&(params->measurements));
    send_text (&(params->run_name));
  }
  else /* so not proc. 0 */
  { /* receive params-struct */
    recv_text (&(params->user));
    recv_text (&(params->out_file));
    recv_text (&(params->log_file));
    recv_text (&(params->machine));
    recv_text (&(params->network));
    recv_text (&(params->node));
    #ifndef SEQ
    MPI_Bcast (&(params->blocks), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->blocksize), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->vectorstride), 1, MPI_INT, 0, 
	       default_communicator);
    for (i = 0; i < MAX_BASETYPES; i++)
      recv_text (&(params->basetypes[i]));
    #endif
    MPI_Bcast (&(params->memory), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->max_steps_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->max_rep_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->min_rep_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->time_meas_default), 1, MPI_DOUBLE, 0, 
	       default_communicator);
    MPI_Bcast (&(params->time_suite_default), 1, MPI_DOUBLE, 0, 
	       default_communicator);
    MPI_Bcast (&(params->cut_quantile_default), 1, MPI_DOUBLE, 0, 
	       default_communicator);
    MPI_Bcast (&(params->multiple_of_default), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->post_proc), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->absolute), 1, MPI_INT, 0, 
	       default_communicator);
    MPI_Bcast (&(params->cache_warmup), 1, MPI_INT, 0, 
	       default_communicator);
    recv_text (&(params->comment));
    recv_text (&(params->measurements));
    recv_text (&(params->run_name));
  }
#endif  /*SEQ*/

  if ((*no_meas = count_measurements (&(params->measurements))) == 0)
  {
    ERROR (NO_MEM,"no measurements defined.\n Possibly a typo of the word MEASUREMENTS in the configuration file.");
    output_error (TRUE);
  }

  if ((ms = malloc (*no_meas * sizeof (measurement_t))) == NULL)
  {
    ERROR (NO_MEM,"no memory for the measuremnts array.");
    output_error (TRUE);
  }

{
  D1(FILE
    *hua = stderr;
    write_text_to_file (&(params->measurements),"measurements",&hua);)
}
  #ifndef SEQ
  set_basetypes (params);
  #endif
  init_symboltable();
  parse (ms, &(params->measurements));

  for (i = 0; i < *no_meas; i++)
  {
    if (ms[i].max_rep == DEFAULT)
      ms[i].max_rep = params->max_rep_default;

    if (ms[i].min_rep == DEFAULT)
      ms[i].min_rep = params->min_rep_default;

    if (ms[i].x_max_steps == DEFAULT)
      ms[i].x_max_steps = params->max_steps_default;

    if (ms[i].standard_error == (double) DEFAULT)
      ms[i].standard_error = params->standard_error_default;

    if (ms[i].time_meas == (double) DEFAULT)
      ms[i].time_meas = params->time_meas_default;

    if (ms[i].time_suite == (double) DEFAULT)
      ms[i].time_suite = params->time_suite_default;

    if (ms[i].cut_quantile == (double) DEFAULT)
      ms[i].cut_quantile = params->cut_quantile_default;

    if (ms[i].multiple_of == (double) DEFAULT)
      ms[i].multiple_of = params->multiple_of_default;
#if 0
    ms[i].node_times = FALSE; /* as a default */ 
#endif
  }

  return (ms);
}

/*
   @FUN:
   @DOES: initializes the parameter struct with its default values,
   the definition of the constants can be found in skampi_error.h
   called by read_parameters.
   @PARAMETERS: the parameter array to be filled.
   @RETURNES:
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
/*@1in../doc/params-init.c*/				     
params_t *
init_params (params_t *params)
{
  int 
    i;
  params->user[0] = NULL;
  params->out_file[0] = OUTFILE;
  params->out_file[1] = NULL;
  params->log_file[0] = LOGFILE;
  params->log_file[1] = NULL;
  params->machine[0] = NULL;
  params->network[0] = NULL;
  params->node[0] = NULL;
  #ifndef SEQ
  for (i = 0; i < MAX_BASETYPES; i++)
    params->basetypes[i][0] = NULL; 
  #endif
  params->memory = MEM_DEFAULT;
  params->max_steps_default = MAX_STEPS_DEFAULT;
  params->max_rep_default = MAX_REP_DEFAULT;
  params->min_rep_default = MIN_REP_DEFAULT;
  params->standard_error_default = STANDARD_ERROR_DEFAULT;
  params->time_meas_default = TIME_MEAS_DEFAULT;
  params->time_suite_default = TIME_SUITE_DEFAULT;
  params->cut_quantile_default = CUT_QUANTILE_DEFAULT;
  params->multiple_of_default = MULTIPLE_OF_DEFAULT;
  params->absolute = FALSE; /* as default */
  params->post_proc = TRUE; /* as default */
  params->cache_warmup = CACHE_WARMUP_DEFAULT; 
#ifndef SEQ
  params->blocks = BLOCKS_DEFAULT;
  params->blocksize = BLOCKSIZE_DEFAULT;
  params->vectorstride = VECTORSTRIDE_DEFAULT;
#endif
  params->comment[0] = NULL;
  params->measurements[0] = NULL;  /* or all ? */
  params->run_name[0] = RUN_NAME_DEFAULT;
  params->run_name[1] = NULL;
  /*@1no*/
  return (params);
}

#ifndef SEQ
void
set_basetypes (params_t *params)
{
  MPI_Aint 
    displ_list[MAX_BASETYPE_SIZE];
  int 
    len_list[MAX_BASETYPE_SIZE],
    list_size,
    i;

  D13(fprintf(stderr, "in set_basetypes\n");)

  for (i = 0; i < MAX_BASETYPES; i++)
  {
    if (params->basetypes[i][0] != NULL)
    {
      D13(fprintf(stderr, "processing basetype[%d]\n",i);)
      D13(fprintf(stderr, "list_size %d\n", list_size);)
      create_basetype(i, params->basetypes[i][0]);
    }
  }
}


#endif

/*
   @FUN:
   @DOES: parses the parameter_file into the struct *params.
   @PARAMETERS: above
   @RETURNES: the filled params-struct or in case of error NULL.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
params_t *
parse_parameter_file (FILE *parameter_file, params_t *params)
{
  char 
    tmp_bool,           /* boolean for the yesno-sections */
    line[MAX_LINE_LEN],
    *corrected_line;
  
  int 
    mode = COMMENT_MODE,
    new_mode,
#ifdef TEXT_APPEND
    comment_line_counter = 0,
    measurements_line_counter = 0,
#endif
    line_counter = 0;
  
  if (parameter_file == NULL)
  {
    ERROR (FILE_READ,"parameter file not readable");
    output_error (TRUE);
  }

  if (params == NULL)
    if ((params = (params_t *) malloc (sizeof(params_t))) == NULL)
    {
      ERROR (NO_MEM,"parameter reading");
      output_error (TRUE);
    }

  while (fgets (line, MAX_LINE_LEN, parameter_file) != NULL)
  {
    corrected_line = line_mode(line, &new_mode);
    
    if (new_mode != NO_MODE)
    {
      mode = new_mode;
      line_counter = 0;
    }
    else
      line_counter++;

    if (line_counter >= TEXT_LINES)
    {
      sprintf (_skampi_msg,"too many lines for parameter mode %d: line"\
	       "skipped",mode);
      ERROR(USER,_skampi_msg);
      output_error (FALSE);
      continue;
    }
    
    switch (mode)
    {
    case COMMENT_MODE:
#ifdef TEXT_APPEND
      insert_in_text (corrected_line, &(params->comment), 
		      comment_line_counter++);
#else
      insert_in_text (corrected_line, &(params->comment), 
		      line_counter);
#endif
      break;
            
    case USER_MODE:
      insert_in_text (corrected_line, &(params->user), line_counter);
      break;

    case NAME_MODE:
      insert_in_text (corrected_line, &(params->run_name), line_counter);
      break;
      
    case MEM_MODE:
      params->memory = atoi (corrected_line);
      if (params->memory == 0)
      {
	params->memory = MEM_DEFAULT;
        sprintf (_skampi_msg,"error parsing memory size,\n"\
		 "memory size set to default value: %d KB.", MEM_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case STEPS_MODE:
      params->max_steps_default = atoi (corrected_line);
      if (params->max_steps_default == 0)
      {
	params->max_steps_default = MAX_STEPS_DEFAULT;
        sprintf (_skampi_msg,"error parsing max steps ,\n"\
		 "max steps set to default value: %d.", MAX_STEPS_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case MAX_REP_MODE:
      params->max_rep_default = atoi (corrected_line);
      if (params->max_rep_default == 0)
      {
	params->max_rep_default = MAX_REP_DEFAULT;
        sprintf (_skampi_msg,"error parsing max rep,\n"\
		 "max repetitions set to default value: %d.", 
		 MAX_REP_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case MIN_REP_MODE:
      params->min_rep_default = atoi (corrected_line);
      if (params->min_rep_default == 0)
      {
	params->min_rep_default = MIN_REP_DEFAULT;
        sprintf (_skampi_msg,"error parsing min steps,\n"\
		 "min steps set to default value: %d.", 
		 MIN_REP_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case STANDARD_ERROR_MODE:
      params->standard_error_default = atof (corrected_line);
      if (params->standard_error_default == 0.0)
      {
	params->standard_error_default = STANDARD_ERROR_DEFAULT;
        sprintf (_skampi_msg,"error parsing standard_error,\n"\
		 "standard_error set to default value: %f.", 
		 STANDARD_ERROR_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case TIME_MEAS_MODE:
      params->time_meas_default = atof (corrected_line);
      if (params->time_meas_default == 0.0)
      {
	params->time_meas_default = TIME_MEAS_DEFAULT;
        sprintf (_skampi_msg,"error parsing Time_Measurement,\n"\
		 "time_meas set to default value: %f.", 
		 TIME_MEAS_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case TIME_SUITE_MODE:
      params->time_suite_default = atof (corrected_line);
      if (params->time_suite_default == 0.0)
      {
	params->time_suite_default = TIME_SUITE_DEFAULT;
        sprintf (_skampi_msg,"error parsing Time_Suite,\n"\
		 "time_suite set to default value: %f.", 
		 TIME_SUITE_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case CUT_QUANTILE_MODE:
      params->cut_quantile_default = atof (corrected_line);
#if 0 /* commented out, because 0.0 is a valid value. But whats to do, if
	 atof failed ?? (RR) */
      if (params->cut_quantile_default == 0.0)
      {
	params->cut_quantile_default = CUT_QUANTILE_DEFAULT;
        sprintf (_skampi_msg,"error parsing Cut_Quantile,\n"\
		 "cut_quantile set to default value: %f.", 
		 CUT_QUANTILE_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
#endif
      break;

    case MULTIPLE_OF_MODE:
      params->multiple_of_default = atoi (corrected_line);
      if (params->multiple_of_default == 0)
      {
	params->multiple_of_default = MULTIPLE_OF_DEFAULT;
        sprintf (_skampi_msg,"error parsing multiple_of value,\n"\
		 "multiple_of value set to default value: %d.", 
		 MULTIPLE_OF_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

      
    case POST_MODE:
      if ((tmp_bool = (strstr (corrected_line,"no") == NULL)))
      {
	if (strstr (corrected_line,"yes") == NULL)
	{
	  sprintf (_skampi_msg, "error parsing parameter @POSTPROC:"\
			     "possible values only: \"yes\" or \"no\".\n"\
			     "set to default value %s.",
		   params->post_proc ? "yes":"no");
	  ERROR(USER,_skampi_msg);
	  output_error (FALSE);
	  /* so do not manipulate params->post_proc */
	}
      }
      params->post_proc = tmp_bool;
      
      break;

    case ABSOLUTE_MODE:
      if ((tmp_bool = (strstr (corrected_line,"no") == NULL)))
      {
	if (strstr (corrected_line,"yes") == NULL)
	{
	  sprintf (_skampi_msg,"error parsing parameter @ABSOLUTE:"\
			     "possible values only: \"yes\" or \"no\".\n"\
			     "set to default value %s.",
		   params->absolute ? "yes":"no");
	  ERROR(USER,_skampi_msg);
	  output_error (FALSE);
	  /* so do not manipulate params->absolute */
	}
      }
      params->absolute = tmp_bool;
      break;

    case BLOCKS_MODE:
      params->blocks = atoi (corrected_line);
      D14(fprintf(stderr,"in parse_parameter_file: BLOCKS_MODE blocks_str %s, blocks %d\n", corrected_line, params->blocks);)
      if (params->blocks == 0)
      {
	params->blocks = BLOCKS_DEFAULT;
        sprintf (_skampi_msg,"error parsing blocks,\n"\
		 "blocks set to default value: %d.", 
		 BLOCKS_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case BLOCKSIZE_MODE:
      params->blocksize = atoi (corrected_line);
      if (params->blocksize == 0)
      {
	params->blocksize = BLOCKSIZE_DEFAULT;
        sprintf (_skampi_msg,"error parsing blocksize,\n"\
		 "blocksize set to default value: %d.", 
		 BLOCKSIZE_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      if (params->blocksize < 3)
      {
	params->blocksize = BLOCKSIZE_DEFAULT;
        sprintf (_skampi_msg,"error: blocksize < 3,\n"\
		 "blocksize set to default value: %d.", 
		 BLOCKSIZE_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case VECTORSTRIDE_MODE:
      params->vectorstride = atoi (corrected_line);
      if (params->vectorstride == 0)
      {
	params->vectorstride = VECTORSTRIDE_DEFAULT;
        sprintf (_skampi_msg,"error parsing vectorstride,\n"\
		 "vectorstride set to default value: %d.", 
		 VECTORSTRIDE_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case CACHE_WARMUP_MODE:
      params->cache_warmup = atoi (corrected_line);
      if (params->cache_warmup <= 0)
      {
	params->cache_warmup = CACHE_WARMUP_DEFAULT;
        sprintf (_skampi_msg,"error parsing cache_warmup value,\n"\
		 "cache_warmup value set to default value: %d.", 
		 CACHE_WARMUP_DEFAULT);
	ERROR(USER,_skampi_msg);
	output_error (FALSE);
      }
      break;

    case NETWORK_MODE:
      insert_in_text (corrected_line, &(params->network), line_counter);
      break;
      
    case NODE_MODE:
      insert_in_text (corrected_line, &(params->node), line_counter);
      break;
      
    case MACHINE_MODE:
      insert_in_text (corrected_line, &(params->machine), line_counter);
      break;

    case OUTFILE_MODE:
      insert_in_text (corrected_line, &(params->out_file), line_counter);
      break;
      
    case LOGFILE_MODE:
      insert_in_text (corrected_line, &(params->log_file), line_counter);
      break;
    case BT1_MODE:
      insert_in_text (corrected_line, &(params->basetypes[0]), line_counter);
      break;
    case BT2_MODE:
      insert_in_text (corrected_line, &(params->basetypes[1]), line_counter);
      break;
    case BT3_MODE:
      insert_in_text (corrected_line, &(params->basetypes[2]), line_counter);
      break;
    case BT4_MODE:
      insert_in_text (corrected_line, &(params->basetypes[3]), line_counter);
      break;
    case BT5_MODE:
      insert_in_text (corrected_line, &(params->basetypes[4]), line_counter);
      break;
    case BT6_MODE:
      insert_in_text (corrected_line, &(params->basetypes[5]), line_counter);
      break;
    case BT7_MODE:
      insert_in_text (corrected_line, &(params->basetypes[6]), line_counter);
      break;
    case BT8_MODE:
      insert_in_text (corrected_line, &(params->basetypes[7]), line_counter);
      break;
    case BT9_MODE:
      insert_in_text (corrected_line, &(params->basetypes[8]), line_counter);
      break;
    case BT10_MODE:
      insert_in_text (corrected_line, &(params->basetypes[9]), line_counter);
      break;

      
    case MEASUREMENTS_MODE:
#ifdef TEXT_APPEND
      insert_in_text (corrected_line, &(params->measurements), 
		      measurements_line_counter++);
#else
      insert_in_text (corrected_line, &(params->measurements), 
		      line_counter);
#endif
      break;
      
    default:
      ERROR (USER,"invalid mode");
      return (NULL);
    }
  }
  if (params->vectorstride < params->blocksize)
  {
    params->vectorstride = params->blocksize + 1;
    sprintf (_skampi_msg,"error: vectorstride < blocksize,\n"\
	     "vectorstride set to default value: %d.", 
	     params->blocksize + 1);
    ERROR(USER,_skampi_msg);
    output_error (FALSE);
  }
  
  return (params);
}

/*
   @FUN:
   @DOES: analyzes *line and evtl. sets *mode to a new found mode.
   @PARAMETERS: above.
   @RETURNES: a pointer to the line (without the keyword).
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
char *
line_mode (char *line, int *mode)
{
  char *new_line;
  if ((new_line = strstr(line,"@USER")) != NULL)
  {
    *mode = USER_MODE;
    return (new_line + strlen ("@USER"));
  }else if ((new_line = strstr(line,"@MEMORY")) != NULL)
  {
    *mode = MEM_MODE;
    return (new_line + strlen ("@MEMORY"));
  }else if ((new_line = strstr(line,"@MAXREPDEFAULT")) != NULL)
  {
    *mode = MAX_REP_MODE;
    return (new_line + strlen ("@MAXREPDEFAULT"));
  }else if ((new_line = strstr(line,"@MINREPDEFAULT")) != NULL)
  {
    *mode = MIN_REP_MODE;
    return (new_line + strlen ("@MINREPDEFAULT"));
  }else if ((new_line = strstr(line,"@STANDARDERRORDEFAULT")) != NULL)
  {
    *mode = STANDARD_ERROR_MODE;
    return (new_line + strlen ("@STANDARDERRORDEFAULT"));
  }else if ((new_line = strstr(line,"@TIMEMEASDEFAULT")) != NULL)
  {
    *mode = TIME_MEAS_MODE;
    return (new_line + strlen ("@TIMEMEASDEFAULT"));
  }else if ((new_line = strstr(line,"@TIMESUITEDEFAULT")) != NULL)
  {
    *mode = TIME_SUITE_MODE;
    return (new_line + strlen ("@TIMESUITEDEFAULT"));
  }else if ((new_line = strstr(line,"@CUTQUANTILEDEFAULT")) != NULL)
  {
    *mode = CUT_QUANTILE_MODE;
    return (new_line + strlen ("@CUTQUANTILEDEFAULT"));
  }else if ((new_line = strstr(line,"@MULTIPLEOFDEFAULT")) != NULL)
  {
    *mode = MULTIPLE_OF_MODE;
    return (new_line + strlen ("@MULTIPLEOFDEFAULT"));
  }else if ((new_line = strstr(line,"@CACHEWARMUP")) != NULL)
  {
    *mode = CACHE_WARMUP_MODE;
    return (new_line + strlen ("@CACHEWARMUP"));
  }else if ((new_line = strstr(line,"@POSTPROC")) != NULL)
  {
    *mode = POST_MODE;
    return (new_line + strlen ("@POSTPROC"));
  }else if ((new_line = strstr(line,"@ABSOLUTE")) != NULL)
  {
    *mode = ABSOLUTE_MODE;
    return (new_line + strlen ("@ABSOLUTE"));
  }else if ((new_line = strstr(line,"@MAXSTEPSDEFAULT")) != NULL)
  {
    *mode = STEPS_MODE;
    return (new_line + strlen ("@MAXSTEPSDEFAULT"));
  }else if ((new_line = strstr(line,"@NUMBER_OF_BLOCKS")) != NULL)
  {
    *mode = BLOCKS_MODE;
    return (new_line + strlen ("@NUMBER_OF_BLOCKS"));
  }else if ((new_line = strstr(line,"@BLOCKSIZE")) != NULL)
  {
    *mode = BLOCKSIZE_MODE;
    return (new_line + strlen ("@BLOCKSIZE"));
  }else if ((new_line = strstr(line,"@VECTORSTRIDE")) != NULL)
  {
    *mode = VECTORSTRIDE_MODE;
    return (new_line + strlen ("@VECTORSTRIDE"));
  }else if ((new_line = strstr(line,"@NETWORK")) != NULL)
  {
    *mode = NETWORK_MODE;
    return (new_line + strlen ("@NETWORK"));
  }else if ((new_line = strstr(line,"@NODE")) != NULL)
  {
    *mode = NODE_MODE;
    return (new_line + strlen ("@NODE"));
  }else if ((new_line = strstr(line,"@MACHINE")) != NULL)
  {
    *mode = MACHINE_MODE;
    return (new_line + strlen ("@MACHINE"));
  }else if ((new_line = strstr(line,"@COMMENT")) != NULL)
  {
    *mode = COMMENT_MODE;
    return (new_line + strlen ("@COMMENT"));
  }if ((new_line = strstr(line,"@NAMEOFRUN")) != NULL)
  {
    *mode = NAME_MODE;
    return (new_line + strlen ("@NAMEOFRUN"));
  }else if ((new_line = strstr(line,"@OUTFILE")) != NULL)
  {
    *mode = OUTFILE_MODE;
    return (new_line + strlen ("@OUTFILE "));
  }else if ((new_line = strstr(line,"@LOGFILE")) != NULL)
  {
    *mode = LOGFILE_MODE;
    return (new_line + strlen ("@LOGFILE "));
  }else if ((new_line = strstr(line,"@BASETYPE1")) != NULL)
  {
    *mode = BT1_MODE;
    return (new_line + strlen ("@BASETYPE1 "));
  }else if ((new_line = strstr(line,"@BASETYPE2")) != NULL)
  {
    *mode = BT2_MODE;
    return (new_line + strlen ("@BASETYPE2 "));
  }else if ((new_line = strstr(line,"@BASETYPE3")) != NULL)
  {
    *mode = BT3_MODE;
    return (new_line + strlen ("@BASETYPE3 "));
  }else if ((new_line = strstr(line,"@BASETYPE4")) != NULL)
  {
    *mode = BT4_MODE;
    return (new_line + strlen ("@BASETYPE4 "));
  }else if ((new_line = strstr(line,"@BASETYPE5")) != NULL)
  {
    *mode = BT5_MODE;
    return (new_line + strlen ("@BASETYPE5 "));
  }else if ((new_line = strstr(line,"@BASETYPE6")) != NULL)
  {
    *mode = BT6_MODE;
    return (new_line + strlen ("@BASETYPE6 "));
  }else if ((new_line = strstr(line,"@BASETYPE7")) != NULL)
  {
    *mode = BT7_MODE;
    return (new_line + strlen ("@BASETYPE7 "));
  }else if ((new_line = strstr(line,"@BASETYPE8")) != NULL)
  {
    *mode = BT8_MODE;
    return (new_line + strlen ("@BASETYPE8 "));
  }else if ((new_line = strstr(line,"@BASETYPE9")) != NULL)
  {
    *mode = BT9_MODE;
    return (new_line + strlen ("@BASETYPE9 "));
  }else if ((new_line = strstr(line,"@BASETYPE10")) != NULL)
  {
    *mode = BT10_MODE;
    return (new_line + strlen ("@BASETYPE10 "));
  }else if ((new_line = strstr(line,"@MEASUREMENTS")) != NULL)
  {
    *mode = MEASUREMENTS_MODE;
    return (new_line + strlen ("@MEASUREMENTS"));
  }else
  {
    *mode = NO_MODE;
    return (line);
  }
}


/*
   @FUN:
   @DOES: counts the number of measurements stored in text (uses that
   each measurement has one opening bracket \{ exactly). 
   @PARAMETERS:
   @RETURNES:
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int
count_measurements (text_t *text)  
{
  int
    i,
    counter;

  for (counter = i = 0; (*text)[i] != NULL; i++)
    if (strstr ((*text)[i], "{") != NULL)
      counter++;

  return (counter);
} /* }}  just for the script funlen.pl, which is confused seeing only opening 
     brackets 
     */
#ifndef SEQ


/*
   @FUN:
   @DOES: sends a text to all other processes in default_communicator,
   process zero is root.
   @PARAMETERS: the text to send.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: default_communicator set.
*/
void
send_text (text_t *text)
{
  int 
    i,
    len;

  for (i = 0; (*text)[i] != NULL; i++)
  {
    len = strlen ((*text)[i]) + 1;

    MPI_Bcast (&len, 1, MPI_INT, 0, default_communicator);
    MPI_Bcast ((*text)[i], len, MPI_CHAR, 0, default_communicator);    
  }
  len = STOP_SIGNAL;

  MPI_Bcast (&len, 1, MPI_INT, 0, default_communicator);
}

/*
   @FUN:
   @DOES: receives the text which has been send via send_text.
   (process zero in default communicator is root.)
   Note: the text_t-struct has to be allocated, not the memory for
   all the strings, this is done here.
   @PARAMETERS: above.
   @RETURNES: a pointer to the filled text structure.
   @SIDEEFFECTS: none.
   @ASSUMES: default_communicator set.
*/
text_t *
recv_text (text_t *text)
{
  int 
    i,
    len;

  if (text == NULL)
    if ((text = malloc (sizeof (text))) == NULL)
    {
      ERROR(NO_MEM,"for parameters - 1");
      output_error (TRUE);
    }

  i = 0;
  MPI_Bcast (&len, 1, MPI_INT, 0, default_communicator);
  while (len != STOP_SIGNAL)
  {
    if (((*text)[i] = malloc (len)) == NULL)
    {
      ERROR(NO_MEM,"for parameters - 1");
      output_error (TRUE);
    }
    MPI_Bcast ((*text)[i++], len, MPI_CHAR, 0, default_communicator);    
    MPI_Bcast (&len, 1, MPI_INT, 0, default_communicator);
  }

  (*text)[i] = NULL;

  return (text);
}

#endif /*SEQ*/
/* *********************  parser *************************** */
/*
   @FUN:
   @DOES: reads next character (not whitspace) from the text *text and
   returns it.
   Note: a char is treated as an (signed!) int (which is necessary, because
   EOT an other constants are negative.)
   @PARAMETERS: above.
   @RETURNES: returnes character, or EOT (ond of text, if there is no further
   character)
   @SIDEEFFECTS: manipulates pos and lineno.
   @ASSUMES: pos and lineno are initialized.
*/
int 
read_next_char (text_t *text)
{
  char
    actual = (*text)[lineno][pos];

  /* skip end of lines */
  while (actual == EOS)
  {
    pos = 0;
    lineno++;
    if ((*text)[lineno] == NULL)
      return (EOT);
    actual = (*text)[lineno][pos];
  }
  
  pos++;

  return ((int)actual);
}

/*
   @FUN:
   @DOES: unreads the last character, like ungetc of the standard library.
   @PARAMETERS: the character to unread (t, not used actually, only for
   similarity to ungetc).
   Note: a char is treated as an (signed!) int (which is necessary, because
   EOT an other constants are negative.)
   @RETURNES: a pointer to the actual character to read in the text *text.
   @SIDEEFFECTS: manipulates pos.
   @ASSUMES: pos and lineno are initialized.
*/
char *
unread_next_char (int t, text_t *text)
{
  if (pos == 0)
  {
    ERROR(INTERN,"no character read, so no char to unread!");
    output_error (TRUE);
  }
  return ((*text)[lineno] + --pos); /* return pointer */
}


/*
   @FUN:
   @DOES: initializes the symboltable with the reserved words. So to add a
   new reserved word, just add it to the array keywords.
   @PARAMETERS: none
   @RETURNES: nothing.
   @SIDEEFFECTS: manipulates symboltable.
   @ASSUMES: keywords initialized 
*/
void
init_symboltable (void)  /* loads reserved words in symboltable */
{
  struct entry *p;

  for (p = keywords; p->token; p++)
    insert (p->lexptr, p-> token);
}

 
/*
   @FUN:
   @DOES: looks up the string *s in the symboltable.
   @PARAMETERS: above.
   @RETURNES: the index of *s if found,
   0 otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: symboltable and lastentry initialized.
*/
int 
lookup (char *s) 
{
  int p;

  for (p = lastentry; p > 0; p--)
    if (strcmp (symtable[p].lexptr, s) == 0)
      return (p);

  return (0);
}

/*
   @FUN:
   @DOES: inserts the string *s (known as token tok) into the symboltable.
   @PARAMETERS: above.
   @RETURNES: the index of *s in the symboltable.
   @SIDEEFFECTS: increases lastentry.
   @ASSUMES: symboltable and lastentry initialized.
*/
int 
insert (char *s, int tok)  /* uebergibt die nummer des eintrags fur
				  s */
{
  int len = strlen (s);

  if (lastentry + 1 >= SYMMAX)
  {
    ERROR (INTERN,"symboltable overflow!");
    output_error (TRUE);
  }

  if (lastchar + len + 1 >= STRMAX)
  {
    ERROR (INTERN,"lexem array overflow!");
    output_error (TRUE);
  }

  lastentry++;

  symtable[lastentry].token = tok;
  symtable[lastentry].lexptr = &lexemes[lastchar + 1];
  lastchar += (len + 1);
  strcpy (symtable[lastentry].lexptr,s);

  return (lastentry);
}

/* *********************  scanner ******************************* */
/*
   @FUN:
   @DOES: scans next token in the text.
   @PARAMETERS:
   @RETURNES: returns next token if found (the ((int)tokenval) the index
   of its actual value in the symboltable unless:
   token is INT (then ((int) tokenval) has its value.
   token is FLOAT (then (tokenval) has its value.
   token is DONE if EOT reached.
   @SIDEEFFECTS: through calling read_next_char.
   @ASSUMES: symboltable initialized.
*/
int 
lexan(text_t *text) /* Scanner, pardon Entschluesseler */
{
  int t;

  while (1)
  {
    t = read_next_char(text);
    if (t == ' ' || t == '\t')
      ; /* delete whitespaces */
#if 0  /* lines are counted in read_next_char */
    else if (t == '\n')
      lineno++;
#endif
    else if (isdigit (t))
    {
      int
	int_tokenval;

      char 
	*s = unread_next_char (t,text);
      
      sscanf (s,"%d",&int_tokenval);
      sscanf (s,"%f",&tokenval);
      
      if ((double) int_tokenval == tokenval)
      {
	tokenval = (double) int_tokenval;
	
	while (read_next_char (text) != ';') /* no really ok ... */
	  ;
	unread_next_char (t,text);
	return (INTEGER);
      }
      else
      {
	while (read_next_char (text) != ';') /* no really ok ... */
	  ;
	unread_next_char (t,text);
	return (FLOAT);
      }
    }
    else if (isalpha(t))
    {
      int 
	p,     /* index of entry in symbol table */
	b = 0; /* index in lexem buffer */

      while (isalnum(t) || t =='_' || t == '-')
      {
	lexbuf[b++] = t;
	t = read_next_char(text);
	if (b>=BSIZE)
	{
	  ERROR (INTERN,"lexem buffer overflow");
	  output_error (TRUE);
	}
      }
      lexbuf[b] = EOS;
      if (t != EOS)
	unread_next_char (t,text);
      p = lookup (lexbuf);
      if (p == 0)
	p = insert (lexbuf, STRING);
      tokenval = p;
      return (symtable[p].token);
    }
    else if (t == EOT)
      return (DONE);
    else
    {
      tokenval = NONE;
      return (t);
    }
  }
}

/* ******************* parser ****************************** */
/*
   @FUN:
   @DOES: compares the lookahead character with the expected (t) and
   calls the scanner.
   @PARAMETERS: additional: *text for calling the scanner.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts with error message if comparison fails.
   @ASSUMES: nothing.
*/
void 
match(int t, text_t *text)
{
  D1(fprintf(stderr,"should match %d (%s)\n",t, token_to_str (t));)
  if (lookahead == t)
    lookahead = lexan(text);
  else
  {
    D1(fprintf(stderr,"but is %d (%s)\n",lookahead, token_to_str (lookahead));)
    sprintf (_skampi_msg,"syntax error in line: %d.\n%s\n",lineno,
	     (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
}


/*
   @FUN:
   @DOES: analyses entries of the @MEASUREMENTS-Section of the 
   parameter-file.
   @PARAMETERS: a pointer to an array of measurements. This array has
   to be big enough. (The size necessaray can be obtained with 
   count_measurements.)
   *text is a pointer to params.measurements usually.
   @RETURNES: nothing.
   @SIDEEFFECTS: measurement called aborts in case of error.
   @ASSUMES: see above.
*/
void 
parse (measurement_t *ms, text_t *text)
{
  int 
    i = 0;

  lookahead = lexan (text);
  while (lookahead != DONE)
    measurement(ms + i++, text);
}

/*
   @FUN:
   @DOES: fills one measurement_t-struct with the data parsed.
   @PARAMETERS: the measurement *ms to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void 
measurement (measurement_t *ms, text_t *text)
{
  int 
    type,
    send_datatype,
    recv_datatype,
    basetype;

  ms->name = symtable[(int) tokenval].lexptr; 
  D1(fprintf(stderr,"a");)
  match (STRING, text); 
  D1(fprintf(stderr,"a");)
  match ('{', text); 
  D1(fprintf(stderr,"b");)
  match (TYPE, text); 
  D1(fprintf(stderr,"c");)
  match ('=', text); 
  D1(fprintf(stderr,"d");)
  type = (int) tokenval;
  match (INTEGER, text);
  D1(fprintf(stderr,"e");)      
  match (';', text);
  D1(fprintf(stderr,"f");)

  match (BASETYPE, text); 
  match ('=', text); 
  basetype = ((int) tokenval) - 1;
  match (INTEGER, text);
  match (';', text);

  match (SEND_DATATYPE, text); 
  match ('=', text); 
  send_datatype = (int) tokenval;
  match (INTEGER, text);
  match (';', text);

  match (RECV_DATATYPE, text); 
  match ('=', text); 
  recv_datatype = (int) tokenval;
  match (INTEGER, text);
  match (';', text);

  match (VARIATION, text); 
  match ('=', text); 
  variation_style (ms, text); 
  match (';', text);

  match (SCALE, text);
  match ('=', text); 
  scale_style (ms, text);
  match (';', text); 

  match (MAX_REPETITION, text); 
  match ('=', text); 
  int_or_default (&(ms->max_rep), text);
  match (';', text);

  match (MIN_REPETITION, text); 
  match ('=', text); 
  int_or_default (&(ms->min_rep), text);
  match (';', text);

  match (MULTIPLE_OF, text); 
  match ('=', text); 
  int_or_default (&(ms->multiple_of), text);
  match (';', text);

  match (TIME_MEAS, text); 
  match ('=', text); 
  float_or_default_or_invalid (&(ms->time_meas), text);
  match (';', text);

  match (TIME_SUITE, text); 
  match ('=', text); 
  float_or_default_or_invalid (&(ms->time_suite), text);
  match (';', text);
#ifndef SEQ
  match (NODE_TIMES, text); 
  match ('=', text); 
  yes_or_no (&(ms->node_times), text);
  match (';', text);
#endif
  match (CUT_QUANTILE, text); 
  match ('=', text); 
  float_or_default (&(ms->cut_quantile), text);
  match (';', text);


  /*eo new */
#if 0
  match (NAME, text);  
  match ('=', text); 
  ms->name = symtable[(int) tokenval].lexptr; 
  match (STRING, text);      
  match (';', text);
#endif
#ifdef WITH_NODES
  match (DEFAULT_NODES, text); 
  match ('=', text); 
  def_nodes = (int) tokenval; 
  match (INTEGER, text);     
  match (';', text);
#else
#ifndef SEQ
  def_nodes = numprocs;
#else
  def_nodes = 1;
#endif /*SEQ*/
#endif /*WITH_NODES*/

  match (DEFAULT_CHUNKS, text); 
  match ('=', text); 
  def_chunks = (int) tokenval; 
  match (INTEGER, text);     
  match (';', text);

  match (DEFAULT_MESSLEN, text); 
  match ('=', text); 
  def_len = (int) tokenval; 
  match (INTEGER, text);     
  match (';', text);

  match (START_ARGUMENT, text); 
  match ('=', text); 
  ms->x_start = (int) tokenval; 
  match (INTEGER, text);     
  match (';', text);

  match (END_ARGUMENT, text);   
  match ('=', text); 
  int_or_max (ms, text);
  match (';', text);

  match (STEPWIDTH, text); 
  match ('=', text);
  int_or_float (&(ms->x_stepwidth), text);
  match (';', text);

  match (MAX_STEPS, text);
  match ('=', text);
  int_or_default (&(ms->x_max_steps), text);
  match (';', text);

  match (MIN_DIST, text); 
  D1(fprintf(stderr,"a1");) 
  match ('=', text);
  D1(fprintf(stderr,"b1");)
  ms->x_min_dist = (int) tokenval;
  match (INTEGER, text);     
  D1(fprintf(stderr,"c1");)
  match (';', text);
  D1(fprintf(stderr,"d1");)

  match (MAX_DIST, text);
  match ('=', text); 
  ms->x_max_dist = (int) tokenval;
  match (INTEGER, text);     
  match (';', text);

  match (STANDARD_ERROR, text);
  match ('=', text); 
  float_or_default (&(ms->standard_error), text);
  match (';', text);

  match ('}', text);
  initialize_meas (ms, type, send_datatype, recv_datatype, basetype, text); 
}       

/*
   @FUN:
   @DOES: decides which variation style lookahead is.
   @PARAMETERS: the measurement *ms to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void
variation_style (measurement_t *ms, text_t *text)
{
  switch (lookahead)
  {
  case LENGTH_VAR:
    ms->variation = LENGTH;
    break;
#ifndef SEQ
  case NODES_VAR:
    ms->variation = NODES;
    break;
  case CHUNKS_VAR:
    ms->variation = CHUNK;
    break;
#endif /*SEQ*/
  case NO_VAR:
    ms->variation = NO_VARIATION;
    break;
  default:
    sprintf (_skampi_msg,"syntax error in line: %d: unknown variation.\n%s\n",
	     lineno, (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}

/*
   @FUN:
   @DOES: decides which scale style lookahead is.
   @PARAMETERS: the measurement *ms to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void
scale_style (measurement_t *ms, text_t *text)
{
  switch (lookahead)
  {
  case FIXED_LIN_SCALE:
    ms->x_scale = FIXED_LIN;
    break;
  case FIXED_LOG_SCALE:
    ms->x_scale = FIXED_LOG;
    break;
  case DYN_LIN_SCALE:
    ms->x_scale = DYN_LIN;
    break;
  case DYN_LOG_SCALE:
    ms->x_scale = DYN_LOG;
    break;
  default:
    sprintf (_skampi_msg,"syntax error in line: %d: unkown scale.\n%s\n",
	     lineno, (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}

/*
   @FUN:
   @DOES: decides whether lookahead is an int or the keyword MAX_VALUE.
   @PARAMETERS: the measurement *ms to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void 
int_or_max (measurement_t *ms, text_t *text)
{
  switch (lookahead)
  {
  case INTEGER:
    ms->x_end = (int) tokenval;
    break;
  case MAX_VALUE:
    ms->x_end = MAX_ARGUMENT;
    break;
  default:
    sprintf (_skampi_msg, "syntax error in line: %d:\n"\
	     " integer or Max_Value expeceted.\n%s\n", lineno, 
	     (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}

/*
   @FUN:
   @DOES: decides whether lookahead is an int or the keyword DEFAULT_VALUE.
   @PARAMETERS: the value val to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void 
int_or_default (int *val, text_t *text)
{
  switch (lookahead)
  {
  case INTEGER:
    *val = (int) tokenval;
    break;
  case DEFAULT_VALUE:
    *val = DEFAULT;
    break;
  default:
    sprintf (_skampi_msg, "syntax error in line: %d:\n"\
	     " integer or Default_Value expeceted.\n%s\n", lineno, 
	     (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}
/*
   @FUN:
   @DOES: decides whether lookahead is an int or a float.
   @PARAMETERS: the value val to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void 
int_or_float (double *val, text_t *text)
{
  switch (lookahead)
  {
  case INTEGER:
  case FLOAT:
    *val = tokenval;
    break;
  default:
    sprintf (_skampi_msg, "syntax error in line: %d:\n"\
	     " integer or float expeceted.\n%s\n", lineno, 
	     (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}

/*
   @FUN:
   @DOES: decides whether lookahead is a "yes" or a "no".
   @PARAMETERS: the value val be filled (1 == yes, 0 == no), and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void 
yes_or_no (int *val, text_t *text)
{
  switch (lookahead)
  {
  case YES:
    *val = TRUE;
    break;
  case NO:
    *val = FALSE;
    break;
  default:
    sprintf (_skampi_msg, "syntax error in line: %d:\n"\
	     " \"yes\" or \"no\" expeceted.\n%s\n", lineno, 
	     (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}

/*
   @FUN:
   @DOES: decides whether lookahead is a float or the keyword DEFAULT_VALUE.
   @PARAMETERS: the value val to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void 
float_or_default (double *val, text_t *text)
{
  switch (lookahead)
  {
  case FLOAT:
    *val = tokenval;
    break;
  case DEFAULT_VALUE:
    *val = (double) DEFAULT;
    break;
  default:
    sprintf (_skampi_msg, "syntax error in line: %d:\n"\
	     " float or Default_Value expeceted.\n%s\n", lineno, 
	     (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}
/*
   @FUN:
   @DOES: decides whether lookahead is a float or the keyword DEFAULT_VALUE 
   or the keyword INVALID_VALUE.
   @PARAMETERS: the value val to be filled, and the *text
   which to parse.
   @RETURNES: nothing
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
void 
float_or_default_or_invalid (double *val, text_t *text)
{
  switch (lookahead)
  {
  case FLOAT:
    *val = tokenval;
    break;
  case DEFAULT_VALUE:
    *val = (double) DEFAULT;
    break;
  case INVALID_VALUE:
    *val = (double) INVALID;
    break;
  default:
    sprintf (_skampi_msg, "syntax error in line: %d:\n"\
	     " float or Default_Value or Invalid_Value expeceted.\n%s\n", 
	     lineno, (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }
  match (lookahead, text);
}

/*
   @FUN:
   @DOES: initializes the pattern specific data of *ms. There for
   the type of an measurement (index) is used.
   @PARAMETERS: additional: *text, for scanner.
   @RETURNES: nothing.
   @SIDEEFFECTS: manipulates *ms,
   aborts in case of error.
   @ASSUMES: nothing.
*/

/* #ifdef NEUE_DS */
void
initialize_meas (measurement_t *ms, int index, int send_datatype_number, 
		 int recv_datatype_number, 
		 int basetype, text_t *text)
{
  int 
    send_is_col,
    recv_is_col;
  /*
  if (!are_bt_same_size(send_bt,recv_bt))
  {
    sprintf (_skampi_msg, 
	     "differently sized or not created send/recv datatypes in line: "\
	     "%d: send_basetype %d, receive_basetype %d."\
	     "\n%s\n", lineno, send_bt + 1, recv_bt + 1, (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  } 
  */   
#ifdef DIFFERENT_SEND_RECV_TYPES
  if (!create_datatype(recv_datatype_number, 
		       basetype, 
		       -1, 
		       &(ms->recv_datatype), 
		       &(ms->recv_datatype_name), 
		       &(ms->recv_datatype_size), 
		       &(ms->recv_datatype_extent),
		       &(ms->recv_kind_type_meas), 
		       &recv_is_col))
  {
    sprintf (_skampi_msg, 
	     "wrong recv datatype number in line: %d: unkown type %d.\n%s\n", 
	     lineno, recv_datatype_number, (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }    
#endif
  if (!create_datatype(send_datatype_number, 
		       basetype, 
		       -1, 
		       &(ms->send_datatype), 
		       &(ms->send_datatype_name), 
		       &(ms->send_datatype_size), 
		       &(ms->send_datatype_extent),
		       &(ms->send_kind_type_meas), 
		       &send_is_col))
  {
    sprintf (_skampi_msg, 
	     "wrong send datatype number in line: %d: unkown type %d.\n%s\n", 
	     lineno, send_datatype_number, (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
  }    

  ms->send_datatype_number = send_datatype_number;
  ms->basetype_number = basetype;
#ifdef DIFFERENT_SEND_RECV_TYPES
  ms->recv_datatype_number = recv_datatype_number;
#else
  ms->recv_datatype_number = send_datatype_number;
  ms->recv_datatype_name =   ms->send_datatype_name;
  ms->recv_datatype_size = ms->send_datatype_size; 
  ms->recv_datatype_extent = ms->send_datatype_extent;
  ms->recv_kind_type_meas =  ms->send_kind_type_meas; 
  recv_is_col = send_is_col;
#endif

  D13(fprintf(stderr, "in initialize_meas, recv_dt %d, send_dt %d\n",
	      ms->recv_datatype, ms->send_datatype);)

  switch (index)
  {
#ifndef SEQ
  case 1:
    p2p_init_Send_Recv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;
    break;
  case 2:
    p2p_init_Send_Recv_AT (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;
    break;
  case 3:
    p2p_init_Send_Irecv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;
  case 4:
    p2p_init_Send_Iprobe_Recv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;
  case 5:
    p2p_init_Ssend_Recv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;
  case 6:
    p2p_init_Isend_Recv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;
  case 7:
    p2p_init_Bsend_Recv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;
  case 8:
    p2p_init_Sendrecv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;
  case 9:
    p2p_init_Sendrecv_replace (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;
  case 10:
    mw_init_Waitsome (ms, NULL);
    ms->data.mw_data.len = def_len;
    ms->data.mw_data.def_nodes = def_nodes;
    ms->data.mw_data.chunks = def_chunks;

    break;
  case 11:
    mw_init_Waitany (ms, NULL);
    ms->data.mw_data.len = def_len;
    ms->data.mw_data.def_nodes = def_nodes;
    ms->data.mw_data.chunks = def_chunks;

    break; 
  case 12:
    mw_init_Recv_AS (ms, NULL);
    ms->data.mw_data.len = def_len;
    ms->data.mw_data.def_nodes = def_nodes;
    ms->data.mw_data.chunks = def_chunks;

    break;
  case 13:
    mw_init_Send (ms, NULL);
    ms->data.mw_data.len = def_len;
    ms->data.mw_data.def_nodes = def_nodes;
    ms->data.mw_data.chunks = def_chunks;

    break;
  case 14:
    mw_init_Ssend (ms, NULL);
    ms->data.mw_data.len = def_len;
    ms->data.mw_data.def_nodes = def_nodes;
    ms->data.mw_data.chunks = def_chunks;

    break;
  case 15:
    mw_init_Isend (ms, NULL);
    ms->data.mw_data.len = def_len;
    ms->data.mw_data.def_nodes = def_nodes;
    ms->data.mw_data.chunks = def_chunks;

    break;
  case 16:
    mw_init_Bsend (ms, NULL);
    ms->data.mw_data.len = def_len;
    ms->data.mw_data.def_nodes = def_nodes;
    ms->data.mw_data.chunks = def_chunks;

    break;
  case 17:
    col_init_Bcast (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 18:
    col_init_Barrier (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 19:
    if ((send_is_col == FALSE) || (recv_is_col == FALSE))
    {
      sprintf (_skampi_msg, 
	       "send_datatype number %d or recv_datatype number %d "\
	       "cannot be used with "\
	       "collective reduction / scan "\
	       "operation (type %d) in line: %d.\n%s\n", 
	       send_datatype_number, recv_datatype_number, index, 
	       lineno, (*text)[lineno]);
      ERROR(USER,_skampi_msg);
      output_error (TRUE);
    }
    col_init_Reduce (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 20:    
    col_init_Alltoall (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 21:
    if ((send_is_col == FALSE) || (recv_is_col == FALSE))
    {
      sprintf (_skampi_msg, 
	       "datatype number %d cannot be used with "\
	       "collective reduction / scan "\
	       "operation (type %d) in line: %d.\n%s\n", 
	       send_datatype_number, recv_datatype_number, index, lineno, (*text)[lineno]);
      ERROR(USER,_skampi_msg);
      output_error (TRUE);
    }
    col_init_Scan (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 22:  
    col_init_Comm_split (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 23:  
    col_init_memcpy (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 24:
    simple_init_Wtime (ms, NULL);
    break;
  case 25:
    simple_init_Comm_rank (ms, NULL);
    break;
  case 26:
    simple_init_Comm_size (ms, NULL);
    break;
  case 27:
    simple_init_Iprobe (ms, NULL);
    break;
  case 28:
    simple_init_attach (ms, NULL);
    break;
  case 29:
    p2p_init_dummy (ms, NULL);
    break;
  case 30:
    mw_init_dummy (ms, NULL);
    break;
  case 31:
    col_init_dummy (ms, NULL);
    break;
  case 32:
    simple_init_dummy (ms, NULL);
    break;

  case 33:    
    col_init_Gather (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 34:
    p2p_init_Issend_Recv (ms, NULL);
    ms->data.p2p_data.len = def_len;
    ms->data.p2p_data.def_nodes = def_nodes;

    break;

  case 35:    
    col_init_Scatter (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 36:
    if ((send_is_col == FALSE) || (recv_is_col == FALSE))
    {
      sprintf (_skampi_msg, 
	       "send_datatype number %d or recv_datatype number %d cannot "\
	       "be used with "\
	       "collective reduction /scan "\
	       "operation (type %d) in line: %d.\n%s\n", 
	       send_datatype_number, recv_datatype_number, 
	       index, lineno, (*text)[lineno]);
      ERROR(USER,_skampi_msg);
      output_error (TRUE);
    }
    col_init_Allreduce (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
  case 37:
    if ((send_is_col == FALSE) || (recv_is_col == FALSE))
    {
      sprintf (_skampi_msg, 
	       "send_datatype number %d or recv_datatype number %d "\
	       "cannot be used with "\
	       "collective reduction /scan "\
	       "operation (type %d) in line: %d.\n%s\n", 
	       send_datatype_number, recv_datatype_number, 
	       index, lineno, (*text)[lineno]);
      ERROR(USER,_skampi_msg);
      output_error (TRUE);
    }
    col_init_Reduce_Bcast (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 38:
    if ((send_is_col == FALSE) || (recv_is_col == FALSE))
    {
      sprintf (_skampi_msg, 
	       "send_datatype number %d or recv_datatype number %d "\
	       "cannot be used with "\
	       "collective reduction /scan "\
	       "operation (type %d) in line: %d.\n%s\n", 
	       send_datatype_number, recv_datatype_number, 
	       index, lineno, (*text)[lineno]);
      ERROR(USER,_skampi_msg);
      output_error (TRUE);
    }
    col_init_Reduce_scatter (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 39:    
    col_init_Allgather (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 40:    
    col_init_Scatterv (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 41:    
    col_init_Gatherv (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 42:    
    col_init_Allgatherv (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 43:    
    col_init_Alltoallv (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 44:    
    if ((send_is_col == FALSE) || (recv_is_col == FALSE))
    {
      sprintf (_skampi_msg, 
	       "send_datatype number %d or recv_datatype number %d "\
	       "cannot be used with "\
	       "collective reduction /scan "\
	       "operation (type %d) in line: %d.\n%s\n", 
	       send_datatype_number, recv_datatype_number,
	       index, lineno, (*text)[lineno]);
      ERROR(USER,_skampi_msg);
      output_error (TRUE);
    }
    col_init_Reduce_Scatterv (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 45:    
    col_init_Gather_Send_Recv (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;

  case 46:    
    col_init_Gather_Isend_Waitall (ms, NULL);
    ms->data.col_data.len = def_len;
    ms->data.col_data.def_nodes = def_nodes;

    break;
#else /*SEQ*/ /* new numbering for sequential measurements */ 
  case 1:
    seqmeas_init_memcpy (ms, NULL);
    break;
#endif /*SEQ*/
  default:

    sprintf (_skampi_msg, "syntax error in line: %d: unkown type %d.\n%s\n", 
	     lineno, index, (*text)[lineno]);
    ERROR(USER,_skampi_msg);
    output_error (TRUE);
    D13(fprintf(stderr, "initialize_meas finnished\n");)

  }
}


/*
   @FUN:
   @DOES: converts a token into a string, which is returend .
   Used for debugging only.
   @PARAMETERS: above.
   @RETURNES: above.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
char * 
token_to_str (int token)
{
  static char buf[0x100];

  
  switch (token)
  {
  case INTEGER         :
    strcpy (buf,"INTEGER");
    break;
  case FLOAT           :
    strcpy (buf,"FLOAT");
    break;
  case STRING          :
    strcpy (buf,"STRING");
    break;
  case TYPE            :
    strcpy (buf,"TYPE  ");
    break;
  case VARIATION       :
    strcpy (buf,"VARIATION");
    break;
  case SCALE           :
    strcpy (buf,"SCALE ");
    break;
  case MAX_REPETITION  :
    strcpy (buf,"MAX_REPETITION");
    break;
  case MIN_REPETITION  :
    strcpy (buf,"MIN_RETITION");
    break;
  case MULTIPLE_OF  :
    strcpy (buf,"MULTIPLE_OF");
    break;
  case TIME_MEAS  :
    strcpy (buf,"TIME_MEAS");
    break;
  case TIME_SUITE  :
    strcpy (buf,"TIME_SUITE");
    break;
  case CUT_QUANTILE  :
    strcpy (buf,"CUT_QUANTILE");
    break;
  case START_ARGUMENT  :
    strcpy (buf,"START_ARGUMENT");
    break;
  case END_ARGUMENT    :
    strcpy (buf,"END_ARGUMENT");
    break;
  case STEPWIDTH   :
    strcpy (buf,"STEPWIDTH");  
    break;
  case MAX_STEPS       :
    strcpy (buf,"MAX_STEPS");
    break;
  case MAX_DIST        :
    strcpy (buf,"MIN_DIST");
    break;
  case MIN_DIST        :
    strcpy (buf,"MIN_DIST");
    break;
  case STANDARD_ERROR  :
    strcpy (buf,"STANDARD_ERROR");
    break;
  case LENGTH_VAR      :
    strcpy (buf,"LENGTH_VAR");
    break;
  case NODES_VAR   :
    strcpy (buf,"NODES_VAR"); 
    break;
  case CHUNKS_VAR      :
    strcpy (buf,"CHUNKS_VAR");
    break;
  case NO_VAR          :
    strcpy (buf,"NO_VAR");
    break;
  case FIXED_LIN_SCALE :
    strcpy (buf,"FIXED_LIN_SCALE");
    break;
  case FIXED_LOG_SCALE :
    strcpy (buf,"FIXED_LOG_SCALE");
    break;
  case DYN_LIN_SCALE   :
    strcpy (buf,"DYN_LIN_SCALE");
    break;
  case DYN_LOG_SCALE   :
    strcpy (buf,"DYN_LOG_SCALE");
    break;
  case MAX_VALUE   :
    strcpy (buf,"MAX_VALUE"); 
    break;
  case DEFAULT_VALUE       :
    strcpy (buf,"DEFAULT_VALUE");
    break;
  default:
    sprintf (buf,"%c",token);
    break;
  }
  return (buf);
}






/* private globals */
static char 
  *_skib; /* skampi internal buffer, used as message buffer for 
	     communication*/ 

static long int 
  _skib_size = 0,   /* size of skampi internal buffer */
  _skib_used = 0;   /* bytes used of _skib */

#ifndef SEQ
static long int
  _attached_buffer_len; /* used by ..._attach... and ..._detach reoutines */
#endif /*SEQ*/


/* private prototype */
long int find_mml (int nor, int nom, int nop);


/* ***************** routines called once (in main) ****************** */
/*
   @FUN:
   @DOES: allocates the memory for the internal buffer
   @PARAMETERS: the size of memory to allocate (in bytes).
   @RETURNES: TRUE iff successful, 
   FALSE otherwise.
   @SIDEEFFECTS: manipulation of the static variables.
   @ASSUMES: first call or free_mem called before.
*/
int 
allocate_mem (int memsize)
{
#ifndef SEQ
  D(fprintf(stderr,"proc %d: in allocate_mem\n",_skampi_myid);)
#else
  D(fprintf(stderr,"in allocate_mem\n");)
#endif /*SEQ*/
  if (_skib_size != 0)
  {
    ERROR(INTERN,"allocate_mem called twice without free_mem between.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"allocate_mem called after mem_init_....");
    output_error(TRUE);
  }
   
  if ((_skib = malloc (memsize)) != NULL)
  {
    _skib_size = memsize;
    D(fprintf(stderr,"proc %d: in allocate_mem %ld - success\n",
	      _skampi_myid, _skib_size);)
    return (TRUE);
  }
  else
  {
    _skib_size = 0;
    D(fprintf(stderr,"proc %d: in allocate_mem - no success\n",_skampi_myid);)
    return (FALSE);
  }
}

/*
   @FUN:
   @DOES: free-es all allocated memory.
   @PARAMETERS: none.
   @RETURNES: nothing.
   @SIDEEFFECTS: manipulation of the static variables.
   @ASSUMES: allocate_mem called before and no call of free_mem after
   that call of allocate_mem.
*/
void 
free_mem (void)
{
  D(fprintf(stderr,"proc %d: in free_mem\n",_skampi_myid);)
  if (_skib_size != 0)
  {
    _skib_used = _skib_size = 0;
    free (_skib);
  }
}
/* ********************** routines for suites ******************* */
/*
   @FUN:
   @DOES: sets _skampi_buffer to _skib (i.e. a location of allocated memory.)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer.
   @SIDEEFFECTS: manipulation of _skampi_buffer.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_one_buffer (int nor, int nom, int nop)
{
  D(fprintf(stderr,"proc %d: in mem_init_one_buffer\n",_skampi_myid);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_one_buffer called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_one_buffer called after another mem_init_...\n"\
	  " without a mem_release_... between.");
    output_error(TRUE);
  }

  _skampi_buffer_2 = _skampi_buffer = _skib;
  _skib_used = _skib_size;
  _skampi_buffer_size = _skib_size;
  return (_skampi_buffer_size);
}

/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 a location of allocated 
   memory.
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2.
   @SIDEEFFECTS: manipulation of _skampi_buffer.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_two_buffers (int nor, int nom, int nop)
{
#ifndef SEQ
  D(fprintf(stderr,"proc %d: in mem_init_two_buffers\n",_skampi_myid);)
#else
  D(fprintf(stderr,"in mem_init_two_buffers:nor %d, nom %d, nop %d\n",nor,nom,nop);)
#endif /*SEQ*/
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_two_buffers called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_two_buffers called after another mem_init_...\n"\
	  " without a mem_release_... between.");
    output_error(TRUE);
  }

  _skampi_buffer = _skib;
  _skampi_buffer_2 = _skib + _skib_size / 2; /* ?? */

  _skib_used = 2 * (_skib_size / 2); /* always precise... ;-) */
  _skampi_buffer_size = (_skib_size / 2);
  return (_skampi_buffer_size);
}

/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 and _skampi_reduce_buffer 
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2 and _skampi_reduce_buffer
   @SIDEEFFECTS: manipulation of _skampi_buffer....
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_reduce_buffers (int nor, int nom, int nop)
{
  long int 
    h;
#ifndef SEQ
  D(fprintf(stderr,"proc %d: in mem_init_reduce_buffers\n",_skampi_myid);)
#else
  D(fprintf(stderr,"in mem_init_reduce_buffers:nor %d, nom %d, nop %d\n",nor,nom,nop);)
#endif /*SEQ*/
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_reduce_buffers called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_reduce_buffers called after another mem_init_...\n"\
	  " without a mem_release_... between.");
    output_error(TRUE);
  }

  _skampi_buffer = _skib;

  h = _skib_size / 3L;
  h /=4L; 
  h *=4L; /* ensure 4 byte alignment */

  _skampi_buffer_2 = _skib + h; /* ?? */
  _skampi_reduce_buffer = _skib + (2 * h);
  _skib_used = 3 * h;
  _skampi_buffer_size = h;
  _skampi_reduce_buffer_size = (int) h;
  D18(fprintf(stderr,"proc %d: in mem_init_reduce_buffers: _skib_size: %ld, "\
	      "h: %ld,"\
	      " _skampi_buffer: %p; _skampi_buffer_end %p, "\
	      "_skampi_reduce_buffer %p\n", _skampi_myid, _skib_size, 
	      h, _skampi_buffer, 
	      _skampi_buffer + _skib_size - 1, _skampi_reduce_buffer);)
  return (_skampi_buffer_size);
}


#ifndef SEQ
/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 a location of allocated 
   memory suiatble for the MPI_Gather operation. (_skampi_buffer for sending,
   _skampi_buffer_2 for receiving.)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2.
   @SIDEEFFECTS: manipulation of _skampi_buffer and _skampi_buffer_2
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_two_buffers_gather (int nor, int nom, int nop)
{
  long int
    buf_len;

  D(fprintf(stderr,"proc %d: in mem_init_two_buffers_gather\n",_skampi_myid);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_two_buffers_gather called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_two_buffers_gather called after another"\
	  " mem_init_...\nwithout a mem_release_... between.");
    output_error(TRUE);
  }

  _skampi_buffer = _skib;
  buf_len = _skib_size / (nop + 1);
  buf_len /= 4;
  buf_len *= 4;  /* for memory alignment */ 
  _skampi_buffer_2 = _skib + buf_len;

  _skib_used = (nop + 1) * buf_len;
  _skampi_buffer_size = buf_len;
  return (_skampi_buffer_size);
}
/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 a location of allocated 
   memory suiatble for the MPI_Scatter operation. (_skampi_buffer for sending,
   _skampi_buffer_2 for receiving.)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2.
   @SIDEEFFECTS: manipulation of _skampi_buffer and _skampi_buffer_2
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_two_buffers_scatter (int nor, int nom, int nop)
{
  long int
    buf_len;

  D(fprintf(stderr,"proc %d: in mem_init_two_buffers_scatter\n",_skampi_myid);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_two_buffers_scatter called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_two_buffers_scatter called after another"\
	  " mem_init_...\nwithout a mem_release_... between.");
    output_error(TRUE);
  }

  _skampi_buffer_2 = _skib;
  buf_len = _skib_size / (nop + 1);
  buf_len /= 4;
  buf_len *= 4;  /* for memory alignment */ 
  _skampi_buffer = _skib + buf_len;

  _skib_used = (nop + 1) * buf_len;
  _skampi_buffer_size = buf_len;
  return (_skampi_buffer_size);
}

/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 a location of 
   allocated memory.
   The difference to mem_init_two_buffers is, that its result is
   divided by nop, because MPI_Alltoall need a buffer of the size
   message length * nop.
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2.
   @SIDEEFFECTS: manipulation of _skampi_buffer.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_two_buffers_alltoall (int nor, int nom, int nop)
{
  D(fprintf(stderr,"proc %d: in mem_init_two_buffers_alltoall\n",
	    _skampi_myid);)
    _skampi_buffer_size = mem_init_two_buffers (nor, nom, nop) / nop;
  return (_skampi_buffer_size);
}

/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 a location of 
   allocated memory.
   The difference to mem_init_two_buffers is, that its result is
   divided by nop, because Bsend of the mw-pattern need a buffer of the size
   message length * nop.
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2.
   @SIDEEFFECTS: manipulation of _skampi_buffer.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between, default_communicator set
*/
long int 
mem_init_two_buffers_attach (int nor, int nom, int nop)
{
   /* Matthias Mueller 3.3.1998 */
 int mbl;  /* max buffer length */
#if 1
 long int  mml = find_mml (nor,nom,nop);  /* max message length */
    

  MPI_Pack_size ((int)mml * nor * nop * nom, MPI_CHAR, default_communicator, &mbl);

  mbl += (nor * nop * nom) * MPI_BSEND_OVERHEAD;
#else
  mml = _skib_size / 2; /* - nom * nor * nop * MPI_BSEND_OVERHEAD; */
  mbl = _skib_size / 2; /* + nom * nor * nop * MPI_BSEND_OVERHEAD; */
#endif

  _attached_buffer_len = mbl;

  D(fprintf(stderr,"proc %d: in mem_init_two_buffers_attach %d\n",
	    _skampi_myid, mbl);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_two_buffers_attach called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_one_buffer_attach called after another"\
	  " mem_init_...\nwithout a mem_release_... between.");
    output_error(TRUE);
  }

  _skampi_buffer = _skib + mbl;
  _skampi_buffer_2 = _skib;

  MPI_Buffer_attach (_skampi_buffer_2, mbl);
  D(fprintf(stderr,"proc %d: in mem_init_two_buffers_attach - done %d\n",
	    _skampi_myid, mml);)
    _skampi_buffer_size = mml;
  return (_skampi_buffer_size); 
  /* max message length is shorter !!! */
}

/*
   @FUN:
   @DOES: computes the max message length when using MPI_Bsend
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: above
   @SIDEEFFECTS: none.
   @ASSUMES: _skib_size, default_communicator set
*/
long int 
find_mml (int nor, int nom, int nop)
{
  static int
    l_nor = 0,
    l_nom = 0,
    l_nop = 0;
  static long int
    l_mml = 0;

  /* Matthias Mueller 3.3.1998 */
  int buf_len = 0;

  if (!(l_nor == nor && l_nom == nom && l_nop == nop))
  {  /* used not first with this arguments*/
    int
      buf_om = _skib_size / 2;
    buf_om -= (2 * nor * nom * nop) * MPI_BSEND_OVERHEAD;
    /* buffer for one message */

    /* test for max mess. len */
    for (l_mml = 0; buf_len < buf_om; l_mml++)
      MPI_Pack_size ((int)l_mml * nor * nom * nop, MPI_CHAR, 
		     default_communicator, &buf_len);
    
    l_nor = nor;
    l_nom = nom;
    l_nop = nop;
  }
  return (_skampi_buffer_size = l_mml);   /* return last computed result */
}

/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 a location of 
   allocated memory.
   The difference to mem_init_two_buffers is, that its result is NOT
   divided by anything (special for p2p pattern)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2.
   @SIDEEFFECTS: manipulation of _skampi_buffer.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between, default_communicator set
*/
long int 
mem_init_two_buffers_attach_p2p (int nor, int nom, int nop)
{
  _skampi_buffer_size = mem_init_two_buffers_attach (1, 1, 1);
  return (_skampi_buffer_size);
}

/*
   @FUN:
   @DOES: sets _skampi_buffer and _skampi_buffer_2 a location of 
   allocated memory.
   The difference to mem_init_two_buffers is, that its result is NOT
   divided by nop and nom (special for mw pattern)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer and
   _skampi_buffer_2.
   @SIDEEFFECTS: manipulation of _skampi_buffer.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between, default_communicator set
*/
long int 
mem_init_two_buffers_attach_mw (int nor, int nom, int nop)
{
  return (_skampi_buffer_size = mem_init_two_buffers_attach (nor, 1, nop));
}

/*
   @FUN:
   @DOES: 'releases' the _skampi_buffers. It must be called after
   allocate_mem. It does NOT free the allocated memory of _skib.
   It is the counterpart of the mem_init_two_buffers_attach functions.
   @PARAMETERS: none.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void
mem_release_detach (void)
{
  int
    mbl = _attached_buffer_len;
  /* max buffer length */
  D(fprintf(stderr,"proc %d: in mem_release_detach\n",_skampi_myid);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_release_detach called\n"\
	  " without calling allocate_mem before.");
    output_error(TRUE);
  }

  MPI_Buffer_detach (_skampi_buffer_2, &mbl);
  mem_release();
}


/*
   @FUN:
   @DOES: sets _skampi_buffer and the _mw_... variable to locations of 
   allocated memory.(Special for master_dispatch_Waitsome in mw_test1.c.)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer.
   @SIDEEFFECTS: manipulation of the mentioned variables.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_mw_Waitsome (int nor, int nom, int nop)
{ /* should only called by process 0 */

  int 
    worker,
    mml,           /* max. message length */
    overhead = 0,  /* memory overhead: _skib -space not used for messages */
    now = nop - 1; /* number of workers (one less than nop because of master */
  D(fprintf(stderr,"proc %d: in mem_init_mw_Waitsome\n",_skampi_myid);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_mw_Waitsome called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_mw_Waitsome called after another mem_init_...\n"\
	  " without a mem_release_... between.");
    output_error(TRUE);
  }

  /* "allocating" stuff */
  _mw_index = (int *) _skib;
  overhead += now * sizeof (int);

  _mw_buffer = (char **) (_skib + overhead);
  overhead += now * sizeof (char *);

  _mw_req = (MPI_Request *) (_skib + overhead);
  overhead += now * sizeof (MPI_Request);  

  master_stati = (MPI_Status *) (_skib + overhead);
  overhead += now * sizeof (MPI_Status);

  mml = (_skib_size - overhead) / nop;

  _skampi_buffer = _skib + overhead;
  
  for (worker = 0; worker < now; worker++)
    _mw_buffer[worker] = _skib + overhead + mml + (worker * mml);

  _skampi_buffer_size = 0;
  return ( mml);
}


/*
   @FUN:
   @DOES: sets _skampi_buffer and the _mw_... variable to locations of 
   allocated memory. (Special for master_dispatch_Waitany in mw_test1.c.)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer.
   @SIDEEFFECTS: manipulation of the mentioned variables.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_mw_Waitany (int nor, int nom, int nop)
{
 /* should only called by process 0 */

  int 
    worker,
    mml,           /* max. message length */
    overhead = 0,  /* memory overhead: _skib -space not used for messages */
    now = nop - 1; /* number of workers (one less than nop because of master */
  D(fprintf(stderr,"proc %d: in mem_init_mw_Waitany \n",_skampi_myid);)  
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_mw_Waitany called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_mw_Waitany called after another mem_init_...\n"\
	  " without a mem_release_... between.");
    output_error(TRUE);
  }

  /* "allocating" stuff */
  _mw_buffer = (char **) (_skib + overhead);
  overhead += now * sizeof (char *);

  _mw_req = (MPI_Request *) (_skib + overhead);
  overhead += now * sizeof (MPI_Request);  

  mml = (_skib_size - overhead) / nop;

  _skampi_buffer = _skib + overhead;
  
  for (worker = 0; worker < now; worker++)
    _mw_buffer[worker] = _skib + overhead + mml + (worker * mml);

  _skampi_buffer_size = mml;
  return (_skampi_buffer_size);
}



/*
   @FUN:
   @DOES: sets _skampi_buffer and the _col_... variable to locations of 
   allocated memory.(Special for col_init_Gather_Waitall_server in 
   col_test1.c.)
   @PARAMETERS: number of repetitions (nor), 
   number of measurements (nom), 
   number of processes involved in the measurement (nop).
   @RETURNES: the size of memory available at _skampi_buffer.
   @SIDEEFFECTS: manipulation of the mentioned variables.
   @ASSUMES: assumes allocate_mem called once before with no
   other mem_init_... between.
*/
long int 
mem_init_col_Waitall (int nor, int nom, int nop)
{ /* should only called by process 0 */

  int 
    mml,           /* max. message length */
    overhead = 0,  /* memory overhead: _skib -space not used for messages */
    now = nop - 1;

  D(fprintf(stderr,"proc %d: in mem_init_col_Waitall\n",_skampi_myid);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_init_col_Waitall called without calling"\
	  " allocate_mem before.");
    output_error(TRUE);
  }

  if (_skib_used != 0)
  {
    ERROR(INTERN,"mem_init_col_Waitall called after another mem_init_...\n"\
	  " without a mem_release_... between.");
    output_error(TRUE);
  }

  /* "allocating" stuff */
  _col_req = (MPI_Request *) (_skib + overhead);
  overhead += now * sizeof (MPI_Request);  

  _col_stati = (MPI_Status *) (_skib + overhead);
  overhead += now * sizeof (MPI_Status);


  /* memory alignment */
  overhead = (overhead + 3)/4;
  overhead *=4;

  mml = (_skib_size - overhead) / nop;

  /* memory alignment */
  mml /=4;
  mml *=4;

  _skampi_buffer = _skib + overhead;

  _skampi_buffer_2 = _skampi_buffer + mml;
  _skampi_buffer_size = mml;
  return (_skampi_buffer_size);
}
#endif /*SEQ*/


/*
   @FUN:
   @DOES: 'releases' the _skampi_buffers. It must be called after
   allocate_mem. It does NOT free the allocated memory of _skib.
   It is the counterpart of the mem_init_one_buffer and the
   mem_init_two_buffers functions.
   @PARAMETERS: none.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void
mem_release (void)
{
  D(fprintf(stderr,"proc %d: in mem_release\n",_skampi_myid);)
  if (_skib_size == 0)
  {
    ERROR(INTERN,"mem_release called without calling allocate_mem before.");
    output_error(TRUE);
  }
  
  _skib_used = 0;
}




/* ************* Routines for calling measurements *************** */
/*
   @FUN:
   @DOES: measures the measurement *ms.
   @PARAMETERS: the measurement to be measured
   @RETURNES: TRUE in case of success.
   @SIDEEFFECTS: writes result list to output_file
   @ASSUMES: _skampi_myid set
*/
int 
measure (measurement_t *ms) /* ms = measurement */
{
  data_t
    simple_data;

#ifndef SEQ
  if (_skampi_myid == 0)
#endif /*SEQ*/
  {
    if ((ms->result_list = init_list (NULL)) == NULL)
      return (FALSE);  /* other processes ?? */
    O(printf ("starting measurement %s\n", ms->name);)
  }
  
  switch (ms->variation)
  {
#ifndef SEQ 
  case NODES:
    O(if (_skampi_myid == 0)
      printf ("varied over nodes.\n"););
    /* here is no call of fill_dummy_values because they depend on the 
       communicator */
    ms->node_times = FALSE; /* no output here, a simple fix RR */
    measure_suite (ms, call_nodes);
    break;
  case CHUNK:
    O(if (_skampi_myid == 0)
      printf ("varied over chunks.\n"););
    fill_dummy_values (ms);
    measure_suite (ms, call_chunks);
    break;
#endif /*SEQ*/
  case LENGTH:
#ifndef SEQ
    O(if (_skampi_myid == 0)
      printf ("varied over length.\n"););
#else
    printf ("varied over length.\n");
#endif /*SEQ*/
    fill_dummy_values (ms);
    measure_suite (ms, call_length);
    break;

  case NO_VARIATION:  /* in the moment the only pattern with no
			 variation is the simple pattern */
    fill_dummy_values (ms);
    call_simple (ms, &simple_data);
    break;
  default:
    ERROR(USER,"invalid variation occured in measure");
    return (FALSE);
  }

  /* Prepare output */
#ifndef SEQ
  if (_skampi_myid == 0)
#endif /*SEQ*/
  {
    char 
      *pattern_str = "";
    if (ms->name != NULL)
    {
      FILE *output_file;
      
      if ((output_file = fopen (out_file_name,"a+")) == NULL)
      {
	ERROR(FILE_OPEN,"append of measurement");
	return (FALSE);
      }

      switch (ms->pattern)
      {
#ifndef SEQ
      case P2P:
	pattern_str = "p2p";
	break;
      case MASTER_WORKER:
	pattern_str = "mw";
	break;
      case COLLECTIVE:
	pattern_str = "col";
	break;
#endif /*SEQ*/
      case SEQMEAS:
	pattern_str = "seq";
	break;
      case SIMPLE:
	pattern_str = "simple";
	break;
      default:
	ERROR(INTERN,"unknown pattern");
	output_error (TRUE);

      }

      fprintf (output_file,"\n#-------------------------------"\
	       "\n#/*@""in%s_%s.ski*/\n%s", pattern_str,
	       ms->name, measurement_data_to_string(ms, expl_text));
      write_to_file (ms->result_list, output_file);
      free_data_list (ms->result_list, DYNAMIC);
      sprintf (_skampi_msg,"Wrote data of measurement:\n %s\nto file %s\n",
	       ms->name, out_file_name);
      write_to_log_file (_skampi_msg);       
      fclose (output_file);
    }
  }
  return (TRUE);
}

/*
   @FUN:
   @DOES: computes the minimal time a measurement can have
   (that is 2* TIME(MPI_Wtime)) Usually this value is only need by
   process zero (which measures).
   @PARAMETERS: none.
   @RETURNES: the this value.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
double 
min_time (void)
{
  measurement_t 
    mtm; /* min_time_measurement */

  data_t 
    simple_data;

  if ((mtm.result_list = init_list (NULL)) == NULL)
    return (FALSE);  /* other processes ?? */

  mtm.pattern = SIMPLE;
  mtm.variation = NO_VARIATION;
  mtm.max_rep = 60;
  mtm.min_rep = 60;
#ifndef SEQ
  mtm.name = "2Wtime";
  mtm.communicator = default_communicator;  
#else
    mtm.name = "2clock";
#endif /*SEQ*/
  mtm.standard_error = 0.001;  
#ifndef SEQ
  simple_init_2Wtime (&mtm, NULL);
#else
  simple_init_2clock (&mtm, NULL);
#endif /*SEQ*/

  fill_dummy_values (&mtm);
  call_simple (&mtm, &simple_data);


  free_data_list (mtm.result_list, DYNAMIC);
  return (simple_data.result_cleaned - simple_data.standard_error_cleaned);
}


/*
   @FUN:
   @DOES: call the measurement ms (which should vary over message length) 
   with the message length length.
   @PARAMETERS: additional: data, the address where to store the result.
   @RETURNES: the filled data struct in case of success, NULL otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_t *
call_length (measurement_t *ms, int length, data_t *data)
{
  static int
    max_min_found = FALSE,
    max_node,
    min_node;
  
  
  switch (ms->pattern)
  {
#ifndef SEQ
  case P2P:    
#if 1
    if (max_min_found == FALSE)
    {
      p2p_find_max_min (ms);
      max_node = ms->data.p2p_data.max_node;
      min_node = ms->data.p2p_data.min_node;
      max_min_found = TRUE;
    }
    else
    {
      ms->data.p2p_data.max_node = max_node;
      ms->data.p2p_data.min_node = min_node;
    }
#else
    p2p_find_max_min (ms); 
#endif      
    ms->data.p2p_data.len = length;
    ms->data.p2p_data.result = data;
    D2(fprintf (stderr,"proc %d: in call_length with arg %d\n",_skampi_myid,
		length);)
    p2p_pattern (ms);
    if (ms->node_times)
      ms->data.p2p_data.result->used_nodes = 2;
    else
      ms->data.p2p_data.result->used_nodes = 0;
    ms->data.p2p_data.result->arg = length;
    break;

  case MASTER_WORKER:
    D(fprintf (stderr,"process %d length mw\n",_skampi_myid);)
    ms->data.mw_data.len = length;
    ms->data.mw_data.result = data;
    ms->data.mw_data.result->used_nodes = 0; /* node times
						do not make sense in the
						mw pattern */
    ms->data.mw_data.result->nodes = 0; /* node times
						do not make sense in the
						mw pattern */
    D11(fprintf(stderr, "%d: call_length-1: received arg %d\n",
		_skampi_myid, length);)

    if (!mw_pattern (ms))
      return (NULL);
    D11(fprintf(stderr, "%d: call_length-2: received arg %d\n",
		_skampi_myid, length);)

    ms->data.mw_data.result->used_nodes = 0; /* node times
						do not make sense in the
						mw pattern */
    ms->data.mw_data.result->arg = length;
    break;

  case COLLECTIVE:
    D1(fprintf (stderr,"process %d here length collective\n",\
		_skampi_myid);)
    ms->data.col_data.len = length;
    ms->data.col_data.result = data;
    col_pattern (ms);
    if (ms->node_times)
      ms->data.col_data.result->used_nodes = numprocs;
    else
      ms->data.col_data.result->used_nodes = 0;
    ms->data.col_data.result->arg = length;
    break;
#else /*SEQ*/
  case SEQMEAS:
    D1(fprintf (stderr,"here length seqmeas\n");)
    ms->data.seqmeas_data.arg = length;
    ms->data.seqmeas_data.result = data;
    seqmeas_pattern (ms);

    /* no node times in the sequential case */
    ms->data.seqmeas_data.result->arg = length;
    break;

#endif /*SEQ*/
  default:
    ERROR(USER,"invalid pattern in call_length");
    return (NULL);
  } /* switch pattern (inner) */
  return (data);
}

#ifndef SEQ /* the following is only ineteresting for the parallel case */

/*
   @FUN:
   @DOES:    create comminucator is a collective operation!
   creates an new communicator with size processes from old_comm, 
   returns false iff new_comm must not used for measurement.
   @PARAMETERS: above
   @RETURNES: TRUE iff new_comm is usable for measurement,
   FALSE if the new_comm has not to be used for measurement.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int 
create_communicator (MPI_Comm old_comm, int size, MPI_Comm *new_comm)
{
  MPI_Comm_split (old_comm, _skampi_myid < size, _skampi_myid, new_comm);
  return (_skampi_myid < size);
}

/*
   @FUN:
   @DOES: call the measurement ms (which should vary over the number of nodes) 
   with nodes nodes.
   @PARAMETERS: additional: data, the address where to store the result.
   @RETURNES: the filled data struct in case of success, NULL otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
data_t *
call_nodes (measurement_t *ms, int nodes, data_t *data)
{
  MPI_Comm
    local_communicator = ms->communicator;

  int 
    max_msg_len;

  if (create_communicator (ms->communicator, nodes, &local_communicator))
  {

    switch(ms->pattern)
    {
    case MASTER_WORKER:
      ms->data.mw_data.communicator = local_communicator;
      ms->data.mw_data.result = data;
      break;

    case COLLECTIVE:
      ms->data.col_data.communicator = local_communicator;
      ms->data.col_data.result = data;
      break;

    default:
      ERROR(USER,"invalid pattern in call_nodes");
      return (NULL);
    }

    fill_dummy_values (ms);

    if (_skampi_myid == 0)
    {
      if (!(max_msg_len = ms->server_init (ms->max_rep *
	  (ms->pattern == MASTER_WORKER ? ms->data.mw_data.chunks: 1), 
			    ms->x_max_steps, nodes)))
      {
	ERROR(NO_MEM,"no memory for messages");
	output_error(TRUE);
      }
    }
    else
    {
      if (!(max_msg_len = ms->client_init (ms->max_rep, ms->x_max_steps, nodes)))
      {
	ERROR(NO_MEM,"client has not enough memory for messages");
	output_error (TRUE); /* pech gehabt! */
      }
    }

    switch(ms->pattern)
    {
    case MASTER_WORKER:
      ms->data.mw_data.len = MIN(max_msg_len,ms->data.mw_data.len);
      if (!mw_pattern (ms))
	return (NULL);
      ms->data.mw_data.result->arg = nodes;
      ms->data.mw_data.result->used_nodes = 0;
      break;

    case COLLECTIVE:
      ms->data.col_data.len = MIN(max_msg_len,ms->data.col_data.len);
      D1(fprintf (stderr,"process %d collective -nodes\n",_skampi_myid);)

      col_pattern (ms);

      ms->data.col_data.result->arg = nodes;

      if (ms->node_times)
	ms->data.col_data.result->used_nodes = nodes;
      else
	ms->data.col_data.result->used_nodes = 0;
      break;

    default:
      ERROR(USER,"invalid pattern in call_nodes");
      return (NULL);
    }
    if (_skampi_myid == 0)
    {
      ms->server_free ();
    }
    else
    {
      ms->client_free ();
    }
  }
  return (data);
}

/*
   @FUN:
   @DOES: call the measurement ms (which should vary over chunks (i.e. number
   of pieces of work)) with chunks chunks.
   @PARAMETERS: additional: data, the address where to store the result.
   @RETURNES: the filled data struct in case of success, NULL otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_myid set.
*/
data_t *
call_chunks (measurement_t *ms, int chunks, data_t *data)
{
  if (ms->pattern == MASTER_WORKER)
  {
    /* call pattern */
    ms->data.mw_data.chunks = chunks;
    ms->data.mw_data.result = data;

    if (!mw_pattern (ms))
      return (NULL);
    ms->data.mw_data.result->arg = chunks;
    ms->data.mw_data.result->used_nodes = 0;
  }
  else
  {
    ERROR(USER,"invalid pattern in call_chunks");
    return (NULL);
  }
  return (data);
}
#endif /*SEQ*/
/*
   @FUN:
   @DOES: call the measurement ms. (In the simple pattern there is no
   parameter to vary over.)
   @PARAMETERS: additional: data, the address where to store the result.
   @RETURNES: the filled data struct in case of success, NULL otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_myid set.
*/
data_t *
call_simple (measurement_t *ms, data_t *data)
{
  int
    nodes = 1,
    error;

#ifndef SEQ
  MPI_Comm_size (ms->communicator, &nodes);

  if (_skampi_myid == 0)
#endif /*SEQ*/
    ms->server_init(ms->max_rep, ms->x_max_steps, nodes);
#ifndef SEQ
  else
    ms->client_init(ms->max_rep, ms->x_max_steps, nodes);
#endif /*SEQ*/
  if (ms->pattern == SIMPLE)
  {
    /* call pattern */
    ms->data.simple_data.result = data;
    simple_pattern (ms);
#ifndef SEQ
    ms->data.simple_data.result->used_nodes = 1;
    ms->data.simple_data.result->nodes = 0;
    if (_skampi_myid == 0)
#endif /*SEQ*/
      append(ms->result_list,data,&error);
  }
  else 
  {
    ERROR(USER,"invalid pattern in call_simple");
    return (NULL);
  }
#ifndef SEQ
  if (_skampi_myid == 0)
#endif /*SEQ*/
    ms->server_free();
#ifndef SEQ
  else
    ms->client_free();
#endif /*SEQ*/
  return (data);
}

/*
   @FUN:
   @DOES: fills the ms struct with the spcific dummy values. (found in the
   pattern-specific struct (named data in ms)):
   @PARAMETERS: above.
   @RETURNES: the filled ms struct in case of success, NULL otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_myid set.
*/
void 
fill_dummy_values (measurement_t *ms)
{
  if (params.absolute)
  {
    measurement_t
      dummy_measurement;
    
    data_t
      data;
    
    int
      nop;
#ifndef SEQ    
    D(fprintf(stderr,"proc %d: in fill_dummy_values \n",_skampi_myid);)


    D(write_to_log_file ("in fill_dummy_values \n");)
      if (ms->variation == NODES && ms->x_end != MAX_ARGUMENT)
	nop = ms->x_end;
      else
	MPI_Comm_size (ms->communicator, &nop);
#else /*SEQ*/
      nop = 1;
#endif /*SEQ*/

    init_data(&data, 0);
    
    dummy_measurement.pattern = ms->pattern;
    dummy_measurement.name = "dummy measurement";
    dummy_measurement.max_rep = ms->max_rep;
    dummy_measurement.min_rep = ms->min_rep;
#ifndef SEQ
    dummy_measurement.send_datatype = ms->send_datatype;
    dummy_measurement.recv_datatype = ms->recv_datatype;
    dummy_measurement.send_datatype_name = ms->send_datatype_name;
    dummy_measurement.send_datatype_size = ms->send_datatype_size;  
    dummy_measurement.send_datatype_extent = ms->send_datatype_extent;
    dummy_measurement.recv_datatype_name = ms->recv_datatype_name;
    dummy_measurement.recv_datatype_size = ms->recv_datatype_size;  
    dummy_measurement.recv_datatype_extent = ms->recv_datatype_extent;
    dummy_measurement.basetype_number = ms->basetype_number;
    dummy_measurement.send_datatype_number = ms->send_datatype_number;
    dummy_measurement.recv_datatype_number = ms->recv_datatype_number;
    dummy_measurement.send_kind_type_meas = ms->send_kind_type_meas;
    dummy_measurement.recv_kind_type_meas = ms->recv_kind_type_meas;
    dummy_measurement.node_times = FALSE;
#endif 
    dummy_measurement.cut_quantile = 0.25;
    dummy_measurement.time_suite = INVALID;
    dummy_measurement.time_meas = INVALID;
    dummy_measurement.multiple_of = 1;

    
    dummy_measurement.standard_error = ms->standard_error;
#ifndef SEQ
    D(fprintf(stderr,"proc %d: in fill_dummy_values - 2 \n",_skampi_myid);)
#else /*SEQ*/
    D(fprintf(stderr,"in fill_dummy_values - 2 \n");)
#endif /*SEQ*/
    switch (ms->pattern)
    {
#ifndef SEQ
    case P2P:
      ms->x_max_steps = 1;
      p2p_init_dummy (&dummy_measurement, &data);
      D(fprintf(stderr,"proc %d: in fill_dummy_values - 3\n",_skampi_myid);)
      dummy_measurement.data.p2p_data.dummy_time = 0.0;
      dummy_measurement.data.p2p_data.dummy_time_se = 0.1;
      dummy_measurement.communicator = 
	dummy_measurement.data.p2p_data.communicator = 
	  ms->data.p2p_data.communicator;
      D(fprintf(stderr,"proc %d: in fill_dummy_values - 4 \n",_skampi_myid);)
      if (_skampi_myid == 0)
	ms->server_init (ms->max_rep, ms->x_max_steps, nop);
      else
	ms->client_init (ms->max_rep, ms->x_max_steps, nop);

      p2p_find_max_min (&dummy_measurement);
      p2p_pattern (&dummy_measurement);
      ms->data.p2p_data.dummy_time = 
	dummy_measurement.data.p2p_data.result->result_cleaned;   
      ms->data.p2p_data.dummy_time_se = 
	dummy_measurement.data.p2p_data.result->standard_error_cleaned;   
      break;
      
    case MASTER_WORKER:
      ms->x_max_steps = 1;
      data.nodes = 0;
      data.used_nodes = 0;
      D(write_to_log_file ("in fill_dummy_values -2\n");)
      mw_init_dummy (&dummy_measurement, &data);
      D(write_to_log_file ("in fill_dummy_values -3\n");)
      dummy_measurement.data.mw_data.dummy_time = 0.0;
      dummy_measurement.data.mw_data.dummy_time_se = 0.1;
      dummy_measurement.communicator = 
	dummy_measurement.data.mw_data.communicator = 
	  ms->data.mw_data.communicator;
      
      if (_skampi_myid == 0)
	ms->server_init (ms->max_rep, ms->x_max_steps, nop);
      else
	ms->client_init (ms->max_rep, ms->x_max_steps, nop);
      D(write_to_log_file ("in fill_dummy_values -4\n");)
      mw_pattern (&dummy_measurement);
      D(write_to_log_file ("in fill_dummy_values -5\n");)
      ms->data.mw_data.dummy_time = 
	dummy_measurement.data.mw_data.result->result_cleaned;   
      ms->data.mw_data.dummy_time_se = 
	dummy_measurement.data.mw_data.result->standard_error_cleaned;  
      break;
      
    case COLLECTIVE:
      ms->x_max_steps = 1;
      col_init_dummy (&dummy_measurement, &data);
      dummy_measurement.data.col_data.dummy_time = 0.0;
      dummy_measurement.data.col_data.dummy_time_se = 0.1;
      dummy_measurement.communicator = 
	dummy_measurement.data.col_data.communicator = 
	  ms->data.col_data.communicator;
      if (_skampi_myid == 0)
	ms->server_init (ms->max_rep, ms->x_max_steps, nop);
      else
	ms->client_init (ms->max_rep, ms->x_max_steps, nop);

      col_pattern (&dummy_measurement);

      ms->data.col_data.dummy_time = 
	dummy_measurement.data.col_data.result->result_cleaned;   
      ms->data.col_data.dummy_time_se = 
	dummy_measurement.data.col_data.result->standard_error_cleaned;   
      D1(printf ("proc %d: in fill_dummy_values: dummy_result %f", 
		 _skampi_myid, ms->data.col_data.dummy_time);)
      D(sprintf(_skampi_msg, "in fill_dummy_values: dummy_result %f", 
		  ms->data.col_data.dummy_time);
        write_to_log_file (_skampi_msg);)
      break;
#else /*SEQ*/
    case SEQMEAS:
      ms->x_max_steps = 1;
      seqmeas_init_dummy (&dummy_measurement, &data);
      dummy_measurement.data.seqmeas_data.dummy_time = 0.0;
      dummy_measurement.data.seqmeas_data.dummy_time_se = 0.1;
      ms->server_init (ms->max_rep, ms->x_max_steps, nop);

      seqmeas_pattern (&dummy_measurement);

      ms->data.seqmeas_data.dummy_time = 
	dummy_measurement.data.seqmeas_data.result->result_cleaned;   
      ms->data.seqmeas_data.dummy_time_se = 
	dummy_measurement.data.seqmeas_data.result->standard_error_cleaned;   
      D1(printf ("in fill_dummy_values: dummy_result %f", 
		 ms->data.seqmeas_data.dummy_time);)
      D(sprintf(_skampi_msg, "in fill_dummy_values: dummy_result %f", 
		  ms->data.seqmeas_data.dummy_time);
        write_to_log_file (_skampi_msg);)
      break;

#endif /*SEQ*/      
    case SIMPLE:
      ms->x_max_steps = 1;
      simple_init_dummy (&dummy_measurement, &data);
      dummy_measurement.data.simple_data.dummy_time = 0.0;
      dummy_measurement.data.simple_data.dummy_time_se = 0.1;
#ifndef SEQ
      dummy_measurement.communicator = 
	dummy_measurement.communicator = ms->communicator;
      if (_skampi_myid == 0)
#endif
	ms->server_init (ms->max_rep, ms->x_max_steps, nop);
#ifndef SEQ
      else
	ms->client_init (ms->max_rep, ms->x_max_steps, nop);
#endif
      simple_pattern (&dummy_measurement);
      ms->data.simple_data.dummy_time = 
	dummy_measurement.data.simple_data.result->result_cleaned;   
      ms->data.simple_data.dummy_time_se = 
	dummy_measurement.data.simple_data.result->standard_error_cleaned;   
      break;
    }

#ifndef SEQ
    D(fprintf(stderr,"proc %d: in init_dummy_values -done \n",_skampi_myid);)
    if (_skampi_myid == 0)
#endif /*SEQ*/
      ms->server_free ();
#ifndef SEQ
    else
      ms->client_free ();
#endif /*SEQ*/
  }
  else /* so do not change results, although they are relative
	and contain the error of measurement's overhead */
  {
    switch (ms->pattern)
    {
#ifndef SEQ
    case P2P:
      ms->data.p2p_data.dummy_time = 0.0;
      ms->data.p2p_data.dummy_time_se = 0.0;
      break;
      
    case MASTER_WORKER:
      ms->data.mw_data.dummy_time = 0.0;
      ms->data.mw_data.dummy_time_se = 0.0;
      break;
      
    case COLLECTIVE:
      ms->data.col_data.dummy_time = 0.0;
      ms->data.col_data.dummy_time_se = 0.0;
      break;
#else/*SEQ*/
    case SEQMEAS:
      ms->data.seqmeas_data.dummy_time = 0.0;
      ms->data.seqmeas_data.dummy_time_se = 0.0;
      break;

#endif /*SEQ*/
    case SIMPLE:
      ms->data.simple_data.dummy_time = 0.0;
      ms->data.simple_data.dummy_time_se = 0.0;
      break;
    }
  }
}

/* private functions */
int parse_int_touple_list (char *input, MPI_Aint *displ_list, int *len_list,
			   int *size, int max_size);

/* private variables */

  D16(static int typecounter = 0;) /* counts calls to MPI_Type_commit vs 
				    MPI_Type_free */
  D16(static int callcounter = 0;) /* counts calls to create_.. and free_...
				     */

/* defined in skampi.c initialized in skampi_tools.c, init_skalib */
extern int
  intsize,
  longintsize,
  doublesize,
  longdoublesize;

  static MPI_Datatype _basetype[MAX_BASETYPES];
  static MPI_Aint _basetype_extent[MAX_BASETYPES];
  static int _basetype_size[MAX_BASETYPES] = {0,0,0,0,0,0,0,0,0,0};
  char *_basetype_name[MAX_BASETYPES];

  MPI_Datatype bvector1, bvector2, bvector3, comp1, comp2, comp3;
  MPI_Datatype bvector, bindex;
/*
   @FUN:
   @DOES: 
    This function creates the basetype[number]. A base type is necessary to 
    create the other user defined types. A basetype is a struct of bt_size
    many entries. Entry j contains bt_len[j] many elements of type MPI_Byte,
    and starts at displacement displ[j].
   @PARAMETERS:     
    number denotes the number of the basetype to be created.
    s is a string containing a triple list (len, offset, type)+ 
   @RETURNES: 
    nothing
   @SIDEEFFECTS: 
    exits program in case of not enough memory. Sets private 
    variables _basetype[number], _basetype_extent[number], 
    and _basetype_size[number], _basetype_name[number]
   @ASSUMES: 
    called never before or called first time after free_basetype. 
    This is determined whether _basetype_size[number] == 0 or not. 
    Pointer-parameter s must not be NULL.
    number < MAX_BASETYPES.
*/
void create_basetype (int number, char *s)
{
  int
    i;

  #ifdef MPI_2
  int
    lb;
  #endif

  MPI_Aint
    bt_disp[MAX_BASETYPE_SIZE];
  int
    bt_blen[MAX_BASETYPE_SIZE],
    bt_elems;


  MPI_Datatype
    bt_type[MAX_BASETYPE_SIZE];


  D16(callcounter++;)

  D13(fprintf(stderr, "in create_basetype -1, s %s, number %d",s,number);)
  if (!strstr(s,"(")) {
    if (strstr(s,"MPI_BYTE")) {
      _basetype[number] = MPI_BYTE;
      _basetype_name[number] = "MPI_BYTE";
#ifdef MPI_2
      MPI_Type_get_extent(_basetype[number], &lb, _basetype_extent + number);
#else
      MPI_Type_extent(_basetype[number], _basetype_extent + number);
#endif
      
      MPI_Type_size(_basetype[number], _basetype_size + number);
      return;
    }
    if (strstr(s,"MPI_INT")) {
      _basetype[number] = MPI_INT;
      _basetype_name[number] = "MPI_INT";
#ifdef MPI_2
      MPI_Type_get_extent(_basetype[number], &lb, _basetype_extent + number);
#else
      MPI_Type_extent(_basetype[number], _basetype_extent + number);
#endif
      
      MPI_Type_size(_basetype[number], _basetype_size + number);
      return;
    }
    if (strstr(s,"MPI_LONG_DOUBLE")) {
      _basetype[number] = MPI_LONG_DOUBLE;
      _basetype_name[number] = "MPI_LONG_DOUBLE";
#ifdef MPI_2
      MPI_Type_get_extent(_basetype[number], &lb, _basetype_extent + number);
#else
      MPI_Type_extent(_basetype[number], _basetype_extent + number);
#endif
      
      MPI_Type_size(_basetype[number], _basetype_size + number);
      return;
    }
    /* note that this order of _first_ testing for MPI_LONG_DOUBLE
       and _then_ testing for MPI_LONG is not accidentally, since the first is
       a prefix of the latter.
    */
    if (strstr(s,"MPI_LONG")) {
      _basetype[number] = MPI_LONG;
      _basetype_name[number] = "MPI_LONG";
#ifdef MPI_2
      MPI_Type_get_extent(_basetype[number], &lb, _basetype_extent + number);
#else
      MPI_Type_extent(_basetype[number], _basetype_extent + number);
#endif
      
      MPI_Type_size(_basetype[number], _basetype_size + number);
      return;
    }
    if (strstr(s,"MPI_FLOAT")) {
      _basetype[number] = MPI_FLOAT;
      _basetype_name[number] = "MPI_FLOAT";
#ifdef MPI_2
      MPI_Type_get_extent(_basetype[number], &lb, _basetype_extent + number);
#else
      MPI_Type_extent(_basetype[number], _basetype_extent + number);
#endif
      
      MPI_Type_size(_basetype[number], _basetype_size + number);
      return;
    }
    if (strstr(s,"MPI_DOUBLE")) {
      _basetype[number] = MPI_DOUBLE;
      _basetype_name[number] = "MPI_DOUBLE";
#ifdef MPI_2
      MPI_Type_get_extent(_basetype[number], &lb, _basetype_extent + number);
#else
      MPI_Type_extent(_basetype[number], _basetype_extent + number);
#endif
      
      MPI_Type_size(_basetype[number], _basetype_size + number);
      return;
    }
  }

  if (!parse_triple_list (s, bt_disp, bt_blen, bt_type,
			      &bt_elems, MAX_BASETYPE_SIZE))
  {
    sprintf(_skampi_msg,"error parsing basetype %d",i + 1);
    ERROR (USER,_skampi_msg);
    output_error (TRUE);
  }

  D13(fprintf(stderr, "in create_basetype -1, s %s",s);)

  if (_basetype_size[number] != 0)
  {
    ERROR(INTERN,"create_basetype called for an allready created basetype.");
    output_error(TRUE);
  }


  D13(fprintf(stderr, "in create_basetype, number %d, elems %d,",number,
	      bt_elems);)

  for (i = 0; i < bt_elems; i++)
  {
    D13(fprintf(stderr, "len[%d] %d, displ[%d] %d, type[%d] %d,",i,bt_blen[i],i,
		(int)bt_disp[i],i,(int)bt_type[i]);)
  }
  D13(fprintf(stderr, "MPI INT %d, MPI_BYTE %d\n", (int) MPI_INT, (int) MPI_BYTE);)

    /* when introducing additional predefined datatypes here, look at
       free_datatype */
  {
    D13(fprintf(stderr, "in create_basetype -2b, number %d, elems %d,",number,
		bt_elems);)
    for (i = 0; i < bt_elems; i++)
    {
      MPI_Aint element_extent;
#ifdef MPI_2
      MPI_Type_get_extent(bt_type[i], &lb, &element_extent);
#else
      MPI_Type_extent(bt_type[i], &element_extent);
#endif

      bt_disp[i] *=  element_extent;

    }

    #ifdef MPI_2
    MPI_Type_create_struct(bt_elems,bt_blen,bt_disp,bt_type,_basetype + number);
    #else
    MPI_Type_struct(bt_elems,bt_blen,bt_disp,bt_type,_basetype + number);
    #endif
    _basetype_name[number] = "struct";
    D16(typecounter++;) MPI_Type_commit(_basetype + number);
  }

  #ifdef MPI_2
  MPI_Type_get_extent(_basetype[number], &lb, _basetype_extent + number);
  #else
  MPI_Type_extent(_basetype[number], _basetype_extent + number);
  #endif

  MPI_Type_size(_basetype[number], _basetype_size + number);

  free(bt_type);
  D13(fprintf(stderr, "finnished create_basetype\n");)
  D16(fprintf(stderr, "finnished %d, create_basetype: typecounter %d\n",
	      callcounter, typecounter);)
}

int
parse_triple_list (char *input, MPI_Aint *displ_list, int *len_list, MPI_Datatype *type_list,
		       int *size, int max_size)
{
  char
    buf[0xFF];

  int
    i,
    j,
    list_index = 0,
    toggle = 0,
    bracket_open = FALSE;

  D13(fprintf(stderr, "input %s\n", input);)

  for (i = 0; input[i]; i++)
  {
    if ((isspace(input[i])) || (isspace(input[i])))
      continue;

    if (input[i] == '(')
      bracket_open = TRUE;

    if (isalnum(input[i]))
    {
      for (j = 0; isalnum(input[i]) || input[i]=='_'; j++, i++) {
	buf[j] = input[i];
      }
      buf[j] = 0;

      /* check the entries for len and disp to be numbers */
      if (toggle == 0 || toggle == 1)
      {
	int
	  start = 0;
	if (buf[0] == '-' && toggle == 0)
	  return(FALSE); /* no negative numbers for len */
	if (buf[0] == '-' && toggle == 1)
	  start = 1; /* overread the sign for disp */
	for (j = 0; buf[j] != 0; j++) {
	  if (!(isdigit(buf[j])))
	    return(FALSE);
	}
      }

      /* fill the appropriate lists */

      if (toggle == 0)
      {
	len_list[list_index] = atoi(buf);
	D13(fprintf(stderr, "len_list[%d] %d\n",
		    list_index,len_list[list_index]);)
      }

      if (toggle == 1)
      {
	displ_list[list_index] = (MPI_Aint) atoi(buf);
	D13(fprintf(stderr, "displ_list[%d] %d\n",
		    list_index, (int) displ_list[list_index]);)
      }

      if (toggle == 2) {
	D13(fprintf(stderr, "buf %s, list_index %d\n", buf, list_index);)
	if (strstr(buf,"MPI_BYTE")) {
	  type_list[list_index] = MPI_BYTE;
	}else
	if (strstr(buf,"MPI_INT")) {
	  type_list[list_index] = MPI_INT;
	}else
	if (strstr(buf,"MPI_LONG_DOUBLE")) {
	  type_list[list_index] = MPI_LONG_DOUBLE;
	}else
	/* note that this order of _first_ testing for MPI_LONG_DOUBLE
	   and _then_ testing for MPI_LONG is not accidentally, since the first is
	   a prefix of the latter.
	*/
	if (strstr(buf,"MPI_LONG")) {
	  type_list[list_index] = MPI_LONG;
	}else
	if (strstr(buf,"MPI_FLOAT")) {
	  type_list[list_index] = MPI_FLOAT;
	}else	
	if (strstr(buf,"MPI_DOUBLE")) {
	  type_list[list_index] = MPI_DOUBLE;
	}else {
	  D13(fprintf(stderr, "could not find appropriate type for %s\n", buf);)
	  return FALSE;
	}
      }
      toggle = (toggle + 1) % 3;
    } /* if isalnum */
    if (!input[i])
      break; /* necessary because of above manipulation of i */

    if (input[i] == ')')
    {
      if (toggle)
	return (FALSE);
      if (!bracket_open)
	return (FALSE);
      bracket_open = FALSE;
      list_index++;
      if (list_index == max_size)
	break;
    }
  } /* for */

  /* this prohibits empty basetypes.
     If you omit this, than you must handle them elsewhere */
  if (list_index == 0)
    return FALSE;

  *size = list_index;
  D13(fprintf(stderr, "size %d\n", *size);)

  return (TRUE);
}




/*
   @FUN:
   @DOES: 
    This function frees the basetype[number].
   @PARAMETERS:     
    number denotes the number of the basetype to be freed.
   @RETURNES: 
    nothing
   @SIDEEFFECTS: 
    sets _basetype_size[number] to zero.
   @ASSUMES: 
    called never before or called first time after create_basetype. 
    This is determined whether _basetype[number]_size == 0 or not. 
    number < MAX_BASETYPES.
*/
void free_basetype (int number)
{
  D16(callcounter++;)
  if (_basetype_size[number] != 0)
  {
    D16(typecounter--;) MPI_Type_free (_basetype + number);
    _basetype_size[number] = 0;
    _basetype_extent[number] = 0;
  }
  D16(fprintf(stderr, "finnished %d free_basetype: typecounter %d\n", 
	      callcounter, typecounter);)
}

/*
   @FUN:
   @DOES: 
     returns true iff _basetype[bt1] has the same size and extent as
     _basetype[bt2] and both, bt1 and bt2,  are constructed.
   @PARAMETERS:     
    above
   @RETURNES: 
    above
   @SIDEEFFECTS: 
   @ASSUMES: 
*/
int are_bt_same_size (int bt1, int bt2)
{
  return ((_basetype_size[bt1] == _basetype_size[bt2]) && 
	  (_basetype_size[bt1] > 0) && 
	  (_basetype_extent[bt1] == _basetype_extent[bt2]));
}


/*
   @FUN:
   @DOES: given the number of a datatype and the length, a d gets a 
    datatype assigned (either MPI predefined or new, depending on the 
    value of number). Its name as a string is returned in *name, 
    the extent of this datatype is returned in size. When the selected 
    datatype is a fixed sized datatype, the *is_one is set to ONE, else
    to ARRAY. 
    In case the selected datatype (by number) is a fixed sized one, the value 
    of len is ignored. When the selected datatype a a variable sized one, 
    it is only created if len !=-1. (In case of len == -1, 
    *is_col is set, unless it is == NULL.) Iff the selected dataype 
    can be used within MPI_Reduce_... than 
    *is_col == TRUE.
    numbers  1 -- 19 denote MPI defined datatypes.
    number  20       denotes a user defined basetypes, selected by bt_number
    numbers 30 -- 37 denote fixed sized user defined types using the basetype
                     bt_number
    numbers 50 -- 58 denote variable sized user defined types using the 
                     basetype bt_number and len. len is not given in bytes, 
		     but in a datatype specific unit (e.g. number of 
		     basetypes, etc.)
		    
    not mentioned numbers here are thought for future enhancements of the
    abive categories.

    bt_number denotes the basetype to use to construct one of the types
    30 -- 58.

    In case *is_col == TRUE, it is possible to perform 
    reduce-operations with this datatype.
    Note that if len is zero, len is set locally to one.
   @PARAMETERS: 
    above.
   @RETURNES: 
    true, iff datatype successfully constructed
   @SIDEEFFECTS: 
    none
   @ASSUMES: 
    pointers d, size, extent, *name (sic!) are valid. is_coll, is_one or 
    name may be NULL.
    create_basetype has been called before for basetype bt_number.
   
*/
int create_datatype (int number, int bt_number, int len, 
		     MPI_Datatype *d, 
		     char **name, int *size, MPI_Aint *extent, 
		     int *is_one, int *is_col)
{
  static char _local_name[0xFF];
  int i, k;
  int isconstr = FALSE;

  /* temporarily used in this function */
  int *blen, *disp, *sublen;
  MPI_Aint *offset;
  MPI_Datatype *type;

#ifdef MPI_2
  int
    lb;  /* not used */
#endif
  D16(callcounter++;)
  if (_basetype_size[bt_number] == 0)
  {
    ERROR(USER,"the required basetype does not exist.");
    output_error(TRUE);
  }

  if (len == 0)
    len = 1;

  D13(fprintf(stderr, "in create_datatype, number %d, bt[%d]: %d\n", 
	      number, bt_number, _basetype[bt_number]);)

  switch(number)
  {
    /* MPI defined types */
  case 1:
    if (name != NULL)
      *name = "MPI_BYTE";
    *d = MPI_BYTE;
    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 2:
    if (name != NULL)
      *name = "MPI_CHAR";
    *d = MPI_CHAR;
    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 3:
    if (name != NULL)
      *name = "MPI_FLOAT";
    *d = MPI_FLOAT;
    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 4:
    if (name != NULL)
      *name = "MPI_DOUBLE";
    *d = MPI_DOUBLE;
    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 5:
    if (name != NULL)
      *name = "MPI_INT";
    *d = MPI_INT;
    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

    /* a base type, selected by bt_number */
  case 20:
    if (name != NULL)
      *name = _local_name;
    if (*name == NULL)
    {
      ERROR(NO_MEM,"allocating datatype buffers: name");
      output_error(TRUE);
    }

    sprintf (*name,"user defined basetype %d (%s)", bt_number + 1,
	     _basetype_name[bt_number]);
    
    *d = _basetype[bt_number];
    *size = _basetype_size[bt_number];
    *extent = _basetype_extent[bt_number];

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    D16(fprintf(stderr, "finnished %d create_datatype: typecounter %d\n", 
		callcounter, typecounter);)

    return (TRUE); /* since size and extent are set,
		      we can return here */

    /*  case 21 -- case 29 reserved for future special purpose 
	datatypes. */

    /* user defined types */
  case 30:
    if (name != NULL)
      *name = "contigous struct of basetype";
    /* contiguous same types */
    /*@1indoctypes30.tex*/
    MPI_Type_contiguous(params.blocks * params.blocksize,_basetype[bt_number],d);
    /*@1no*/
    D16(typecounter++;) MPI_Type_commit(d);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 31:
    if (name != NULL)
      *name = "vector of basetype";
    /* vector */
    /*@1indoctypes31.tex*/
    MPI_Type_vector(params.blocks,params.blocksize,params.vectorstride,_basetype[bt_number],d);
    /*@1no*/
    D16(typecounter++;) MPI_Type_commit(d);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 32:
    if (name != NULL)
      *name = "hvector of basetype";
    /* hvector */
    
    #ifdef MPI_2
    /*@1indoctypes32.tex*/
    MPI_Type_create_hvector(params.blocks,params.blocksize,params.vectorstride*
			    _basetype_size[bt_number],
			    _basetype[bt_number],d);
    /*@1no*/
    #else
    MPI_Type_hvector(params.blocks,params.blocksize,params.vectorstride*
		     _basetype_size[bt_number],
		     _basetype[bt_number],d);

    #endif
    D16(typecounter++;) MPI_Type_commit(d);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 33:
    if (name != NULL)
      *name = "indexed";
    /* indexed */
    blen = (int *)malloc(params.blocks *sizeof(int));
    disp = (int *)malloc(params.blocks *sizeof(int));
    if ((blen == NULL) || (disp == NULL))
    {
      ERROR(NO_MEM,"allocating datatype buffers");
      output_error(TRUE);
    }
    /*@1indoctypes33.tex*/
    blen[0] = params.blocksize;
    disp[0] = 0;
    k = 1;
    for (i=1; i<params.blocks; i++) 
    {
      blen[i] = params.blocksize-k;
      disp[i] = disp[i-1]+blen[i-1]+1;
      k = 1-k;
    }
    blen[params.blocks-1] += params.blocks/2;
    MPI_Type_indexed(params.blocks,blen,disp,_basetype[bt_number],d);
    /*@1no*/
    D16(typecounter++;) MPI_Type_commit(d);

    free(blen);
    free(disp);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;
#ifdef MPI_2
  case 34:
    if (name != NULL)
      *name = "block indexed";

    /* block indexed */
    /* indexed */
    disp = (int *)malloc(params.blocks *sizeof(int));
    if (disp == NULL)
    {
      ERROR(NO_MEM,"allocating datatype buffers");
      output_error(TRUE);
    }
    
    /*@1indoctypes34.tex*/
    /* requires MPI 2 */
    for (i=0; i<params.blocks; i++) 
    {
      disp[i] = params.blocksize*i+i;
    }
    MPI_Type_create_indexed_block(params.blocks,params.blocksize,disp,
				  _basetype[bt_number],d);
    /*@1no*/
    D16(typecounter++;) MPI_Type_commit(d);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;
#endif
  case 35:
    if (name != NULL)
      *name = "hindexed";

    /* hindexed */
    blen = (int *)malloc(params.blocks *sizeof(int));
    offset = (MPI_Aint *)malloc(params.blocks *sizeof(MPI_Aint));
    if ((blen == NULL) || (offset == NULL))
    {
      ERROR(NO_MEM,"allocating datatype buffers");
      output_error(TRUE);
    }
    /*@1indoctypes35.tex*/
    blen[0] = params.blocksize;
    offset[0] = 0;
    k = 1;
    for (i=1; i<params.blocks; i++) 
    {
      blen[i] = params.blocksize-k;
      offset[i] = offset[i-1]+blen[i-1]+1;
      k = 1-k;
    }
    for (i=0; i<params.blocks; i++) 
    {
      offset[i] *= _basetype_size[bt_number];
    }
    blen[params.blocks-1] += params.blocks/2;

    /*@1no*/
#ifdef MPI_2
    /*@1ap*/
    MPI_Type_create_hindexed(params.blocks,blen,offset,_basetype[bt_number],d);
    /*@1no*/
#else
    MPI_Type_hindexed(params.blocks,blen,offset,_basetype[bt_number],d);
#endif

    D16(typecounter++;) MPI_Type_commit(d);

    free(blen);
    free(offset);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

  case 36:
    if (name != NULL)
      *name = "homogenous struct";

    /* struct (homogenous) */
    blen = (int *)malloc(params.blocks *sizeof(int));
    offset = (MPI_Aint *)malloc(params.blocks *sizeof(MPI_Aint));
    type = (MPI_Datatype *)malloc(params.blocks *sizeof(MPI_Datatype));
    if ((blen == NULL) || (offset == NULL) || (type == NULL))
    {
      ERROR(NO_MEM,"allocating datatype buffers");
      output_error(TRUE);
    }
    /*@1indoctypes36.tex*/    
    blen[0] = params.blocksize;
    offset[0] = 0;
    type[0] = _basetype[bt_number];
    k = 1;
    for (i=1; i<params.blocks; i++) 
    {
      blen[i] = params.blocksize-k;
      offset[i] = offset[i-1]+blen[i-1]+1;
      type[i] = _basetype[bt_number];
      k = 1-k;
    }
    for (i=0; i<params.blocks; i++)
    {
      offset[i] *= _basetype_size[bt_number];
    }
    blen[params.blocks-1] += params.blocks/2;

    /*@1no*/
#ifdef MPI_2
    /*@1ap*/
    MPI_Type_create_struct(params.blocks,blen,offset,type,d);
    /*@1no*/
#else
    MPI_Type_struct(params.blocks,blen,offset,type,d);
#endif

    D16(typecounter++;) MPI_Type_commit(d);

    free(blen);
    free(offset);
    free(type);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;

#ifdef MPI_2
#ifdef ARRAYTYPES
  case 37:
    if (name != NULL)
      *name = "subarray";

    blen = (int *)malloc(params.blocks *sizeof(int));
    sublen = (int *)malloc(params.blocks *sizeof(int)); 
    type = (MPI_Datatype *)malloc(params.blocks *sizeof(MPI_Datatype));

    if ((blen == NULL) || (sublen == NULL) || (type == NULL))
    {
      ERROR(NO_MEM,"allocating datatype buffers");
      output_error(TRUE);
    }

    /* subarray */
    /*@1indoctypes37.tex*/
    /* requires MPI 2, especially subarrays */
    for (i=0; i<params.blocks; i++) 
    {
      blen[i] = SUBARRAYOFFSET+params.blocksize+SUBARRAYOFFSET;
      sublen[i] = params.blocksize;
      disp[i] = SUBARRAYOFFSET;
    }
    MPI_Type_create_subarray(params.blocks,blen,sublen,disp,MPI_ORDER_C,
			     _basetype[bt_number],d);
    /*@1no*/
    D16(typecounter++;) MPI_Type_commit(d);

    free(blen);
    free(sublen);
    free(type);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    isconstr = TRUE;
    break;
#endif
#endif

    /*  case 38 -- case 49 reserved for future fixed sized user defined 
	datatypes. */

    /* Dynamic types 
       depend on the parameter len, so when called with len == -1 
       they are not created and their size is not determined, but
       *is_col is set */

  case 50:
    if (name != NULL)
      *name = "dyn. vector 3";

    if (len != -1)
    {  
      /*@1indoctypes50.tex*/
      MPI_Type_vector(params.blocks,len*params.blocksize,len*params.vectorstride,
		      _basetype[bt_number], d);
      /*@1no*/
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;
  case 51:
    if (name != NULL)
      *name = "dyn. vector 2";

    if (len != -1)
    {
      /*@1indoctypes51.tex*/
      MPI_Type_vector(len,params.blocks*params.blocksize,
		      params.blocks*params.vectorstride,
		      _basetype[bt_number],d);
      /*@1no*/
      MPI_Type_commit(d);
      isconstr = TRUE;
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;
  case 52:
    D13(fprintf(stderr, "in create_datatype, case 52\n");)

    if (name != NULL)
      *name = "dyn. vector 1";

    if (len != -1)
    {  
      MPI_Aint
	myextent;
      D13(fprintf(stderr, "in create_datatype, case 52 - 1a len: %d\n", len);)
      /*@1indoctypes52.tex*/
      MPI_Type_vector(len*params.blocks,params.blocksize,params.vectorstride,
		      _basetype[bt_number],d);
#ifdef MPI_2
      MPI_Type_get_extent(*d, &lb, &myextent);
#else /* and that is still the default */
      MPI_Type_extent(*d, &myextent);
#endif
      


      D18(fprintf(stderr, "proc %d: in create_datatype, case 52 1b len: %d"\
		  ", blocks: %d, blocksize: %d, vs: %d, bssize: %d bs: %d,"\
		  "extent of created vector: %d\n", 
		  _skampi_myid, len,
		  params.blocks,params.blocksize,params.vectorstride,
		  _basetype_size[bt_number], _basetype[bt_number],
		  (int) myextent);)
      /*@1no*/
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    D13(fprintf(stderr, "in create_datatype, case 52 - 2\n");)

    break;

  case 53:
    if (name != NULL)
      *name = "dyn. homogenous struct 1";

    if (len != -1)
    {  
      blen = (int *)malloc(len * params.blocks *sizeof(int));
      offset = (MPI_Aint *)malloc(len * params.blocks *sizeof(MPI_Aint));
      type = (MPI_Datatype *)malloc(len * params.blocks *sizeof(MPI_Datatype));

      if ((blen == NULL) || (offset == NULL) || (type == NULL))
      {
	ERROR(NO_MEM,"allocating datatype buffers");
	output_error(TRUE);
      }

      /*@1indoctypes53.tex*/
      blen[0] = params.blocksize;
      offset[0] = 0;
      type[0] = _basetype[bt_number];
      k = 1;
      for (i=1; i<len*params.blocks; i++) 
      {
	blen[i] = params.blocksize-k;
	offset[i] = offset[i-1]+blen[i-1]+1;
	type[i] = _basetype[bt_number];
	k = 1-k;
      }
      for (i=0; i<len*params.blocks; i++) 
      {
	offset[i] *= _basetype_size[bt_number];
      }
      blen[i-1] += i/2;
      /*@1no*/
      #ifdef MPI_2
      /*@1ap*/
      MPI_Type_create_struct(len*params.blocks,blen,offset,type,d);
      /*@1no*/
      #else
      MPI_Type_struct(len*params.blocks,blen,offset,type,d);
      #endif
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
      free(blen);
      free(offset);
      free(type);

    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 54:
    if (name != NULL)
      *name = "dyn. homogenous struct 2";

    if (len != -1)
    {  
      blen = (int *)malloc(len *sizeof(int));
      offset = (MPI_Aint *)malloc(len * sizeof(MPI_Aint));
      type = (MPI_Datatype *)malloc(len * sizeof(MPI_Datatype));

      if ((blen == NULL) || (offset == NULL) || (type == NULL))
      {
	ERROR(NO_MEM,"allocating datatype buffers");
	output_error(TRUE);
      }

      /*@1indoctypes54.tex*/
      blen[0] = params.blocksize;
      offset[0] = 0;
      type[0] = _basetype[bt_number];
      k = 1;
      for (i=1; i<len; i++)
      {
	blen[i] = params.blocks*params.blocksize-k;
	offset[i] = offset[i-1]+blen[i-1]+1;
	type[i] = _basetype[bt_number];
	k = 1-k;
      }
      for (i=0; i<len; i++) 
      {
	offset[i] *= _basetype_size[bt_number];
      }
      blen[i-1] += i/2;
      /*@1no*/
      #ifdef MPI_2
      /*@1ap*/
      MPI_Type_create_struct(len,blen,offset,type,d);
      /*@1no*/
      #else
      MPI_Type_struct(len,blen,offset,type,d);
      #endif
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
      free(blen);
      free(offset);
      free(type);
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;


  case 55:
    if (name != NULL)
      *name = "dyn. homogenous struct 3";

    if (len != -1)
    {  
      blen = (int *)malloc(params.blocks *sizeof(int));
      offset = (MPI_Aint *)malloc(params.blocks *sizeof(MPI_Aint));
      type = (MPI_Datatype *)malloc(params.blocks *sizeof(MPI_Datatype));

      if ((blen == NULL) || (offset == NULL) || (type == NULL))
      {
	ERROR(NO_MEM,"allocating datatype buffers");
	output_error(TRUE);
      }
      
      /*@1indoctypes55.tex*/
      blen[0] = params.blocksize;
      offset[0] = 0;
      type[0] = _basetype[bt_number];
      k = 1;
      for (i=1; i<params.blocks; i++) 
      {
	blen[i] = len*params.blocksize-k;
	offset[i] = offset[i-1]+blen[i-1]+1;
	type[i] = _basetype[bt_number];
	k = 1-k;
      }
      for (i=0; i<params.blocks; i++) 
      {
	offset[i] *= _basetype_size[bt_number];
      }
      blen[i-1] += i/2;
      /*@1no*/
      #ifdef MPI_2
      /*@1ap*/
      MPI_Type_create_struct(params.blocks,blen,offset,type,d);
      /*@1no*/
      #else
      MPI_Type_struct(params.blocks,blen,offset,type,d);
      #endif

      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
      free(blen);
      free(offset);
      free(type);
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 56:
    if (name != NULL)
      *name = "dyn. vector 1";

    if (len != -1)
    {  
      /*@1indoctypes56.tex*/
      MPI_Type_vector(params.blocksize,len,len+params.vectorstride,
		      _basetype[bt_number],&bvector1);
      D16(typecounter++;) MPI_Type_commit(&bvector1); /* superfluous(?), but why not */
      MPI_Type_vector(params.blocks,1,2,bvector1,d);
      /*@1no*/
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 57:
    if (name != NULL)
      *name = "dyn. vector 2";

    if (len != -1)
    {  
      /*@1indoctypes57.tex*/
      MPI_Type_vector(len,params.blocksize,params.vectorstride,
		      _basetype[bt_number],&bvector2);
      D16(typecounter++;) MPI_Type_commit(&bvector2); /* superfluous(?), but why not */
      MPI_Type_vector(params.blocks,1,2,bvector2,d);
      /*@1no*/
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 58:
    if (name != NULL)
      *name = "dyn. vector 3";

    if (len != -1)
    {  
      /*@1indoctypes58.tex*/
      MPI_Type_vector(params.blocks,params.blocksize,params.vectorstride,
		      _basetype[bt_number],&bvector3);
      D16(typecounter++;) MPI_Type_commit(&bvector3); /* superfluous(?), but why not */
      MPI_Type_vector(len,1,2,bvector3,d);
      /*@1no*/
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
    }

    if (is_one != NULL)
      *is_one = ONE;
    if (is_col != NULL)
      *is_col = TRUE;
    break;
  case 61:
    if (name != NULL)
      *name = "nested vector-vector";


      /*@1indoctypes61.tex*/
      MPI_Type_vector(params.blocksize,1,2,_basetype[bt_number],&bvector);
      MPI_Type_commit(&bvector);
      MPI_Type_vector(params.blocks,1,2,bvector,d);
      /*@1no*/
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;


    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 62:
    if (name != NULL)
      *name = "nested vector-index";


      blen = (int *)malloc(params.blocksize *sizeof(int));
      disp = (int *)malloc(params.blocksize *sizeof(int));
      if ((blen == NULL) || (disp == NULL))
        {
          ERROR(NO_MEM,"allocating datatype buffers");
          output_error(TRUE);
        }
      /*@1indoctypes62.tex*/
      for (i=0; i<params.blocksize; i++)
        {
          blen[i] = 1;
          disp[i] = 2 * i;
        }
      MPI_Type_indexed(params.blocksize,blen,disp,
                       _basetype[bt_number],&bindex);
      MPI_Type_commit(&bindex);
      MPI_Type_vector(params.blocks,1,2,bindex,d);
      D16(typecounter++;) MPI_Type_commit(d);
      /*@1no*/
      free(blen);
      free(disp);
      isconstr = TRUE;

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 63:
    if (name != NULL)
      *name = "nested index-vector";


      blen = (int *)malloc(params.blocks *sizeof(int));
      disp = (int *)malloc(params.blocks *sizeof(int));
      if ((blen == NULL) || (disp == NULL))
        {
          ERROR(NO_MEM,"allocating datatype buffers");
          output_error(TRUE);
        }

      /*@1indoctypes63.tex*/
      MPI_Type_vector(params.blocksize,1,2,_basetype[bt_number],&bvector);
      MPI_Type_commit(&bvector);
      for (i=0; i<params.blocks; i++)
        {
          blen[i] = 1;
          disp[i] = 2*i;
        }
      MPI_Type_indexed(params.blocks,blen,disp,bvector,d);
      D16(typecounter++;) MPI_Type_commit(d);
      isconstr = TRUE;
      /*@1no*/
      free(blen);
      free(disp);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 64:
    if (name != NULL)
      *name = "nested index-index";

      blen = (int *)malloc(MAX(params.blocks,params.blocksize) *sizeof(int));
      disp = (int *)malloc(MAX(params.blocks,params.blocksize) *sizeof(int));
      if ((blen == NULL) || (disp == NULL))
        {
          ERROR(NO_MEM,"allocating datatype buffers");
          output_error(TRUE);
        }

    /*@1indoctypes64.tex*/

      for (i=0; i<params.blocksize; i++)
        {
          blen[i] = 1;
          disp[i] = 2*i;
        }
      MPI_Type_indexed(params.blocksize,blen,disp,_basetype[bt_number],&bindex);
      MPI_Type_commit(&bindex);

      for (i=0; i<params.blocks; i++)
        {
          blen[i] = 1;
          disp[i] = 2*i;
        }
      MPI_Type_indexed(params.blocks,blen,disp,bindex,d);
      D16(typecounter++;) MPI_Type_commit(d);
      /*@1no*/
      free(blen);
      free(disp);
      isconstr = TRUE;

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    break;

  case 70:
    if (name != NULL)
      *name = "special type 1";
    blen = (int *)malloc(params.blocks *sizeof(int));
    offset = (MPI_Aint *)malloc(params.blocks *sizeof(MPI_Aint));
    type = (MPI_Datatype *)malloc(params.blocks *sizeof(MPI_Datatype));
    disp = (int *)malloc(params.blocks *sizeof(int));
    if ((blen == NULL) || (offset == NULL) || (type == NULL) || (disp == NULL))
    {
      ERROR(NO_MEM,"allocating datatype buffers");
      output_error(TRUE);
    }

    /*@1indoctypes70.tex*/
    /* Special types (assume here that BLOCKSIZE>=3) */

    MPI_Type_vector(params.blocks,1,params.blocksize,_basetype[bt_number],&comp1);
    D16(typecounter++;)MPI_Type_commit(&comp1);
    for (i=0; i<params.blocks; i++) {
      blen[i] = 1;
      disp[i] = i*params.blocksize;
    }
    MPI_Type_indexed(params.blocks,blen,disp,_basetype[bt_number],&comp2);
    D16(typecounter++;)MPI_Type_commit(&comp2);
    for (i=0; i<params.blocks; i++) {
      blen[i] = params.blocksize-2;
      offset[i] = i*params.blocksize*_basetype_size[bt_number];
      type[i] = _basetype[bt_number];
    }
    #if MPI_2
    MPI_Type_create_struct(params.blocks,blen,offset,type,&comp3);
    #else
    MPI_Type_struct(params.blocks,blen,offset,type,&comp3);
    #endif
    D16(typecounter++;)MPI_Type_commit(&comp3);
    blen[0] = 1; offset[0] = 0; type[0] = comp1;
    blen[1] = 1; offset[1] = _basetype_size[bt_number]; type[1] = comp2;
    blen[2] = 1; offset[2] = 2*_basetype_size[bt_number]; type[2] = comp3;
    #ifdef MPI_2
    MPI_Type_create_struct(3,blen,offset,type,d);
    #else
    MPI_Type_struct(3,blen,offset,type,d);
    #endif
    /*@1no*/
    D16(typecounter++;) MPI_Type_commit(d);

    if (is_one != NULL)
      *is_one = ARRAY;
    if (is_col != NULL)
      *is_col = TRUE;
    free(disp);
    free(blen);
    free(offset);
    free(type);
    isconstr = TRUE;
    break;

  default:
    D16(fprintf(stderr, "finnished %d create_datatype: typecounter %d\n", 
		callcounter, typecounter);)
    return (FALSE);
  }

#define GET_SIZE

#ifdef GET_SIZE
  /* if type is constructed, then calculate size.
     The type is constructed iff is is 
     a non-dynamic type. */ 
  if (isconstr == TRUE) 
#endif
  {
#ifdef MPI_2
    MPI_Type_get_extent(*d, &lb, extent);
#else /* and that is still the default */
    MPI_Type_extent(*d, extent);
#endif

    MPI_Type_size (*d,size);
  }
#ifdef GET_SIZE
  else
  {
    *size = 1;
    *extent = (MPI_Aint) 1;
  }
#endif
  D13(fprintf(stderr, "create_datatype finnished\n");)
  D16(fprintf(stderr, "finnished %d create_datatype: typecounter %d\n", 
	      callcounter, typecounter);)
    
  return (TRUE);
}

/*
   @FUN:
   @DOES: calls MPI_Type_free for the MPI_Datatype d. number is used to 
     check, whether this datatype is not a predefined datatype or a basetype.
     number is also used to free specific auxiliary datatypes.
   @PARAMETERS: above.
   @RETURNES: nothing
   @SIDEEFFECTS: none
   @ASSUMES: datatype to free has been created before. 
   But that is not checked.
*/
void free_datatype (int number, MPI_Datatype *d)
{
  D16(callcounter++;)

  /* beachte: nie ein vordefiniertes oder basetype d zerstoeren. */
  if (number < 20)
  {
    D16(fprintf(stderr, "finnished %d free_datatype: typecounter %d\n",
		callcounter, typecounter);)
    return;
  }
  switch (number)
  {
    /* MPI defined datatypes, basetypes, and fixed sized user defined
       datatypes can be handled equally. */
  case 1: break;
  case 2: break;
  case 3: break;
  case 4: break;
  case 5: break;
  case 6: break;
  case 7: break;
  case 8: break;
  case 9: break;
  case 10: break;
  case 11: break;
  case 12: break;
  case 13: break;
  case 14: break;
  case 15: break;
  case 16: break;
  case 17: break;
  case 18: break;
  case 19: break;
  case 20: break;
  case 30: break;
  case 31: break;
  case 32: break;
  case 33: break;
  case 34: break;
  case 35: break;
  case 36: break;
  case 37: break;
  case 50: break;
  case 51: break;
  case 52: break;
  case 53: break;
  case 54: break;
  case 55: break;

    /* free auxiliary types */
  case 56:
    if (bvector1 != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&bvector1);
    }
    break;

  case 57:
    if (bvector2 != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&bvector2);
    }
    break;


  case 58:
    if (bvector3 != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&bvector3);
    }
    break;


  case 61:
    if (bvector != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&bvector);
    }
    break;

  case 62:
    if (bindex != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&bindex);
    }
    break;

  case 63:
    if (bvector != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&bvector);
    }
    break;

  case 64:
    if (bindex != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&bindex);
    }
    break;

  case 70:
    if (comp1 != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&comp1);
    }
    if (comp2 != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&comp2);
    }
    if (comp3 != MPI_DATATYPE_NULL)
    {
      D16(typecounter--;) MPI_Type_free (&comp3);
    }
    break;



  default:
      ERROR(INTERN,"unknown datatype number in free_datatype");
      output_error(TRUE);
  }

  if ((*d != MPI_BYTE) && (*d != MPI_INT) && (*d != MPI_LONG) &&
      (*d != MPI_DOUBLE) && (*d != MPI_LONG_DOUBLE) && (*d!=MPI_DATATYPE_NULL))
    {
      D16(typecounter--;) MPI_Type_free(d);
    }
  D16(fprintf(stderr, "finnished %d free_datatype: typecounter %d\n",
	      callcounter, typecounter);)

}

/*
   @FUN:
   @DOES:
    convertes *len from unit byte to unit elements of this datatype.
    That is, *len gives the number of bytes in a send or receive buffer,
    when this function is called. After the function returned, *len denotes
    the maximum number of elements of datatype_number which fit in such a
    buffer.
   @PARAMETERS:
    The datatype is given by datatype_number, its
    basetype_number (bt_number) and by itself (d).
   @RETURNES: nothing
   @SIDEEFFECTS: none
   @ASSUMES:
    in case datatype_number < 50, the datatype
    denoted by datatype_number must have been created before.
    But that is not checked.
*/
void adjust_last_argument (int datatype_number, int bt_number,
			   MPI_Datatype d, long int *len)
{
#ifdef MPI_2
  int
    lb;  /* not used */
#endif
  MPI_Aint
    extent;

  switch (datatype_number)
  {
    /* MPI defined datatypes, basetypes, and fixed sized user defined
       datatypes can be handled equally. */
  case 1:
  case 2:
  case 3:
  case 4:
  case 5:
  case 6:
  case 7:
  case 8:
  case 9:
  case 10:
  case 11:
  case 12:
  case 13:
  case 14:
  case 15:
  case 16:
  case 17:
  case 18:
  case 19:
  case 20:
  case 30:
  case 31:
  case 32:
  case 33:
  case 34:
  case 35:
  case 36:
  case 37:
  case 61:
  case 62:
  case 63:
  case 64:
#ifdef MPI_2
    MPI_Type_get_extent(d, &lb, &extent);
#else /* and that is still the default */
    MPI_Type_extent(d, &extent);
#endif
    *len /= ((long int)extent);
    break ;
    /* variable sized datatypes must be handled different */
  case 50:
    *len /= ((long int)(params.blocks * params.vectorstride *
			((long int)_basetype_extent[bt_number])));
    break ;

  case 51:
    *len /= ((long int)(params.blocks * params.vectorstride *
			((long int)_basetype_extent[bt_number])));
    break ;

  case 52:
    D18(fprintf(stderr, "proc %d: in adjust_last_argument-before, len: %ld",
		_skampi_myid, *len);)
    *len /= ((long int) (params.blocks * params.vectorstride *
			((long int)_basetype_extent[bt_number])));
    D18(fprintf(stderr, "proc %d: in adjust_last_argument-after, len: %ld"\
		", blocks: %d, blocksize: %d, vs: %d, bssize: %d bs: %d\n",
		_skampi_myid, *len,
		params.blocks,params.blocksize,params.vectorstride,
		_basetype_size[bt_number], _basetype[bt_number]);)

    break ;

  case 53:
    *len /= ((long int)(params.blocks * (params.blocksize + 1) *
			((long int)_basetype_extent[bt_number])));
    break ;

  case 54:
    *len = ((long int)(*len - params.blocks * ((long int)_basetype_extent[bt_number]))) /
      ((long int)((params.blocks * params.blocksize + 1) *
		  ((long int)_basetype_extent[bt_number])));
    break ;

  case 55:
    *len /= ((long int)(params.blocks * (params.blocksize + 1)*
			((long int)_basetype_extent[bt_number])));
    break ;

  case 56:
#if 0 /* old version, off by a factor of ten */
    *len = ((long int)(*len - (2 * params.blocks * params.blocksize *
			       params.vectorstride *
			       ((long int)_basetype_extent[bt_number])))) /
      ((long int)(2 * params.blocks * params.blocksize *
		  params.vectorstride * ((long int)_basetype_extent[bt_number])));
#else /* revised version RR */
    *len = (*len / ((long int) (2L * params.blocks * params.blocksize *
				(long int) _basetype_extent[bt_number])))
      - ((long int)params.vectorstride);
#endif /*old / new version */
    break ;

  case 57:
    *len /= ((long int)(2 * params.blocks * params.vectorstride *
			((long int)_basetype_extent[bt_number])));
    break ;

  case 58:
    *len /= ((long int)(2 * params.blocks * params.vectorstride *
			((long int)_basetype_extent[bt_number])));
    break ;

  case 70:
    *len /= ((long int)(params.blocks * params.blocksize *
			((long int)_basetype_extent[bt_number])));
    break;

  default:
      ERROR(INTERN,"unknown datatype number in adjust_last_argument");
      output_error(TRUE);
  }
  *len /= 4;
  *len *= 4;

}


/*
   @FUN:
   @DOES: initializes the message buffer (should be called before sends)
   to clear the cache.
   @PARAMETERS: the buffer *buf and its length
   @RETURNES: nothing
   @SIDEEFFECTS: none.
   @ASSUMES: nothing
*/
void initialize_data(char *buf, long int length)
{
  long int
    i;
  for (i = 0; i < length; i++)
#if 0
    buf[i] = rand() % 0x100;
#else
    buf[i] = 0;
#endif
}



void _skampi_reduce_op_c(void *invec, void *inoutvec, int *len,
			 MPI_Datatype *type)
{
  int i;
  int pos;

  pos = 0;
  D18(fprintf(stderr,"proc %d: in reduce_op: attempting to pack %d units"\
	      " in a buffer of size %d, buffer at %p\n",
	      _skampi_myid, *len,_skampi_reduce_buffer_size, 
	      _skampi_reduce_buffer);)

  MPI_Pack(invec,*len,*type,_skampi_reduce_buffer,
	   _skampi_reduce_buffer_size,&pos,_current_comm);
  pos = 0;
  MPI_Unpack(_skampi_reduce_buffer,_skampi_reduce_buffer_size,
	     &pos,inoutvec,*len,*type,_current_comm);
}


/*
   @FUN:
   @DOES: writes the message msg to the logfile (which also can be
   stdout or stderr. If it is really a file it will be opend and closed.
   @PARAMETERS: above.
   @RETURNES: TRUE iff successful,
   FALSE in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_myid and log_file_name set.
*/
int 
write_to_log_file (char *msg)
{
#ifndef SEQ
  if (_skampi_myid == 0)
#endif /*SEQ*/
  {
    FILE 
      *log_file = NULL;
    
    if (!strcmp (  log_file_name,"stderr"))
      log_file = stderr;
    else if (!strcmp (  log_file_name,"stdout"))
      log_file = stdout;
    else
      log_file = fopen (log_file_name,"a+");
    
    if (log_file == NULL)
    {
      fprintf (stderr,"***Error opening log file %s.\n"\
	       "logging only on stderr\n%s\n***",
	       log_file_name, msg);
      return (FALSE);
    }
#ifndef SEQ
    fprintf (log_file,"Process %d: %s", _skampi_myid, msg);
#else
    fprintf (log_file,"%s", msg);
#endif /*SEQ*/
    fclose (log_file);
  }
#ifndef SEQ
  else
    printf ("Process %d: %s", _skampi_myid, msg);
#endif /*SEQ*/
  return (TRUE);
}

/* **************** routines for logging *************************** */
/*
   @FUN:
   @DOES: builds a printable string string containing most of the data stored
   in *ms.
   @PARAMETERS: above.
   @RETURNES: pointer to this string.
   @SIDEEFFECTS: uses _skampi_msg (as little buffer...)
   @ASSUMES: nothing.
*/
char *
measurement_data_to_string (measurement_t *ms, char *string)
{
  char 
    *pattern_str = NULL,
    *x_scale_str = NULL,
    *node_times_str = NULL;
        
  char 
    default_values_str[0xFF],
    time_suite_str[0xFF],
    unit_str[0x2FF],
    var_str[0x310];

  int
    message_len = -1,
    chunks = -1;
  

  if (string == NULL)
    if ((string = (char *) malloc (0x1000)) == NULL)
      return ("");

  switch (ms->pattern)
  {
#ifndef SEQ
  case P2P:
    pattern_str = "Point-to-Point";
    message_len = ms->data.p2p_data.len;
    break;
  case MASTER_WORKER:
    pattern_str = "Master-Worker";
    message_len = ms->data.mw_data.len;
    chunks = ms->data.mw_data.chunks;
    break;
  case COLLECTIVE:
    pattern_str = "Collective";
    message_len = ms->data.col_data.len;
    break;
#else
  case SEQMEAS:
    pattern_str = "Sequential-Measurement";
    message_len = ms->data.seqmeas_data.arg;
    break;
#endif
  case SIMPLE:
    pattern_str = "Simple";
    break;
  }

  if (ms->send_datatype_number>=20) 
  {
    if (ms->send_kind_type_meas == ARRAY) 
    {
      sprintf (unit_str," basetype %d (%s), send-datatype %d: "\
	       "size %d Byte%s, extent %d Byte%s (%s), receive-datatype %d: "\
	       "size %d Byte%s, extent %d Byte%s (%s)", 
	       ms->basetype_number + 1, _basetype_name[ms->basetype_number], 
	       ms->send_datatype_number, 
	       ms->send_datatype_size, (ms->send_datatype_size==1)?"":"s",
	       (int) ms->send_datatype_extent,
	       (((int) ms->send_datatype_extent)==1)?"":"s",
	       ms->send_datatype_name,
	       ms->recv_datatype_number,
	       ms->recv_datatype_size, 
	       (ms->recv_datatype_size==1)?"":"s",
	       (int) ms->recv_datatype_extent,
	       (((int) ms->recv_datatype_extent)==1)?"":"s",
	       ms->recv_datatype_name);
    }
    else
    {
      if (ms->recv_kind_type_meas == ARRAY)
      {
	sprintf (unit_str," basetype %d (%s), send-datatype %d: (%s)"\
		 ", receive-datatype %d: "\
		 "size %d Byte%s, extent %d Byte%s (%s)", 
		 ms->basetype_number + 1, _basetype_name[ms->basetype_number], 
		 ms->send_datatype_number, 
		 ms->send_datatype_name,
		 ms->recv_datatype_number,
		 ms->recv_datatype_size, 
		 (ms->recv_datatype_size==1)?"":"s",
		 (int) ms->recv_datatype_extent,
		 (((int) ms->recv_datatype_extent)==1)?"":"s",
		 ms->recv_datatype_name);
      }
      else
      {
	sprintf (unit_str," basetype %d (%s), send-datatype %d: (%s)"\
		 ", receive-datatype %d: (%s)",
		 ms->basetype_number + 1, _basetype_name[ms->basetype_number], 
		 ms->send_datatype_number, 
		 ms->send_datatype_name,
		 ms->recv_datatype_number,
		 ms->recv_datatype_name);
      }
    }
  }
  else
  {
    sprintf (unit_str," sender:%s, receiver %s", ms->send_datatype_name,
	     ms->recv_datatype_name);
  }
  switch (ms->variation)
  {
  case LENGTH:
    sprintf (var_str,"message_length [bytes in type: %s] (%%d)",
	     unit_str);
    break;
  case CHUNK:
    sprintf (var_str,"chunks [pieces of work, %s] (%%d)", unit_str);
    chunks = -1;
    break;
  case NODES:
    sprintf (var_str,"number_of_nodes [number, %s] (%%d)", unit_str);
    break;
  }

  default_values_str[0] = 0;
  if (ms->variation != LENGTH && message_len != -1)
    sprintf (default_values_str,", message length %d units",message_len);

  if (chunks != -1)
  {
    sprintf (_skampi_msg,", chunks %d",chunks);
    strcat (default_values_str, _skampi_msg);
  }

  switch (ms->x_scale)
  {
  case FIXED_LIN:  
    x_scale_str = "linear, no automatic x wide adaption";
    break;
  case FIXED_LOG:
    x_scale_str = "logarithmic, no automatic x wide adaption";
    break;
  case DYN_LIN:
    x_scale_str = "linear, automatic x wide adaption";
    break;
  case DYN_LOG:
    x_scale_str = "logarithmic, automatic x wide adaption";
    break;

  }

  if (!ms->node_times)
    node_times_str = "";
  else
    node_times_str = "(node_times [microsec.] (%6.1f) )+";


  if (ms->time_suite == (double) INVALID)
    strcpy(time_suite_str,"disabled");
  else
    sprintf(time_suite_str,"%4.2f",ms->time_suite);

  if (ms->pattern != SIMPLE)
    sprintf (string,"#Description of the %s measurement:\n"\
	     "#Pattern: %s varied over the %s.\n"\
	     "#The x scale is %s\n"\
	     "#range: %d - %d, stepwidth: %f.\n"\
	     "#default values: %d nodes%s, max. / act. time for "\
	     "suite %s/%4.2f min.\n"\
	     "#max. allowed standard error is %3.2f %%, "\
	     "cut quantile is %3.2f %%\n"\
	     "#Format: <args> %s (%%8d) <results> time_cleaned [microsec.] "\
	     "(%%9.1f) "\
	     "standard_error_cleaned [microsec.] (%%8.1f) count_cleaned "\
	     "[number] (%%6d) time_all [microsec.] (%%9.1f) "\
	     "standard_error_all [microsec.] (%%8.1f) count_all "\
	     "[number] (%%6d) %s\n",
	     ms->name, pattern_str, 
	     var_str, x_scale_str, 
	     ms->x_start_bytes, ms->x_end_bytes, ms->x_stepwidth,
	     ms->nodes, default_values_str,
	     time_suite_str, ms->act_time_suite,
	     ms->standard_error * 100, ms->cut_quantile * 100, var_str, 
	     node_times_str);
  else
    sprintf (string,"#Description of the %s measurement:\n"\
	     "#Pattern: %s.\n#\n#\n#\n"\
	     "#max. allowed standard error is %3.2f %%, cut quantile "\
	     "is %3.2f %%\n"\
	     "#Format: <args> (%%8d) <results> time_cleaned [microsec.] "\
	     "(%%9.1f) standard_error_cleaned [microsec.] (%%8.1f) "\
	     "count_cleaned [number] (%%6d) time_all [microsec.] (%%6.2f) "\
	     "standard_error_all [microsec.] (%%8.1f) count_all [number] "\
	     "(%%6d)\n\n",
	     ms->name, pattern_str, ms->standard_error * 100, 
	     ms->cut_quantile * 100);

    /* note: routines read_header / write_header assume that every header has 
       HEADER_LINES lines (defined in skampi_tools.h )
     */
  return (string);
}

/* ******************* routines for output processing **************** */

#if 0 /*(now done in perl-script dorep.pl) */
void
measurement_data_to_tex_module (measurement_t *ms)
{
  FILE
    *file;   /* the gnuplot command-file */

  char
    file_name[FN_LEN],
    buffer[LINE_LEN];
  

  sprintf (file_name,"%s.tmd", ms->name); /* tmd = tex module */

  /* only create file if it not exists */
  if ((file = fopen (file_name,"r")) == NULL)
  {
    char 
      *pattern_str = NULL,
      *var_str = NULL,
      *x_scale_str = NULL;

    fclose (file);
    if ((file = fopen (file_name,"w")) == NULL)
    {
      sprintf (_skampi_msg, "gnuplot command-file %s.", file_name);
      ERROR(FILE_OPEN,_skampi_msg);
      output_error (TRUE);
    }

    switch (ms->pattern)
    {
    case P2P:
      pattern_str = "Point-to-Point";
      break;
    case SIMPLE:
      pattern_str = "Simple";
      break;
    case MASTER_WORKER:
      pattern_str = "Master-Worker";
      break;
    case COLLECTIVE:
      pattern_str = "Collective";
      break;
    }
    
    switch (ms->variation)
    {
    case LENGTH:
      var_str = "message length";
      break;
    case CHUNK:
      var_str = "chunks (number of pieces of work)";
      break;
    case NODES:
      var_str = "number of nodes";
      break;
    }
    
    
    switch (ms->x_scale)
    {
    case FIXED_LIN:  
      x_scale_str = "linear, no automatic x wide adaption";
      break;
    case FIXED_LOG:
      x_scale_str = "logarithmic, no automatic x wide adaption";
      break;
    case DYN_LIN:
      x_scale_str = "linear, automatic x wide adaption";
      break;
    case DYN_LOG:
      x_scale_str = "logarithmic, automatic x wide adaption";
      break;
      
    }

    backslashify (buffer, ms->name);
    
    if (ms->pattern != SIMPLE)
    {
      fprintf (file,"\\subsection{%s}\n"\
	       "\\begin{itemize}\n"\
	       "\\item Pattern: %s varied over the %s\n"\
	       "\\item x scale: %s\n"\
	       "\\item range: %d - %d\n"\
	       "\\item stepwidth: %d\n"\
	       "\\item max. allowed standard error is %f %%\n"\
	       "\\end{itemize}\n",
	       buffer, pattern_str, 
	       var_str, x_scale_str, ms->x_start, ms->x_end, ms->x_stepwidth,
	       ms->standard_error * 100);
      fprintf (file, "\\begin{figure}[Htb]\n"\
	       "\\begin{center}\n"\
	       "\\epsfig{file=%s.eps}\n"\
	       "\\end{center}\n"\
	       "\\caption{Measurement %s varied over %s.}\n"\
	       "\\label{%s}\n"\
	       "\\end{figure}\n",
	       ms->name, buffer, var_str, ms->name);
    }
    else
    {
      fprintf (file,"\\subsection{ %s}\n"\
	       "\\item Pattern: %s\n"\
	       "\\item max. allowed standard error is %f %%\n"\
	       "\\end{itemize}\n",
	       buffer, pattern_str, ms->standard_error * 100);
    }
  }
}

char *
backslashify (char *dest, char *source)
{
  while (*source)
  {
    if (*source == '_')
      *dest++ = '\\';
    *dest++ = *source++;
  }

  *dest = '\0';
  return (dest);
}

void
measurement_data_to_gpl_command_file (measurement_t *ms)
{
  FILE
    *file;   /* the gnuplot command-file */

  char
    file_name[FN_LEN];

  if (ms->pattern == SIMPLE)
    return;  /* do not create graphics for the simple pattern (only ONE
		value!!) */

  sprintf (file_name,"%s.gpl", ms->name);

  /* only create file if it not exists */
  if ((file = fopen (file_name,"r")) == NULL)
  {
    char
      *x_log_scale,
      *y_log_scale ="",
      *x_label,
      *y_label;

    fclose (file);
    if ((file = fopen (file_name,"w")) == NULL)
    {
      sprintf (_skampi_msg, "gnuplot command-file %s.", file_name);
      ERROR(FILE_OPEN,_skampi_msg);
      output_error (TRUE);
    }

    switch (ms->variation)
    {
    case LENGTH:
      x_label = "\"message length\"";
      break;
    case CHUNK:
      x_label = "\"chunks (number of pieces of work)\"";
      break;
    case NODES:
      x_label = "\"number of nodes\"";
      break;
    default:
      x_label = "\"\"";
      break;
    }
	
    y_label = "\"time (sec.)\"";


    if(ms->x_scale == FIXED_LOG || ms->x_scale == DYN_LOG)
    {
      x_log_scale = "set logscale x 2\n";
#if 0
      y_log_scale = "set logscale y 2\n";
#endif
    }
    else
    {
      x_log_scale = "";
      y_log_scale = "";
    }
      

    fprintf (file, "#gnuplot command-file for the measurement %s\n"\
	     "set nologscale\n"\
	     "set xtics\n"\
	     "set ytics\n"\
	     "set key 200, 100\n"\
	     "set term postscript eps 18\n"\
	     "#set terminal x11\n"\
	     "set xlabel %s\n"\
             "set ylabel %s\n"\
	     "%s%s"\
	     "set output \"%s.eps\"\n"\
	     "plot [x=%d:%d] \"%s.ski\" using 1:2 title \"%s\" with linesp\n",
             ms->name, x_label,y_label, x_log_scale, y_log_scale,
	     ms->name, ms->x_start, ms->x_end,
	     ms->name,ms->name);
    fclose (file);
  }
}
#endif
/*
   @FUN:
   @DOES: reads header (containing HEADER_LINES lines)
   of the measurement at the current position of
   the file-pointer into text.
   @PARAMETERS: above.
   @RETURNES: the manipulated file_handle.
   @SIDEEFFECTS: none.
   @ASSUMES: *file is a valid file handle of on open file, and its file-pointer
   really points to a header.
*/
FILE * 
read_header (FILE *file, text_t *text)
{
  char 
    line[LINE_LEN];

  int
    i;

  for (i = 0; i < HEADER_LINES; i++)
  {
    if (fgets (line, LINE_LEN, file) == NULL)
      return (NULL);
#if 0
    if (strstr (line, "#") == NULL)
      return (NULL);
#endif
    line[LINE_LEN - 1] = '\0';
    insert_in_text (line, text, i);
  }
  return (file);
}

/*
   @FUN:
   @DOES: writes the header (containing HEADER_LINES lines)
   stored in *text in the file,
   this header will be named name there.
   @PARAMETERS: above.
   @RETURNES: the manipulated file-handel.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
FILE * 
write_header (FILE *file, text_t *text, char *name)
{
  char 
    line[LINE_LEN];

  int
    i;
  
  fprintf (file,"\n#-------------------------------\n#/*@""in%s ",name);  /* space after %s important for
		                          dorep.pl !!! */
  for (i = 0; i < HEADER_LINES-1; i++)
  {
    if ((fprintf (file, "%s\n",read_from_text (line, text, i))) == 0)
    {
      ERROR(FILE_WRITE,"writing header");
      output_error (TRUE);
    }
  }
  return (file);
}
    
/*
   @FUN:
   @DOES: writes text to file *file in a section s.
   note: file is ** so that writing in file changes the filepointer! 
   @PARAMETERS: above.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void 
write_text_to_file (text_t *text, char *s, FILE **file)
{
  int
    i;

  if ((*text)[0] != NULL)
  {
    fprintf (*file, "#%s %s\n", s, (*text)[0]);
    for (i = 1; (*text)[i] != NULL; i++)
      fprintf (*file, "#%s\n",(*text)[i]);
  }
}


/*
   @FUN:
   @DOES: inserts line into array text at position pos.
   (Note: text is (should) always (be) an NULL-Pointer terminated array.
   @PARAMETERS: above.
   @RETURNES: pointer to text,
   or NULL in case of error.
   @SIDEEFFECTS: none.
   @ASSUMES: text points to array of TEXT_LINES char *
   or is NULL (than allocates).
*/
text_t *
insert_in_text (char *line, text_t *text, int pos)
{
  int len = strlen (line);

  if (pos >= TEXT_LINES)
  {
    ERROR (USER,"too many text lines ");
    return (NULL);
  }

  if (text == NULL)
    if ((text = (text_t *) malloc (sizeof(char *) * TEXT_LINES)) == NULL)
    {
      ERROR (NO_MEM,"parameter inserting");
      return (NULL);
    }
  
  if (((*text)[pos] = (char *)malloc (len + 1)) == NULL) /* adding +1 for the 
							    \0 */
  {
    ERROR (NO_MEM,"parameter inserting");
    return (NULL);
  }
  
  strcpy ((*text)[pos], line); 
  (*text)[pos][len - 1] = 0;  /* do not copy the \n character */
  (*text)[pos + 1] = NULL;

  return (text);
}

/*
   @FUN:
   @DOES: reads the textline at position pos from text and stores it 
   at line.
   @PARAMETERS: above.
   @RETURNES: pointer to line.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
char *
read_from_text (char *line, text_t *text, int pos)
{
  if (pos >= TEXT_LINES)
  {
    ERROR (USER,"too many text lines ");
    return (NULL);
  }

  if (text == NULL)
  {
    ERROR (USER,"text points to NULL ");
    return (NULL);
  }

  strcpy (line,(*text)[pos]); 
  return (line);
}

/*
   @FUN:
   @DOES: free-es all memory occupied by the textlines. If mode == DYNAMIC
   it free-es also the pointer-array text. (Call with mode == STATIC if not
   wanted.)
   @PARAMETERS: above.
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void
free_text (text_t *text, int mode)
{
  int 
    i = 0;

  while ((*text)[i] != NULL)
    free ((*text)[i++]);

  if (mode == DYNAMIC)
    free (text);
}


  
/*
   @FUN:
   @DOES: reads the old log_file (which is the log_file of the previous run),
   to analyze which measurements run before, and which failed.
   The results are send from process 0 to all others in default_communicator.
   @PARAMETERS: name of the old log_file (log_file_str),
   an integer array (work_array), which will be filled with control-info.
   the initialized array of all measurements.
   @RETURNES: pointer to modified work_array.
   @SIDEEFFECTS: none.
   @ASSUMES: _skampi_myid and default_communicator set.
*/
int *
read_old_log_file (char *log_file_str, int *work_array, measurement_t *ms,
		   int number_of_measurements)
{
#ifndef SEQ
  if (_skampi_myid == 0)
  {
#endif /*SEQ*/
    FILE 
      *log_file;
    int 
      i,
      start_found = number_of_measurements;
    
    char 
      line[LINE_LEN];
    
    if (work_array == NULL)
      if ((work_array = (int *) malloc (sizeof (int) * number_of_measurements))
	  == NULL)
      {
	ERROR (NO_MEM,"read_old_log_file");
	output_error (TRUE);
      }
    
    if (!strcmp (log_file_str,"stdout") || !strcmp (log_file_str,"stderr"))
      goto send_array;    /* no old info accessable */

    if ((log_file = fopen (log_file_str, "r")) == NULL)
      goto send_array;    /* no old info accessable */

    
    while (fgets(line, LINE_LEN, log_file) != NULL)
    {
      char 
	buf[0x500];
      
      for (i = 0; i < number_of_measurements; i++)
      {
	sprintf (buf,"%s failed", ms[i].name);
	if (strstr(line,buf) != NULL)
	{
	  /* only mark a benchmark as failed, if the
	     user wants to run also in this run. */
	  if (work_array[i] == TODO)  					 
	    work_array[i] = FAILED;
	  break;
	}	
	
	sprintf (buf,"%s started", ms[i].name);
	if (strstr(line,buf) != NULL)
	{
	  start_found = i;

	  /* only mark a benchmark as failed, if the
	     user wants to run also in this run. */
	  if (work_array[i] == TODO)  					 
	    work_array[i] = FAILED;
	  break;
	}	
	
	sprintf (buf,"%s ended", ms[i].name);
	if (strstr(line,buf) != NULL)
	{
	  if (start_found == i)
	  {
	    work_array[i] = SKIP;
	    break;
	  }
	  else
	  {
	    fprintf (stderr,"corrupted log file %s\nskip reading!\n",
		     log_file_str);
	    fclose (log_file);
	    return (work_array);
	  }	
	}      
      }
    } 
    fclose (log_file);
  send_array:
#ifndef SEQ
    MPI_Bcast (work_array, number_of_measurements, MPI_INT, 0, 
	       default_communicator);
  }
  else /* so not process 0 */
    MPI_Bcast (work_array, number_of_measurements, MPI_INT, 0, 
	       default_communicator);
#endif /*SEQ*/  
  return (work_array);
}

/* ******************* output file management ************************* */
/*
   @FUN:
   @DOES: returnes a new output_file_name which is name.<number> with number
   high enough, the the returned name is new.
   @PARAMETERS: the name which to append with the number.
   @RETURNES: a pointer to the new name.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
char *
new_name (char *name)
{
  static char
    n_name[FN_LEN];

  sprintf (n_name,"%s.%d", name, number_of_output_files (name) + 1);

  return (n_name);
}

/*
   @FUN:
   @DOES: returnes max value for files existing in working directory
   with <name>.<return_value> 
   assumed that if <name>.n exists than also <name>.n - 1 exists, 
   unless n = 1 
   @PARAMETERS: above.
   @RETURNES: above. (or NULL in case of error.)
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int 
number_of_output_files (char *name)
{
  FILE
    *file_dummy;

  int 
    appendix = 1;
 
  char 
    n_name[0x100];

  if (name == NULL) /* for safety */
    return (FALSE);

  for (;; appendix++)
  {
    sprintf (n_name,"%s.%d", name, appendix);
    if ((file_dummy = fopen (n_name,"r")) != NULL)
      fclose (file_dummy);
    else
      break;
  }
  /* fopen failed at last call, so decrease appendix */
  return (--appendix); 
}

/*
   @FUN:
   @DOES: tests if file is a complete skampi output file.
   @PARAMETERS: above.
   @RETURNES: TRUE iff complete, FALSE otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int 
output_file_complete (FILE *file)
{
  char 
    line[LINE_LEN];
  
  int 
    slen = strlen (FINISHED_MSG);

  /* move to last line*/
#if 0
  fseek (file, SEEK_CUR, (-1) * slen);
  fgets (line, 0x100, file);
#else
  rewind (file);
  while (fgets (line, 0x100, file) != NULL)
    ;
#endif
  return (strncmp (line, FINISHED_MSG, slen) == 0);
}

/*
   @FUN:
   @DOES: tests if file is a skampi output file, which was
   created by postprocessing.
   @PARAMETERS: above.
   @RETURNES: TRUE iff postprocessed, FALSE otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int 
output_file_postprocessed (FILE *file)
{
  char 
    line[LINE_LEN];
  
  /* move to last line*/
#if 0
  fseek (file, SEEK_CUR, (-1) * slen);
  fgets (line, 0x100, file);
#else
  rewind (file);
  while (fgets (line, 0x100, file) != NULL)
    if (strstr (line, "postproc") != NULL)
	return (TRUE);
#endif
  return (FALSE);
}

/*
   @FUN:
   @DOES: creates log file and renames evtl existing log file of previous
   run.
   @PARAMETERS: none.
   @RETURNES: nothing.
   @SIDEEFFECTS: prints error messages in case of trouble.
   @ASSUMES: _skampi_myid set.
*/
void 
create_log_file (void)
{
  FILE 
    *log_file = NULL;

  int
    remove_flag = FALSE,  /* stores result of remove(log_file) */
    rename_flag= FALSE;   /* stores result of rename 
			     log_file to <log_file>.old */
#ifndef SEQ
  if (_skampi_myid == 0) 
#endif
  {
    if (strcmp ( log_file_name,"stderr")
	&& strcmp ( log_file_name,"stdout"))
    {
      remove_flag = remove (old_log_file_name);
      /* order of parameters of rename is ok !! */
      rename_flag = rename (log_file_name, old_log_file_name); 
      
      if ((log_file = fopen (log_file_name,"w+")) == NULL)
      {
	ERROR(FILE_OPEN,"creating log file");
	output_error(FALSE);
      }

      fprintf (stdout,"log file %s successfully created.\n",
	       log_file_name);
      fclose (log_file);
      
      if (remove_flag == 0) /* that means remove has been successful */
      {
	sprintf (_skampi_msg, "old log-file %s removed\n",old_log_file_name);
	write_to_log_file (_skampi_msg);
      }
      
      if (rename_flag == 0) /* that means rename has been successful */
      {
	sprintf (_skampi_msg, "renamed old log-file %s to %s\n",
		 log_file_name, old_log_file_name);
	write_to_log_file (_skampi_msg);
      }
    }
  }
}

/*
   @FUN:
   @DOES: creates new output file and determines if a complete previous run
   has been performed. (then *new_run is set to TRUE.) The value of 
   new_run is sent to all other processes in default_communicator.
   @PARAMETERS: above.
   @RETURNES: nothing.
   @SIDEEFFECTS: prints error messages in case of trouble.
   @ASSUMES: _skampi_myid and default_communicator set.
*/
void 
create_output_file (int *new_run)
{
  FILE
    *output_file;
#ifndef SEQ
  if (_skampi_myid == 0)
  {
#endif /*SEQ*/
    /* test if file exists */

    if ((output_file = fopen (out_file_name,"r")) == NULL)
    {
      /* fclose (output_file); fixed RR 23.4.98 */
      
      if ((output_file = fopen (out_file_name,"a+")) == NULL)
      {
	ERROR(FILE_OPEN,"creating output file");
	output_error(TRUE);
      }
      *new_run = TRUE;
    }
    else
    {
      /* if output_file exists and is complete */
      if (output_file_complete (output_file))  
      {
	*new_run = TRUE;
	if (!output_file_postprocessed (output_file))
	{
	  /* rename it to oldname ++ ".<newnumber>" */
	  fclose (output_file);
	  strcpy (new_out_file_name, new_name (out_file_name));
	  rename (out_file_name, new_out_file_name);
	  sprintf (_skampi_msg,"Output file %s renamed to %s.\n",
		   out_file_name, new_out_file_name);
	  write_to_log_file (_skampi_msg);
	}
	/* create new output file */
	if ((output_file = fopen (out_file_name,"w+")) == NULL)
	{
	  ERROR(FILE_OPEN,"creating output file");
	  output_error(TRUE);
	}
      }
      else
	*new_run = FALSE;
    }
    write_head_of_outfile (&output_file,"");
    fclose (output_file);
    sprintf (_skampi_msg,"Output file %s successfully created.\n",
	     out_file_name);
    write_to_log_file (_skampi_msg);
#ifndef SEQ
    MPI_Bcast (new_run, 1, MPI_INT, 0, default_communicator);
  }
  else
    MPI_Bcast (new_run, 1 ,MPI_INT, 0, default_communicator);
#endif /*SEQ*/
}

/*
   @FUN:
   @DOES: extracts from the RCS id string the version number 
   @PARAMETERS: Pointer to the target string and pointer to 
   rcsstring
   @RETURNES: Pointer to target string
   @SIDEEFFECTS: writes to targetpointer the version number
   @ASSUMES: nothing.
*/
char *
ExtractVersionNumber ( char * PtrTarget, char * PtrSource )
{
  int i,j;
  
  for (i=0; !isdigit ( PtrSource[i] ); i++ );
  
  for (j=0 ; !isspace ( PtrSource[i] ); 
       PtrTarget[j]=PtrSource[i], i++, j++ );
  
  PtrTarget[j] = 0;
  return PtrTarget;
}

/*
   @FUN:
   @DOES: writes the head of the outfile (i.e. the machine, node, 
   network, user and absolute -section of the params file.
   @PARAMETERS: a pointer to a filehandle, and a string (no_runs), which 
   can contain the number of skampi-runs used for postprecessing. 
   (This option is only used by postprocessing.)
   @RETURNES: nothing.
   @SIDEEFFECTS: manipulates file (sets the filepointer ahead).
   @ASSUMES: numprocs set
*/

void
write_head_of_outfile (FILE **file, char *no_runs)
{
  time_t time_buf;
  char *time_str;
  char version[100];
  char basetype_str[0xFF];
  #ifndef WIN
  struct utsname MyName;
  #endif
  /*  struct tm localdate;
      int err=0; 
  */
  int
    i; 

  write_text_to_file (&(params.machine), "@MACHINE", file);  
  write_text_to_file (&(params.node), "@NODE", file);
  write_text_to_file (&(params.network), "@NETWORK", file);
  write_text_to_file (&(params.user), "@USER", file);

  fprintf (*file,"#@NAMEOFRUN %s / SKaMPI Ver. %s\n",params.run_name[0],
	  ExtractVersionNumber ( version, rcsid ));

  fprintf (*file,"#@INSTITUTION ** please fill in the name and the "\
	   "location of your institution here **\n");


  /*
  getdate_r ( "%m/%d/%Y", localdate, &err );
  if (err == 0 )
    fprintf ( *file, "#@DATE %i/%i/%i\n", localdate.tm_mon, localdate.tm_mday, 
	     localdate.tm_yday );
  */

  /* Versionnumber only in skosfile version */

  fprintf (*file,"#@SKAMPIVERSION %s\n", ExtractVersionNumber ( version, rcsid ) );
  #ifndef WIN
  if ( uname ( &MyName ) == -1 )
    {
      fprintf ( stdout, "uname failed. Filling with dummy values.\n" );
      fprintf ( *file, "#@OSNAME none\n" );
      fprintf ( *file, "#@OSRELEASE none\n"  );
      fprintf ( *file, "#@OSVERSION none\n" );
      fprintf ( *file, "#@HOSTNAME none\n" );
      fprintf ( *file, "#@ARCHITECTURE none\n" );
    }
  else
    {
      fprintf ( *file, "#@OSNAME %s\n", MyName.sysname );
      fprintf ( *file, "#@OSRELEASE %s\n", MyName.release );
      fprintf ( *file, "#@OSVERSION %s\n", MyName.version );
      fprintf ( *file, "#@HOSTNAME %s\n", MyName.nodename );
      fprintf ( *file, "#@ARCHITECTURE %s\n", MyName.machine );
    }
  #else
      fprintf ( stdout, "uname n/a. Filling with dummy values.\n" );
      fprintf ( *file, "#@OSNAME WINDOOZE\n" );
      fprintf ( *file, "#@OSRELEASE ?\n"  );
      fprintf ( *file, "#@OSVERSION ?\n" );
      fprintf ( *file, "#@HOSTNAME none\n" );
      fprintf ( *file, "#@ARCHITECTURE PC Cluster\n" );
  #endif
#ifndef SEQ
  fprintf (*file,"#@NODES %d\n",numprocs); 
  /* set in main, before call of create_output_file */

  for (i = 0; i < MAX_BASETYPES; i++)
  {
    sprintf(basetype_str,"@BASETYPE%d",i + 1);
    if (params.basetypes[i][0] != NULL)
      write_text_to_file (&(params.basetypes[i]), basetype_str, file);
  }
#endif /*SEQ*/
  fprintf (*file,"#@ABSOLUTE %s\n",
	   (params.absolute == 1) ? "yes":"no");
	
  /* time stamp */
  if (time (&time_buf) == ((time_t) (-1)))
    time_str = "**no time availabel**";
  else
    time_str = asctime (localtime (&time_buf));
  fprintf ( *file, "#@DATE %s\n",time_str);
  fprintf(*file, "#@BLOCKS %d\n#@BLOCKSIZE %d\n#@VECTORSTRIDE %d\n",
	  params.blocks, params.blocksize, params.vectorstride);
  if (strlen (no_runs) > 0)
    fprintf (*file,"#@POSTPROC %s\n",
	     (params.post_proc == 1) ? no_runs:"no");
}

/*
   @FUN:
   @DOES: interpolates a double at value between (arg1,res1) and (arg2,res2).
   @PARAMETERS: above.
   @RETURNES: pointer to the interpolated data-struct.
   @SIDEEFFECTS: allocates new data element if data == NULL.
   @ASSUMES: nothing.
*/
double 
linear_interpolate (double arg_inter, double arg1, double arg2, 
			   double res1, double res2)
{
  if (arg1 == arg2)
    return ((res1 + res2) / 2);

  return (res1 + (arg_inter - arg1) * 
	  (res2 - res1) / (arg2 - arg1));
}
/*
   @FUN:
   @DOES: determines the system's clock accessible resolution 
   @PARAMETERS: none
   @RETURNES: resolution
   @SIDEEFFECTS: none
   @ASSUMES: nothing
*/

double clock_resolution(void)
{
#ifdef SEQ
  clock_t
    start_time,
    end_time;

  long int 
    i;

  for (i = 0, start_time = clock(); ;++i)
  {
    end_time = clock();
    if ((end_time - start_time) >=1)
      break;
  }

  return (((double)(end_time - start_time)) / ((double)CLOCKS_PER_SEC));
#else
  return (MPI_Wtick());
#endif /*SEQ*/
}



/*
   @FUN:
   @DOES: in the parallel case: initializes global variables
   numprocs, _skampi_myid, default_communicator, processor_name
   in all cases: Fills global variables repetitions, 
   out_file_name, log_file_name, 
   old_log_file_name. Reads PARAMETER_FILE, the old log file, creates
   the output file and the new log file. Sets the pointers (!) 
   measurements_array and work_array (There given as **).
   measurements_array is an array of all suites of measurements described
   in the parameter file. Suite i is described in a measurements_t struct
   (*measurements_array)[i].
   If suite i has to be perfomed (*work_array)[i] is set to TODO, else
   to SKIP.
   *number_of_measurements is set to the size of these arrays.
   Also *new_run is set to TRUE iff this run is not a continuation 
   of an aborted run.
   Allocates memory (also calls allocate_mem). 
   @PARAMETERS: above.
   @RETURNES: nothing.
   @SIDEEFFECTS: aborts in case of errors (IO or memory)
   prints messages to stdout (if #define O(A) A).
   @ASSUMES: mentioned global variables defined, MPI_Init called
*/
void init_skalib (measurement_t **measurements_array, 
		  int **work_array, int *number_of_measurements)
{
  int 
    new_run,
#ifdef IO_CHECK
    io_flag,      /* dummy flag for MPI_Attr_get-Call */
    io_node,      /* node, which can perform ANSI-C - IO */
#endif
#ifndef SEQ
    namelen,      /* used as dummy from MPI_Get_processor_name */
#endif /*SEQ*/
    i;            /* for loops */           


  
#ifndef SEQ
  MPI_Comm_size(MPI_COMM_WORLD,&numprocs);

  if (numprocs > MAX_PROCESSORS)
  {
    ERROR(INTERN,"SKaMPI started with more than MAX_PROCESSORS.\n"\
	  "Please incerase MAX_PROCESSORS in module skampi.h\nand recompile.");
    output_error(TRUE);
  }

  MPI_Comm_rank(MPI_COMM_WORLD,&_skampi_myid);
  MPI_Get_processor_name(processor_name,&namelen);

  default_communicator = MPI_COMM_WORLD;

  MPI_Type_size(MPI_INT,&intsize);
  MPI_Type_size(MPI_LONG,&longintsize);
  MPI_Type_size(MPI_DOUBLE,&doublesize);
  MPI_Type_size(MPI_LONG_DOUBLE,&longdoublesize);

  MPI_Op_create (_skampi_reduce_op_c, 0, &_skampi_reduce_op);

#endif
#ifndef SEQ
#ifdef IO_CHECK
  MPI_Attr_get (MPI_COMM_WORLD, MPI_IO, &io_node, &io_flag);

  if (_skampi_myid == 0 && io_flag)
    if (*io_node != 0 && *io_node != MPI_ANY_SOURCE)
    {
      ERROR(INTERN,"node 0 has no IO facility");
      output_error(TRUE);
    }
#endif /* IO_CECK */
#endif /*SEQ*/

  *measurements_array = read_parameters (PARAMETER_FILE, &params, 
					 number_of_measurements);

  for (i = 0; i < *number_of_measurements; i++)
  {
#ifndef SEQ
    (*measurements_array)[i].communicator = default_communicator;
    (*measurements_array)[i].nodes = numprocs;
#endif /*SEQ*/
    (*measurements_array)[i].act_time_suite = 0.0;
  }

  if ((*work_array = malloc (*number_of_measurements * sizeof (int))) == NULL)
  {
    ERROR (NO_MEM,"for work_array");
    output_error (TRUE);
  }
#ifndef SEQ
  if (_skampi_myid == 0)
#endif
  {
    repetitions = (long int) (clock_resolution() * WISHED_RESOLUTION);

    if (repetitions == 0)
      repetitions = 1; /* in case the clock is higher than the wished res. */
  }

#ifndef SEQ
  MPI_Bcast(&repetitions, 1, MPI_LONG, 0, MPI_COMM_WORLD); 
  /* each node should have the root's resolution. */
#endif

  out_file_name = params.out_file[0];
  log_file_name = params.log_file[0];

  strcpy (old_log_file_name,log_file_name);
  strcat (old_log_file_name,".old");

  O(printf("creating log file %s\n", log_file_name);)
  create_log_file();

#ifndef SEQ
  sprintf (_skampi_msg,"Process %d on %s\n", _skampi_myid, processor_name);
  write_to_log_file (_skampi_msg);
#endif

  O(printf("creating output file %s\n", out_file_name);)
  create_output_file(&new_run);

#ifndef SEQ
  O(printf("proc.: %d: allocating %d Kbytes global memory\n", 
	   _skampi_myid, params.memory);)
#else
  O(printf("allocating %d Kbytes global memory\n", params.memory);)
#endif /*SEQ*/

  if (!allocate_mem (params.memory * 1024))
  {
    ERROR(NO_MEM,"allocating global buffers");
    output_error(TRUE);
  }
  
  /* this time should never be  succeeded by any time measured. */
  /* Changed to #if 0 Matthias Mueller 20.2.1998 */
#if 0
  _critical_min_time = min_time();
#else
  _critical_min_time = 0.0;
#endif

#ifndef SEQ
  O(fprintf(stderr,"proc.:%d: global memory successfully allocated.\n", 
	    _skampi_myid);)
#else
  O(fprintf(stderr,"global memory successfully allocated.\n");)
#endif /*SEQ*/
  for (i = 0; i < *number_of_measurements; i++)
    (*work_array)[i] = TODO;
  
  if (!new_run)
  {
    O(printf("reading old log file\n");)
    read_old_log_file (old_log_file_name, *work_array, *measurements_array, 
		       *number_of_measurements);
  }
#ifndef SEQ
  D2(fprintf(stderr,"proc.:%d: here at 1.\n", _skampi_myid);)
#else
  D2(fprintf(stderr,"here at 1.\n");)
#endif /*SEQ*/
}


/*
   @FUN:
   @DOES: performs measurement stored in measurements_array (with its tag in
   work_array set to TODO. Writes results in outfile and remarks in logfile. 
   number_of_measurements is the size of these arrays.
   @PARAMETERS: above.
   @RETURNES: nothing.
   @SIDEEFFECTS: aborts in case of errors (IO or memory)
   prints messages to stdout (if #define O(A) A).
   @ASSUMES: init_skalib called or equivalent operations performed
*/
void perform_measurements (measurement_t *meas_array, 
		  int *wa, int *number_of_meas)
{
  int
    i,            /* for loops */
    all_skip;     /* TRUE iff nothing to do */

  /* Do measurements */
  for (all_skip = TRUE, i = 0; i < *number_of_meas; i++)
    if (wa[i] != SKIP)
      all_skip = FALSE;

#ifndef SEQ
  D2(fprintf(stderr,"proc.:%d: here at 2.\n", _skampi_myid);)
#else
  D2(fprintf(stderr,"here at 2.\n");)
#endif /*SEQ*/

  if (all_skip == FALSE)
  {
    for (i = 0; ; i= (i+1) % *number_of_meas)
    {
#ifndef SEQ
      MPI_Barrier(MPI_COMM_WORLD);
#endif /*SEQ*/
      
      if (wa[i] == SKIP)
      {
#ifndef SEQ
	if (_skampi_myid == 0)
#endif /*SEQ*/
	{
	  sprintf (_skampi_msg,"%s skipped\n", 
		   meas_array[i].name);
	  write_to_log_file (_skampi_msg);
	}
      }
      else if (wa[i] == DONE)
	break;
      else if (wa[i] == FAILED)
      {
	wa[i] = TODO;
#ifndef SEQ
	if (_skampi_myid == 0)
#endif /*SEQ*/
	{
	  fprintf(stderr,"It seems that the measurement %s has been failed\n",
                  		  meas_array[i].name);
          fprintf(stderr,"in the last run. Now it will be repeated"\
		  "after all other\n" );
          fprintf(stderr,"selected measurements.\n");
          fprintf(stderr,"If you want to ommit it at all, "\
		  "you may delete the entry\n");
          fprintf(stderr,"%s\nin the section @MEASUREMENTS of the file %s.\n",
	  meas_array[i].name,  PARAMETER_FILE);
          
	  sprintf (_skampi_msg,"%s failed\n", 
		   meas_array[i].name);
	  write_to_log_file (_skampi_msg);
	}
	continue;   /* so the failed measurement will be attempted in the
		       next (!) turn (after number_of_meas steps) */
      }
      else if (wa[i] == TODO)
      {
	time_t time_buf;
	char *time_str;
	
#ifndef SEQ
	if (_skampi_myid == 0)
#endif /*SEQ*/
	{	
	  /* time stamp start */
	  if (time (&time_buf) == ((time_t) (-1)))
	    time_str = "**no time available**\n";
	  else
	    time_str = asctime (localtime (&time_buf));
	  
	  sprintf (_skampi_msg,"%s started at %s\n", 
		   meas_array[i].name, time_str);
	  write_to_log_file (_skampi_msg);
	}
	
	if (!measure (meas_array + i))
	{
	  output_error (FALSE);
	  break;
	}
	
#ifndef SEQ
	if (_skampi_myid == 0)
#endif /*SEQ*/
	{      
	  /* time stamp end */
	  if (time (&time_buf) == ((time_t) (-1)))
	    time_str = "**no time available**\n";
	  else
	    time_str = asctime (localtime (&time_buf));
	  
	  sprintf (_skampi_msg,"%s ended at %s\n", 
		   meas_array[i].name, time_str);
	  write_to_log_file (_skampi_msg);
	}
	wa[i] = DONE;
      }  
    }
  }
  else
  {
    sprintf (_skampi_msg,"nothing to do: all choosen measurements from %s \n"\
	     "are marked as done in log-file %s\n",PARAMETER_FILE,
	     log_file_name);
    write_to_log_file (_skampi_msg);
  }
#ifndef SEQ
  D2(printf("Proc.: %d:before last barrier\n",_skampi_myid);)
  MPI_Barrier (MPI_COMM_WORLD);
  D2(printf("Proc.: %d:behind last barrier\n",_skampi_myid);)
  if (_skampi_myid == 0)
#endif /*SEQ*/
  {
    FILE
      *output_file;

    if ((output_file = fopen (out_file_name,"a+")) != NULL)
    {
      fprintf (output_file,"/*@""no*/\n%s", FINISHED_MSG);
      fclose (output_file);
    }
    sprintf (_skampi_msg, "%s", FINISHED_MSG);
    write_to_log_file (_skampi_msg);

    /* call postprocessing */
    if (params.post_proc)
    {
      O(printf("starting post processing.\n");)
      post_processing (out_file_name);
      O(printf("post processing done.\n");)
    }
  }
  free_mem();
#ifndef SEQ
  O(printf("Proc.: %d: %s\n",_skampi_myid, FINISHED_MSG);)
#else/*SEQ*/
  O(printf("%s\n", FINISHED_MSG);)
#endif /*SEQ*/
#ifndef SEQ
#if 1
  MPI_Finalize();
#else
  MPI_Abort(MPI_COMM_WORLD, 0);
#endif /*1*/
#endif /*SEQ*/

}

/* private prototypes */
static char   *read_all_lists_of_next_meas (void);
static int     read_one_list_of_meas       (int index, char *meas);
static int     find_meas                   (int index, char *search);
static char   *skip_to_next_meas           (int index);
static int     init_post_proc              (char *input_file_name);
static void    free_post_proc              (void);
static void    free_all_lists              (void);
static data_t *interpolate_data            (int value, data_t *left, 
					    data_t *right, data_t *data);
static int     all_finished                (int *vector);
       int     data_cmp (const void *d1,const void *d2); /* for qsort */
					 

/* private globals */
static int
  nif,                      /* number of input files */
  *finished;                /* used to determine termination in 
			       combine_lists */
static FILE 
  **input_files;            /* array of nif input files */

static data_list_t          
  *lists;                   /* array of nif data_lists */ 

static list_item_t
  **items;                  /* array of nif pointers to list_items */

static data_t
  *new_data;                /* array of nif data elements */

static text_t               
  header;                   /* the textlines of the header */

static char
  m_name[FN_LEN];         /* name of measurement */



/*
   @FUN:
   @DOES: complete postprocessing.
   @PARAMETERS: name of input_file (which is the outputfile in skampi usually)
   a pointer to the array of measurements (not needed now, because
   measurement_data_to_gpl_command_file and  measurement_data_to_tex_module
   are now implemented in the perl-script dorep.pl.
   nom: number of measurements. (some as with ms).
   @RETURNES: TRUE. (return-type is int for further errormamagement)
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: params-struct is filled when called.
*/
int
post_processing (char *input_file_name)
{
  FILE
    *output_file;
  
  data_list_t
    result_list;

  char
    no_runs_str[0x100];

  init_post_proc (input_file_name);
#if 0  /* now done in the perl-skript dorep.pl */
  for (i = 0; i < nom; i++)
  {
    measurement_data_to_gpl_command_file (ms + i);
    measurement_data_to_tex_module (ms + i);
  }
#endif
  if (nif == 0)  
    return (TRUE); /* nothing to do, if only one outputfile exists */

  init_list (&result_list);

  if ((output_file = fopen (input_file_name,"w")) == NULL)
  {
    sprintf (_skampi_msg,"opening output file %s\n", input_file_name);
    ERROR (FILE_OPEN,_skampi_msg);
    output_error (TRUE);
  }

  sprintf (no_runs_str,"%d times.", nif);

  write_head_of_outfile (&output_file,no_runs_str);
  
  while (read_all_lists_of_next_meas() != NULL)  /* the header is read here */
  {
#ifndef MODULE_TEST
    combine_lists (&result_list);
    free_all_lists ();
    output_file = write_header (output_file, &header, m_name);
    free_text (&header, STATIC);
    D4(fprintf(stderr,"*************** post_processing aaaa ***************\n");)
    D4(write_header (stderr, &header, m_name);)
    D4(fprintf(stderr,"*************** post_processing bbbb ***************\n");)
    D4(write_to_file (&result_list,stderr);)
    D4(fprintf(stderr,"*************** post_processing eeee ***************\n");)
    
    if (write_to_file (&result_list, output_file) != DL_NO_ERROR)
    {
      ERROR (FILE_WRITE,"postprocessing output\n");
      output_error (TRUE);
    }
    free_data_list (&result_list, STATIC);
#else
    int
      a;
    for (a = 0; a < nif; a++)
      write_to_file (lists + a, stderr);
    write_header (stderr, &header, m_name);
    free_all_lists ();
    free_data_list (&result_list, STATIC);
#endif

  }
  fprintf (output_file,"/*@""no*/\n%s-postprocessed", FINISHED_MSG);  
  fclose (output_file);
  
  free_post_proc();
  return (TRUE);
}

/*
   @FUN:
   @DOES: initializes all static variables of this module and
   opens all input_files (== output_files of skampi).
   @PARAMETERS: name of input_file.
   @RETURNES: TRUE. (return-type is int for further errormamagement)
   @SIDEEFFECTS: aborts in case of error.
   @ASSUMES: nothing.
*/
int 
init_post_proc (char *input_file_name)
{
  FILE
    *file;
  
  int
    i;

  char
    n_name[FN_LEN];
 
  nif = number_of_output_files (input_file_name);
  /* note that nomenclatura in module skampi_tools is reverse
     to here: output_files there are the input_files here */
    
  /* if there are other output-files and 
     if input_file exists and is not a previous postprocessed file
     rename it to input_file_name.<nif + 1> */
  if ((nif > 0) && ((file = fopen (input_file_name,"r")) != NULL))
  {
    if (!output_file_postprocessed (file))
    {
      fclose (file);
      rename (input_file_name, new_name (input_file_name));
      nif++;
    }
    else
      fclose (file);
  }

  if (nif == 0)
    return (TRUE);

  /* allocating around */
  if ((input_files = malloc (nif * sizeof (FILE *))) == NULL)
  {
    ERROR(NO_MEM,"for postprocessing - 1");
    output_error (TRUE);
  }

  if ((lists = malloc (nif * sizeof (data_list_t))) == NULL)
  {
    ERROR(NO_MEM,"for postprocessing - 2");
    output_error (TRUE);
  }

  if ((items =  malloc (nif * sizeof (list_item_t *))) == NULL)
  {
    ERROR(NO_MEM,"for postprocessing - 3");
    output_error (TRUE);
  }

  if ((new_data = malloc (nif * sizeof (data_t))) == NULL)
  {
    ERROR(NO_MEM,"for postprocessing - 4");
    output_error (TRUE);
  }

  if ((finished = malloc (nif * sizeof (int))) == NULL)
  {
    ERROR(NO_MEM,"for postprocessing - 5");
    output_error (TRUE);
  }

  /* initialize the whole stuff */
  for (i = 0; i < nif; i++)
  {
    sprintf (n_name,"%s.%d", input_file_name, i + 1);
    if ((input_files[i] = fopen (n_name,"r")) == NULL)
    {
      sprintf (_skampi_msg,"file: %s\n", n_name);
      ERROR(FILE_OPEN,_skampi_msg);
      output_error (TRUE);
    }

    init_data(new_data + i, 0);
    init_list (lists + i);
    items[i] = NULL;
  }

  return (TRUE);
}


/*
   @FUN:
   @DOES: free-es all allocated memory for internal use and closes all
   here opened files
   @PARAMETERS: none.
   @RETURNES: nothing.
   @SIDEEFFECTS: on the internal variables.
   @ASSUMES: init_post_proc run before.
*/
void
free_post_proc (void)
{
  int
    i;

  for (i = 0; i < nif; i++)
  {
    fclose (input_files[i]);
    free_data(new_data + i, STATIC);  /* STATIC since array is freed below */
  }
  
  free (finished);
  free (new_data);
  free (items);
  free (input_files);
  free (lists);  /* the single lists are freeed in free_all_lists */
}

/*
   @FUN:
   @DOES: free-es all data elements of every list.
   It does NOT free the array of lists (this is done in free_post_proc.)
   @PARAMETERS: none.
   @RETURNES: nothing
   @SIDEEFFECTS: on the data stored in the lists.
   @ASSUMES: nothing.
*/
void
free_all_lists (void)
{
  int
    i;

  for (i = 0; i < nif; i++)
    free_data_list (lists + i, STATIC);
}

/*
   @FUN:
   @DOES: skips to next measurement of file input_files[index]
   returnes name of that measurement
   @PARAMETERS: above.
   @RETURNES: name of the measurement found or NULL in case of EOF.
   @SIDEEFFECTS: on file pointer input_files[index]
   @ASSUMES: input_file[index] open (i.e. init_post_proc called before).
*/
char *
skip_to_next_meas (int index)
{
  static char
    line[LINE_LEN];

  char
    *local;
    
  do
    if (fgets (line, LINE_LEN, input_files[index]) == NULL)
      return (NULL);  /* eof reached */
  while ((local = strstr (line,"@in")) == NULL);

  return (local + strlen ("@in"));
}

/*
   @FUN:
   @DOES: finds measurement with the name *search in input_file[index]
   @PARAMETERS: additional: name of measurement to look for.
   @RETURNES:    returns TRUE iff found FALSE otherwise
   @SIDEEFFECTS: on file pointer input_files[index]
   @ASSUMES: input_file[index] open (i.e. init_post_proc called before).
*/
int
find_meas (int index, char *search)
{
  static char
    line[LINE_LEN];

  char
    *local;
    
  do
    if (fgets (line, LINE_LEN, input_files[index]) == NULL)
      return (FALSE);  /* eof reached */
  while ((local = strstr (line,search)) == NULL);

  return (TRUE);
}


/*
   @FUN:
   @DOES: reads measurement with the name *meas in input_file[index]
   into the list addressed by lists[index].
   @PARAMETERS: additional: name of measurement to look for.
   @RETURNES:    returns TRUE iff found FALSE otherwise
   @SIDEEFFECTS: on file pointer input_files[index] and on lists[index]
   @ASSUMES: input_file[index] open (i.e. init_post_proc called before).
*/
int
read_one_list_of_meas (int index, char *meas)
{
  int
    error = DL_NO_ELEM;

  char
    *next_meas;
  
#ifdef POSIX
  fpos_t
    fpos;

  fgetpos (input_files[index], &fpos);
#else
  long int
    filepos = ftell (input_files[index]);
#endif

  next_meas = skip_to_next_meas (index);

  if (next_meas == NULL) /* eof reached */
    return (FALSE);
  D4(fprintf(stderr,"*************** 1-1-1-1 ***************\n");)
  if (!strcmp (next_meas, meas))  /* next meas is the wanted */
    read_from_file (lists + index, input_files + index, &error);
  else /* so we have to find it */
  {
  D4(fprintf(stderr,"*************** 2-2-2-2 ***************\n");)
#ifdef POSIX
    fsetpos (input_files[index], &fpos); 
#else
    fseek (input_files[index], filepos, 0); /* 0 == SEEK_SET */
#endif
    if (find_meas (index, meas))
      read_from_file (lists + index, input_files + index, &error);

#ifdef POSIX
    fsetpos (input_files[index], &fpos); 
#else
    fseek (input_files[index], filepos, 0); /* 0 == SEEK_SET */
#endif
    /* jump back to old pos, because the next measurement tends to be there */
  }
  return (error == DL_NO_ERROR);
}


/*  */
/*
   @FUN:
   @DOES: reads all lists of next measurtement (the next means the next in 
   input_files[0]) and stores the read data in the lists **lists.
   @PARAMETERS: additional: name of measurement to look for.
   @RETURNES: returnes name of that meas iff success
   @SIDEEFFECTS: on file pointers input_files and on lists.
   @ASSUMES: init_post_proc called before.
*/
char *
read_all_lists_of_next_meas (void)
{
  int
    i,
    error;

  char
    *name;

  /* get the name of the next meas */
  if ((name = skip_to_next_meas (0)) == NULL)
    return (NULL); /* eof reached */

  strcpy (m_name,name);
  read_header (input_files[0], &header);
  read_from_file (lists, input_files, &error);
  D4(fprintf(stderr,"*************** 0000 ***************\n");)
  D4(write_to_file (lists,stderr);)
  /* read them all */
  for (i = 1; i < nif; i++)
  {
    if (!read_one_list_of_meas (i, m_name))
    {
      sprintf (_skampi_msg,"input_files %d, at measurement %s\n", i, m_name);
      ERROR(FILE_READ,_skampi_msg);
      output_error (TRUE);
    }
    D4(fprintf(stderr,"*************** %d%d%d%d ***************\n",i,i,i,i);)
    D4(write_to_file (lists,stderr);)
  }
  return (m_name);
}

/*
   @FUN:
   @DOES: combines all lists of the **lists-array to one new result_list.
   @PARAMETERS: above.
   @RETURNES: TRUE if result_list conaines really data elements.
   @SIDEEFFECTS: if result_list == NULL it is allocated and initialized.
   Aborts in case of error.
   @ASSUMES: result list is initialized unless it is NULL.
*/
int 
combine_lists (data_list_t *result_list)
{
  int
    i,
    error,
    inter_arg;   /* the argument where to interpolate */

  /* the usual checks... */
  if (result_list == NULL)
    if ((result_list = init_list (NULL)) == NULL)
    {
      ERROR(NO_MEM,"for result_list");
      output_error (TRUE);
    }
  

  /* fill items with the first list elements */
  for (i = 0; i < nif; i++)
  {
    items[i] = item_addr (lists + i, START, 0, &error); 
    finished[i] = FALSE;
  }
 

  while (! all_finished (finished))
  {
    data_t
      result_data;

    /* find min arg: the arg where to interpolate */
    inter_arg = (items[0])->data.arg;
    for (i = 1; i < nif; i++)
      if (finished[i] != TRUE)
	if ((items[i])->data.arg < inter_arg)
	  inter_arg = (items[i])->data.arg;
    
    for (i = 0; i < nif; i++)  /* for all lists */
    {
      list_item_t
	*left;

      /* find the right arg (need for interpolation) */
      if (finished[i] != TRUE)
	/* find ele right of inter_arg */
	while ((items[i])->data.arg <= inter_arg) 
	{
	  /* read next ele */
	  items[i] = item_addr_at_item (lists + i, items[i], 1, &error);
	  if (is_end (items[i]))
	    break;  /* the while loop */
	}

      if (is_end (items[i]) && (items[i])->data.arg == inter_arg)
      {
	copy_data(new_data + i, &(items[i]->data));  /* last ele */
	finished[i] = TRUE;  /* this list reached its end */
      }
      else
      {
	if (((items[i])->data.arg <= inter_arg) || (finished[i] == TRUE))  
	{  
	  /* there no right ele, so mark as invalid */
	  new_data[i].arg = -1;  
	  new_data[i].count_cleaned = 0;
	  new_data[i].result_cleaned = 0.0;
	  new_data[i].standard_error_cleaned = 0.0;
	  new_data[i].count_all = 0;
	  new_data[i].result_all = 0.0;
	  new_data[i].standard_error_all = 0.0;
	  finished[i] = TRUE;  /* this list reached its end */
	}
	else /* so found a 'right' element */
	{	
	  if (is_start (items[i])) 
	  {  /* right ele is the first (so no real left) */
	    new_data[i].arg = -1; /* mark as invalid */
	    new_data[i].count_cleaned = 0;
	    new_data[i].result_cleaned = 0.0;
	    new_data[i].standard_error_cleaned = 0.0;
	    new_data[i].count_all = 0;
	    new_data[i].result_all = 0.0;
	    new_data[i].standard_error_all = 0.0;
	  }
	  else /* found left and right */
	  {
	    left = item_addr_at_item (lists + i, items[i], -1, &error);
	    if (left->data.arg != inter_arg)  /* have to interpolate */
	      interpolate_data (inter_arg, &(left->data), &((items[i])->data), 
				new_data + i);
	    else /* so nothing to interpolate */
	    {
	      copy_data(new_data + i, (&left->data));

	      /*
		new_data[i].arg = inter_arg;
		new_data[i].count_cleaned = left->data.count_cleaned;
		new_data[i].result_cleaned = left->data.result_cleaned;
		new_data[i].standard_error_cleaned = left->data.standard_error_cleaned;
		new_data[i].count_all = left->data.count_all;
		new_data[i].result_all = left->data.result_all;
		new_data[i].standard_error_all = left->data.standard_error_all;
	      */
	    }
	  }
	}
      }
    }
    append(result_list, post_process (new_data, &result_data), &error);
    free_data(&result_data, STATIC);
  }
  return (number_of_elements (result_list) > 0);
}

/*
   @FUN:
   @DOES: tests if all entries in vector are TRUE.
   @PARAMETERS: above.
   @RETURNES: TRUE iff all elements of vector are TRUE,
   FALSE otherwise.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int
all_finished (int *vector)
{
  int
    i;

  for (i = 0; i < nif; i++)
    if (vector[i] == FALSE)
      return (FALSE);

  return (TRUE);
}

/*
   @FUN:
   @DOES: interpolates a complete data_t-struct at value (relative to 
   entry arg) between left and right.
   @PARAMETERS: bove.
   @RETURNES: pointer to the interpolated data-struct.
   @SIDEEFFECTS: allocates new data element if data == NULL.
   @ASSUMES: nothing.
*/
data_t *
interpolate_data (int value, data_t *left, data_t *right, data_t *data)
{
  if (data == NULL)
#ifndef SEQ
    if (!init_data (data, left->nodes))
#else /*SEQ*/
    if (!init_data (data, 0))
#endif /*SEQ*/

    {
      ERROR(NO_MEM,"in interpolate_data");
      output_error (TRUE);
    }
  
  copy_data(data, left);  /* only to copy node_times */

  data->arg = value;
  data->result_cleaned = linear_interpolate (value, left->arg, right->arg,
				     left->result_cleaned, right->result_cleaned);
  data->result_all = linear_interpolate (value, left->arg, right->arg,
				     left->result_all, right->result_all);
  /* lin._inter. is found in skampi_tools.c */

  data->count_cleaned = MIN(left->count_cleaned,right->count_cleaned);
  data->count_all = MIN(left->count_all,right->count_all);
  data->standard_error_cleaned = MIN(left->standard_error_cleaned,
				     right->standard_error_cleaned);
  data->standard_error_all = MIN(left->standard_error_all,right->standard_error_all);

  return (data);
}

/*
   @FUN:
   @DOES: this is the founction which really decides how to merge
   several data-struct (stored in the array new_data) to one (result_data).
   It refers to the ..._all values (which is certainlay a design decision).
   @PARAMETERS: above.
   @RETURNES: a pointer to result_data.
   @SIDEEFFECTS: none.
   @ASSUMES: nif set.
*/
data_t *
post_process (data_t *new_data, data_t *result_data)
{
  int
    i,
    median_at, 
    rep_sum = 0;
  
  /* find median, ignore invalid data-eles */

  qsort (new_data, nif, sizeof (data_t), &data_cmp);
  for (i = 0; i < nif; i++)
    rep_sum += new_data[i].count_all;

  median_at = rep_sum / 2;
  
  /* if all elements are invalid, the for loop quits immediately */
  for (rep_sum = i = 0; rep_sum < median_at; i++)
    rep_sum += new_data[i].count_all;

  copy_data(result_data, new_data + ((i)?(i - 1):0));

  return (result_data);
}

/*
   @FUN:
   @DOES: compares the results of two data_t-structs, used for qsort-calls
   Since used in function post_process, it refers to the result_all.
   @PARAMETERS: two pointers to data_t-structs d1, d2
   @RETURNES: 0 iff equal, -1 iff d1 < d2, 1 else
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int
data_cmp (const void *d1,const void *d2)
{
  if (((data_t *)d1)->result_all < ((data_t *)d2)->result_all)
    return (-1);
  else
    return (((data_t *)d1)->result_all > ((data_t *)d2)->result_all);
}






/* intern Prototypes */

enum{ADD, APPEND}; /* for mode in call_tbm */

int call_tbm (measurement_t *ms, double arg, tbm_t tbm, data_t *one_result, 
	      int mode);
double calculate_key (measurement_t *ms, PqData prio_data, int log_flag);
double min3 (double a, double b, double c);
int double_round (double f, int multiple_of);

/*
   @FUN:
   @DOES: computes all arguments, where to measure the measurement ms and calls
   it via the routine tbm (to_be_measured).
   @PARAMETERS: above.
   @RETURNES: nothing
   @SIDEEFFECTS: sets ms->x_end to effective value, if it is initialized to\\
   MAX_ARGUMENT, 
   exits in case of error.
   @ASSUMES: _skampi_myid set.
*/
void 
measure_suite (measurement_t *ms, tbm_t tbm)
{
#ifndef SEQ
  if (_skampi_myid ==  0)
  {
#endif /*SEQ*/
    signed int
      error;

    int
      nop, /* max number of processes used in a suite */
      last_arg=-1;  /* to avoid calls of the same argument twice,
		    important for rational value of stepwidth < sqrt(2) */
    int 
      steps_allowed;

    long int
      max_allowed_length;
      

    double
      arg = 1.0, /* only to suppress compiler warning */
      i,
      x_start = (double) ms->x_start,
      x_end = (double) ms->x_end,
      x_stepwidth = ms->x_stepwidth;
#ifndef SEQ
    double
      suite_start_time = MPI_Wtime();
#else
    clock_t
      suite_start_time = clock();
#endif /*SEQ*/
    
    Pq
      *prio = pqInit (ms->x_max_steps);

    data_t
      one_result;

    ms->x_end_bytes = 0; /* to be increased in loop */

    D2(fprintf(stderr,"in autodist - 0: x_start %f, x_end %f stw %f.\n",
	       x_start, x_end, x_stepwidth);)

#ifndef SEQ
    MPI_Comm_size (ms->communicator, &nop);
#else
    nop = 1;
#endif /*SEQ*/

    init_data (&one_result, nop);

    D2(fprintf(stderr,"in autodist - 0.4: x_start %f, x_end %f stw %f.\n",
	       x_start, x_end, x_stepwidth);)

#ifndef SEQ
    if (ms->variation == NODES)
    {
      if (ms->x_end != MAX_ARGUMENT)
	nop = ms->x_end;
      else
      {
	ms->x_end = nop;
	x_end = (double) nop;
      }
      max_allowed_length = 0;
      ms->x_start_bytes = ms->x_end; /* to be reduced in loop */
    }
    else
    /* because when  == nodes it is called 
       in tbm (==call_nodes in skampi_call.c) */
#endif /*SEQ*/
    {				    
      if (!(max_allowed_length = ms->server_init (
	  ms->max_rep *
#ifndef SEQ 
	  (ms->pattern == MASTER_WORKER ? ms->data.mw_data.chunks: 1), 
#else
	  1,
#endif /*SEQ*/
	   ms->x_max_steps, nop)))
      {
	ERROR(NO_MEM,"no memory for messages");
	/* send stop signal to all other processes */
	arg = STOP_SIGNAL;
#ifndef SEQ
	MPI_Bcast (&arg, 1, MPI_DOUBLE, 0, ms->communicator); 
#endif /*SEQ*/
	return;
      }
      ms->x_start_bytes = max_allowed_length; /* to be reduced in loop */
      adjust_last_argument (ms->send_datatype_number, 
			    ms->basetype_number,
			    ms->send_datatype, 
			    &max_allowed_length);
    }
    D2(fprintf(stderr,"in autodist - 0.6: x_start %f, x_end %f stw %f.\n",
	       x_start, x_end, x_stepwidth);)

    if (ms->variation == LENGTH)
    {
      if (ms->x_end == MAX_ARGUMENT)
	x_end = max_allowed_length;
      else
	x_end = MIN((double)max_allowed_length,x_end);
      ms->x_end = (int) x_end;
    }
    else if (ms->variation == CHUNK)
      x_end = ms->x_end;

    fprintf(stderr,"in autodist - 1: x_start %f, x_end %f stw %f.\n",
	       x_start, x_end, x_stepwidth);

    if (ms->x_scale == DYN_LOG || ms->x_scale == FIXED_LOG)
    {
      if (x_start != 0)
        x_start = (log (x_start) / log (ms->x_stepwidth)); 
      else
        ms->x_start = x_start = 1; /* GNUPLOT has Problems with 
                                      ms->x_start == 0 */
      /* x_start = (double) ms->x_start; */
      if (x_end != 1.0)
	x_end = (log (x_end) / log (ms->x_stepwidth)); 
      x_stepwidth = 1.0; 
    }

    D2(fprintf(stderr,"in autodist - 2: x_start %f, x_end %f stw %f.\n",
	       x_start, x_end, x_stepwidth);)
    
    if (ms->x_scale == DYN_LOG || ms->x_scale == FIXED_LOG)
    {
      arg = ms->x_start / ms->x_stepwidth; /* yes ms->... */
    }
    D18(fprintf(stderr,"in autodist - 11: x_start %f, x_end %f stw %f, reducebuffer %d.\n",
	       x_start, x_end, x_stepwidth,_skampi_reduce_buffer_size);)

    /* round stepwidth */
    for (i = x_start; i <= x_end; i += ((int) x_stepwidth)) 
    {
      D2(fprintf(stderr,"in autodist main loop.\n");)
      if (ms->x_scale == DYN_LOG || ms->x_scale == FIXED_LOG)
      {
        if (arg == 0)
          arg = 1.0;
        else
          arg *= ms->x_stepwidth; /* yes: ms->x_... */
      }
      else
	arg = double_round (i, ms->multiple_of);

      D11(printf("computed new arg %f, last arg %d.\n",arg, last_arg);)
	    
      /* fixed_linear and stepwidth not large enough */
      if (double_round (arg, ms->multiple_of) == last_arg) 
	continue;

      O(printf("measuring at arg %d.\n", double_round (arg, ms->multiple_of));)
      if (!call_tbm (ms, double_round(arg, ms->multiple_of), tbm, &one_result,
		     ADD))
      {
	D11(fprintf(stderr, "%d: in autodist return -1");)
	return;
      }

      last_arg = double_round (arg, ms->multiple_of);

      if (one_result.arg_bytes > ms->x_end_bytes)
	ms->x_end_bytes = one_result.arg_bytes;
      if (one_result.arg_bytes < ms->x_start_bytes)
	ms->x_start_bytes = one_result.arg_bytes;


      if (ms->time_suite != INVALID)
#ifndef SEQ
	if (MPI_Wtime() - suite_start_time >= ms->time_suite * 60.0) 
#else
	if ((clock() - suite_start_time) / CLOCKS_PER_SEC >= 
	      ms->time_suite * 60.0) 
	  /* Note that CLK_TCK instead of CLOCKS_PER_SEC is wrong at 
	     least on linux */
#endif /*SEQ*/
	  /* conversion min -> sec. */
	  goto ende;

    } /* for */
    D11(fprintf(stderr, "%d: in autodist -0\n", _skampi_myid);)
    /* for measurung at the highest argument */
    if ((last_arg != ms->x_end) && (last_arg != x_end))
    {      
      if (ms->x_scale == DYN_LOG || ms->x_scale == FIXED_LOG)
	arg = ms->x_end;
      else
	arg = x_end;

      arg = double_round(arg, ms->multiple_of);

      if (arg != last_arg)
      {
	O(printf("measuring at arg %d.\n",(int)arg);)	
	  if (!call_tbm (ms, double_round(arg, ms->multiple_of), tbm, 
			 &one_result, ADD))
	  {
	    D11(fprintf(stderr, "%d: in autodist return -2");)
	    return;
	  }
	  if (one_result.arg_bytes > ms->x_end_bytes)
	    ms->x_end_bytes = one_result.arg_bytes;
      }
    }    

    if (ms->x_start_bytes == 0)
	ms->x_start_bytes = 1;


    D11(fprintf(stderr, "%d: in autodist -01\n", _skampi_myid);)
    D(write_to_file(ms->result_list,stderr);)

    if (((int) x_start) >= ((int)x_end))
    {
      D11(fprintf(stderr, "%d: in autodist -01a\n", _skampi_myid);)
      goto ende;
    }
    /* if dynamic adaption, then use priority queues to determine more 
       aguments */
    D11(fprintf(stderr, "%d: in autodist -01b\n", _skampi_myid);)
    steps_allowed = ms->x_max_steps - 
      number_of_elements (ms->result_list);
    D11(fprintf(stderr, "%d: in autodist -01b1\n", _skampi_myid);)
    if ((ms->x_scale == DYN_LIN || ms->x_scale == DYN_LOG) && steps_allowed)
    {
      PqItem
	prio_item;

      list_item_t
	*list_item;

      double
	new_arg;

      D11(printf("hello: I am dynamic!\n");)
      
      D11(fprintf(stderr, "%d: in autodist -11!!!!!!!!\n",_skampi_myid);)
      /* first fill the priority queue */
      prio_item.data = item_addr (ms->result_list, START, 0, &error);
      if ((prio_item.key = calculate_key (ms, prio_item.data, 
					  (ms->x_scale == DYN_LOG))) 
	  != PQMINUSINFINITY)
	pqInsert (prio, prio_item);
      D11(fprintf(stderr, "%d: in autodist -11a!!!!!!!!\n",_skampi_myid);)
      for (i = 1; i < number_of_elements (ms->result_list) - 3; i++)
      {
	D11(fprintf(stderr, "%d: in autodist -111a!!!!!!!!\n",_skampi_myid);)
	prio_item.data = item_addr (ms->result_list, LAST, 1, &error);
	D11(fprintf(stderr, "%d: in autodist -111b!!!!!!!!\n",_skampi_myid);)
	if ((prio_item.key = calculate_key (ms, prio_item.data, 
					    (ms->x_scale == DYN_LOG))) 
	    != PQMINUSINFINITY)
	{
	  D11(fprintf(stderr, "%d: in autodist -111c!!!!!!!!\n",_skampi_myid);)
	  pqInsert (prio, prio_item);
	}
	D11(fprintf(stderr, "%d: in autodist -111d!!!!!!!!\n",_skampi_myid);)
      }

      /* do more measurements */
      D(write_to_log_file ("in autodist -11b \n");)
      D11(fprintf(stderr, "%d: in autodist -11b\n",_skampi_myid);)
      D11(fprintf(stderr, "%d: in autodist -11bb\n",_skampi_myid);)
      if (steps_allowed > 0)
      {
	D11(fprintf(stderr,"hello: steps_allowed %d\n", steps_allowed);)

	while (pqLength (prio) > 0 && steps_allowed-- > 0)
	{
	  data_t
	    right_data;
	  D11(fprintf(stderr, "%d: in autodist -11c\n",_skampi_myid);)

	  #ifndef SEQ 
	  init_data(&right_data,ms->nodes);
	  #else
	  init_data(&right_data,0);
          #endif /*SEQ*/
	  if (ms->time_suite != INVALID)
	  {
            #ifndef SEQ
	    if (MPI_Wtime() - suite_start_time >= ms->time_suite * 60.0) 
            #else
	    if ((clock() - suite_start_time) / CLOCKS_PER_SEC >= 
		ms->time_suite * 60.0) 
            #endif /*SEQ*/
	      /* conversion min -> sec. */
	      break;
	  }
	  /* compute new argument */
	  D(write_to_log_file ("in autodist -2 \n");)
	  D11(fprintf(stderr, "%d: in autodist -2\n",_skampi_myid);)
	  list_item = pqMaxData(prio);
	  pqDeleteMax (prio);

	  read_item_ele (ms->result_list, list_item, 1, &right_data, &error);
	  D11(fprintf(stderr, "%d: in autodist -2a\n",_skampi_myid);)
	  if (ms->x_scale == DYN_LOG)
	    new_arg = sqrt(right_data.arg) * sqrt(list_item->data.arg);
	  else
	    new_arg = (right_data.arg + list_item->data.arg) / 2;
	  D11(fprintf(stderr, "%d: in autodist -11d\n",_skampi_myid);)
	  new_arg = double_round(new_arg, ms->multiple_of);
	  D11(printf("computed new arg %f, last arg %d.\n",new_arg, last_arg);)
	    
	  if ((fabs (list_item->data.arg - new_arg) < ms->x_min_dist)
	      || (last_arg == ((int) new_arg)))
	  {
	    steps_allowed++;
	    continue;
	  }

	  O(printf("measuring at arg %d.\n",(int)new_arg);)

	  if (!call_tbm (ms, new_arg, tbm, &one_result, APPEND))
	    return;
	  D11(fprintf(stderr, "%d: in autodist -3");)
	  D(write_to_log_file ("in autodist -1 \n");)
	  last_arg = (int) new_arg;
	  D11(printf("after tbm: new arg %f, last arg %d.\n",new_arg, 
		     last_arg);)
	  /* update proiority queue,
	     first: update the more left of the new two elements */
	  prio_item.data = list_item;
	  if ((prio_item.key = calculate_key (ms, prio_item.data, 
					      (ms->x_scale == DYN_LOG))) 
	      != PQMINUSINFINITY)
	    pqInsert (prio, prio_item);

	  /* second: possibly insert second (right) element */
	  prio_item.data = item_addr (ms->result_list, LAST, 1, &error);
	  if ((prio_item.key = calculate_key (ms, prio_item.data, 
					      (ms->x_scale == DYN_LOG))) 
	      != PQMINUSINFINITY)
	    pqInsert (prio, prio_item);
	  D11(fprintf(stderr, "%d: in autodist -4");)
	} /* while */
      } /* if steps_allowed == ...*/
      D11(fprintf(stderr, "%d: in autodist 11b1");)
      pqClose (prio);
      D11(fprintf(stderr, "%d: in autodist 11b2");)
    }
  ende:
    D11(fprintf(stderr, "%d: in autodist end");)
    /* send stop signal to all other processes */
    arg = STOP_SIGNAL;
#ifndef SEQ
    MPI_Bcast (&arg, 1, MPI_DOUBLE, 0, ms->communicator); 
    ms->act_time_suite = (MPI_Wtime() - suite_start_time) / 60.0;
#else
    ms->act_time_suite = (clock() - suite_start_time) / (60 * CLOCKS_PER_SEC);
#endif /*SEQ*/


    if (ms->variation != NODES)  /* because when == nodes it is called
				    in tbm (==call_nodes in skampi_call.c) */
      ms->server_free ();
#ifndef SEQ
  }
  else /* I am not the zero process */
  {
    double
      arg;

    data_t
      one_result;

    int 
      nop;

    if (ms->variation == NODES)
      nop = ms->x_end;
    else
      MPI_Comm_size (ms->communicator, &nop);

    if (ms->variation != NODES)  /* because when == nodes it is called
				    in tbm (==call_nodes in skampi_call.c) */
      if (!ms->client_init (ms->max_rep, ms->x_max_steps, nop))
      {
	ERROR(NO_MEM,"client has not enough memory for messages");
	output_error (TRUE); /* pech gehabt! */
	return;
      }
    while (call_tbm (ms, arg, tbm, &one_result, ADD))
      ;    

    if (ms->variation != NODES)  /* because whenn == nodes it is called
				    in tbm (==call_nodes in skampi_call.c) */
      ms->client_free ();
    D11(fprintf(stderr, "%d: in autodist -end");)
  }
#endif /*SEQ*/ 
}

/*
   @FUN:
   @DOES: computes the key for the x_axis - segment for inserting it into the
   Priority-queue.
   We use the result_cleaned (which is a desgin decision).
   @PARAMETERS: the actual measurement,
   the x_axis segment pqdata.
   @RETURNES: the key
   @SIDEEFFECTS: none.
   @ASSUMES: MACRO FUN defined.
*/
#define FUN(a,b) (MAX((a),(b)))

double calculate_key (measurement_t *ms, PqData pqdata, int log_flag)
{
  data_t
    *me,
    left,
    right1,
    right2;

  double 
    min_diff,
    diff_left,
    diff_right,
    horizontal,
    a,   /* args */
    l,
    r1,
    r2;

  int 
    error;
  D11(fprintf(stderr, "%d: in calculate_key -1\n",_skampi_myid);)
#ifndef SEQ
  init_data(&left,0); /* formerly ms->nodes instead of 0*/
  D11(fprintf(stderr, "%d: in calculate_key -11\n",_skampi_myid);)
  init_data(&right1,0); /* formerly ms->nodes instead of 0*/
  D11(fprintf(stderr, "%d: in calculate_key -12\n",_skampi_myid);)
  init_data(&right2,0); /* formerly ms->nodes instead of 0*/
  D11(fprintf(stderr, "%d: in calculate_key -13\n",_skampi_myid);)
#else /*SEQ*/
  init_data(&left,0);
  init_data(&right1,0);
  init_data(&right2,0);
#endif /*SEQ*/
  D11(fprintf(stderr, "%d: in calculate_key -2\n",_skampi_myid);)
  /* does not matter if pqdata is the the leftmost data-element,
     then left will be a pointer to it. */
  read_item_ele (ms->result_list, pqdata, -1, &left, &error);
  D11(fprintf(stderr, "%d: in calculate_key -3\n",_skampi_myid);)
  read_item_ele (ms->result_list, pqdata, 1, &right1, &error);
  D11(fprintf(stderr, "%d: in calculate_key -4\n",_skampi_myid);)
  read_item_ele (ms->result_list, pqdata, 2, &right2, &error);
  me = &(pqdata->data);
  D11(fprintf(stderr, "%d: in calculate_key -5\n",_skampi_myid);)

  a = me->arg;
  l = left.arg;
  r1 = right1.arg;
  r2 = right2.arg;

  diff_left = fabs (linear_interpolate (a, r1, r2,
					right1.result_cleaned, right2.result_cleaned) - 
		                         me->result_cleaned) / 
                                        (me->result_cleaned == 0 ? 1 : me->result_cleaned);
  D11(fprintf(stderr, "%d: in calculate_key -6\n",_skampi_myid);)
  diff_right = fabs (linear_interpolate (r1, l, a,
					 left.result_cleaned, me->result_cleaned) - 
		                         right1.result_cleaned) / 
                             (right1.result_cleaned == 0 ? 1 : right1.result_cleaned);

  D11(fprintf(stderr, "%d: in calculate_key -8\n",_skampi_myid);)
  horizontal = ((double) r1) / ((double) (a == 0 ? 1.0 : a)) - 1.0;

  min_diff = min3 (horizontal, diff_left, diff_right);



#if 0 
  sprintf (_skampi_msg,"**autodist** at arg: %f (l: %f r1: %f r2: %f)"\
           "min_diff: %f diff_left: %f diff_right: %f horizontal: %f \n", 
           a, l, r1, r2, min_diff, diff_left, diff_right, horizontal);
  write_to_log_file (_skampi_msg);
#endif

#if 0 /* Verfeinerung besser, wenn abgeschaltet */
  if (min_diff < me->standard_error_cleaned / me->result_cleaned)
    return (PQMINUSINFINITY);
#endif

  return (min_diff);
}

double min3 (double a, double b, double c)
{
  if (a < b)
  {
    if (c < a)
      return (c);
    else
      return (a);
  }
  else
  {
    if (c < b)
      return (c);
    else
      return (b);
  }
}

int double_round (double f, int multiple_of)
{
  int 
    h = (int) (f + 0.5);
  return ((h / multiple_of) * multiple_of); /* please do optimize away */
}

int call_tbm (measurement_t *ms, double arg, tbm_t tbm, data_t *one_result, 
	      int mode)
{
  signed int
    error;

#ifndef SEQ
  D11(fprintf(stderr, "%d: call_tbm-0 waiting for bcast :\n",_skampi_myid);)
  MPI_Bcast (&arg, 1, MPI_DOUBLE, 0, ms->communicator); 
  D11(fprintf(stderr, "%d: call_tbm-1: received arg %f\n",_skampi_myid, arg);)
  if (arg == STOP_SIGNAL) /* when called from a client */
    return (FALSE);
  if (ms->send_kind_type_meas == ONE)
  {
    create_datatype (ms->send_datatype_number,
		     ms->basetype_number,
		     (int)arg, 
		     &(ms->send_datatype), 
		     &ms->send_datatype_name, 
		     &(ms->send_datatype_size), 
		     &(ms->send_datatype_extent), NULL, NULL);

  }
  D11(fprintf(stderr, "%d: call_tbm-2: received arg %f\n",_skampi_myid, arg);)
  if (ms->recv_kind_type_meas == ONE)
  {
    create_datatype (ms->recv_datatype_number,
		     ms->basetype_number,
		     (int)arg, 
		     &(ms->recv_datatype), 
		     &ms->recv_datatype_name, 
		     &(ms->recv_datatype_size), 
		     &(ms->recv_datatype_extent), NULL, NULL);
  }
  D11(fprintf(stderr, "%d: call_tbm-3: received arg %f\n",_skampi_myid, arg);)
  D15(fprintf(stderr, "call_tbm: send_dt_number: %d (%s) MPI_Datatype %d %d, sbt: %d,\n", 
	      ms->send_datatype_number,
	      ms->send_datatype_name, ms->send_datatype, ms->recv_datatype,
	      ms->basetype_number);)

#endif /*SEQ*/
  if ((tbm (ms, arg, one_result)) == NULL)
  {
    sprintf (_skampi_msg,"measurement %s failed with arg %f.\n",
	     ms->name, arg);
    write_to_log_file (_skampi_msg);
    /* return (FALSE); */
    /* critical : what happens to the processes not involved in
       tbm if it fails ?? */
  }
  D11(fprintf(stderr, "%d: call_tbm-4: received arg %f\n",_skampi_myid, arg);)
#ifndef SEQ
  if (ms->send_kind_type_meas == ONE)
  {
     free_datatype(ms->send_datatype_number, &(ms->send_datatype));
  }
  if (ms->recv_kind_type_meas == ONE)
  {
     free_datatype(ms->recv_datatype_number, &(ms->recv_datatype));
  }
#endif /*SEQ*/
  D11(fprintf(stderr, "%d: call_tbm-5: received arg %f\n",_skampi_myid, arg);)
  if (_skampi_myid == 0)
  {
    one_result->arg = arg;
    if (ms->variation !=LENGTH)
      one_result->arg_bytes = arg; 
    if (mode == ADD)
      append(ms->result_list,one_result,&error);
    else /* so APPEND */
      add (ms->result_list, LAST, -1, one_result, &error);
    if (error != DL_NO_ERROR)
    {
      ERROR(NO_MEM,"no memory for results");
      /* send stop signal to all other processes */
      arg = STOP_SIGNAL;
#ifndef SEQ
      MPI_Bcast (&arg, 1, MPI_DOUBLE, 0, ms->communicator); 
#endif /*SEQ*/
      return (FALSE);
    }
  }
  return (TRUE);
}
int double_cmp (const void *d1,const void *d2);

static double 
  *tbm_buffer,
#ifndef SEQ
  *node_times_buffer,
#endif /*SEQ*/
  square_result_sum_cleaned,
  result_sum_cleaned,
  mean_value_cleaned,
  standard_error_cleaned,
  square_result_sum_all,
  result_sum_all,
  mean_value_all,
  standard_error_all;
#ifndef SEQ
static double
  meas_start_time;
#else
static clock_t
  meas_start_time;
#endif /*SEQ*/


  /* Please note the comment concering the variables
     "standard_error..." given at the beginning of function
     "am_control_end". */

static int
  buffer_size,
  counter; /* number of measurements */


/*
   @FUN:
   @DOES: initializes all private (static) variables
   allocates memory.
   @PARAMETERS: the size (in bytes) of memory to be allocated.
   @RETURNES: TRUE iff allocation ok, FALSE otherwise.
   @SIDEEFFECTS: changing the mentioned variables.
   @ASSUMES: nothing.
*/
int 
am_init (int size)
{
#ifndef SEQ
  meas_start_time = MPI_Wtime();
#else
  meas_start_time = clock();
#endif /*SEQ*/
  counter = 0;
  square_result_sum_cleaned = result_sum_cleaned = mean_value_cleaned = 
    standard_error_cleaned = 0.0;
  square_result_sum_all = result_sum_all = 
    mean_value_all = standard_error_all = 0.0;
  buffer_size = size;

  if ((tbm_buffer = (double *) malloc (sizeof (double) * size))==NULL)
    return (0);
#ifndef SEQ
  if ((node_times_buffer = (double *) malloc (sizeof (double) * numprocs))
      ==NULL)
    free (tbm_buffer);
  return (node_times_buffer != NULL);
#else
  return (TRUE);
#endif /*SEQ*/
}

/*
   @FUN:
   @DOES: frees the allocated buffers
   @PARAMETERS: none.
   @RETURNES: nothing.
   @SIDEEFFECTS: memory freed, variables set back to zero.
   @ASSUMES: tbm_buffer has been allocated before.
*/
void 
am_free (void)
{
  counter = 0;
  buffer_size = 0;

  free (tbm_buffer);
#ifndef SEQ
  free (node_times_buffer);
#endif /*SEQ*/

}

/*
   @FUN:
   @DOES: controles whether the ms at arg arg should be repeated 
   (returnes TRUE) or not (returnes FALSE).
   @PARAMETERS: the current  measurement ms, the actual argument arg,
   the measured time (tbm_time), the node_time, 
   the partner (-process) also involved into
   this measurement. If there is no other process involved, partner is
   set to NO_COMMUNICATION.  If it is set to USE_COMMUNICATOR, the the argument
   local_communicator will be used. (for communication to more than one 
   other processes. The root is process 0).
   @RETURNES: see above.
   @SIDEEFFECTS: on the static variables.
   @ASSUMES: _skampi_myid set.
   am_init has been called before.
*/
#define SQUARE(a) ((a)*(a))
/* returnes true iff measurement has to be repeated */
#ifndef SEQ
int 
am_control_end (measurement_t *ms, int arg, double tbm_time,
		int partner, double node_time, MPI_Comm local_communicator)
#else
int 
am_control_end (measurement_t *ms, int arg, double tbm_time,
		int partner)
#endif /*SEQ*/
{

  /* Please note: the variables "standard_error..." contain an
     estimator for the standard error of the mean. This estimator is
     defined as estimator := standard_deviation / sqrt(n), where n is the
     number of measurements (i.e., counter).  Here we do not use the
     above formular. We do not calculate an standard error first to
     calculate the estimator. We calculate the estimator of the
     standard_error on the fly, i.e. we use the formular:

     estimator = sqrt ( (sum_i  ((x_i)^2) - ((sum_i x_i)^2)/n) / n * (n - 1))
     
     compare to formula 1.105 in "Lothar Sachs, Angewandte Statistik,
     Springer Verlag, 8th ed. 1997"
     (It is assumed that the results are Gaussian/normal distributed .)

     Note that standard_error != standard_deviation !

   */

  int
    return_flag;
#ifndef SEQ
  if (_skampi_myid == 0)
#endif /*SEQ*/  
  {
    /* store the result time */
    tbm_buffer[counter++] = tbm_time;

    /* update variables */
    
    result_sum_all += tbm_time;
    square_result_sum_all += SQUARE(tbm_time);
    
    mean_value_all = result_sum_all / counter;

    if (counter == 1) /* cannot do calculation of standard_error 
                         (division by zero) */
    {
      return_flag = TRUE; /* do not stop */
      goto send_result;
    }
    
    standard_error_all = 
      sqrt ((square_result_sum_all - (SQUARE(result_sum_all) / counter))/ 
	    (counter * (counter - 1)));
    
    if (counter == buffer_size)
    {
      if (arg >= 0) /* do not complain when warming up the cache */
      {
	sprintf (_skampi_msg,"The measurement %s with arg %d \n"\
		 "has not fallen "\
		 "short of the max. allowed error of %f %%.\n"\
		 "The actual standard error is %f of the mean value %f\n"\
		 "(i.e. %f %%)\n"\
		 "The measurement has been repeated %d times.\n" ,
		 ms->name, arg, 100 * ms->standard_error, 
		 standard_error_all, mean_value_all, 
		 (standard_error_all * 100) / 
		 (mean_value_all == 0 ? 1 : mean_value_all), counter);
	
	write_to_log_file (_skampi_msg);
      }
      return_flag = FALSE; /* stop */
      goto send_result;
    }
    
    if (arg < 0) /* only dummy measurement */
    {
      if (counter <= (-1) * arg)  /* here arg is used to determine the number
				     of dummy-measurements */
	return_flag = TRUE; /* repeat meas. */
      else
	return_flag = FALSE; /* stop meas. */
      goto send_result;
    }

    if (ms->time_meas != INVALID)
#ifndef SEQ
      if (MPI_Wtime() - meas_start_time >= ms->time_meas * 60) 
#else
      if ((clock() - meas_start_time) / CLOCKS_PER_SEC >= ms->time_meas * 60) 
#endif /*SEQ*/
      {
	return_flag = FALSE; /* stop */
	goto send_result;
      }

    /* repetitions is set in skampi_tools.c::init_skalib */
    if ((counter < ms->min_rep) || (counter < repetitions))
    {
      return_flag = TRUE; /* repeat */
      goto send_result;
    }

    if (standard_error_all < ms->standard_error * mean_value_all)
    {
      return_flag = FALSE;  /* then stop measurements */
      goto send_result;
    }
    
    /* repeat the measurement */
    return_flag = TRUE;
  send_result:
#ifndef SEQ
    if (partner != NO_COMMUNICATION)
    {
      if (partner == USE_COMMUNICATOR)
      {
	MPI_Bcast (&return_flag, 1, MPI_INT, 0, local_communicator);
	MPI_Barrier (local_communicator);
	if (return_flag == FALSE) /* so measurements are stopped */
	  MPI_Gather (&node_time, 1, MPI_DOUBLE, node_times_buffer, 
		      1, MPI_DOUBLE, 0, local_communicator);

      }
      else /* then you are the sender (because you are proc. 0) 
	      and you have to send to partner */
      {
	MPI_Ssend (&return_flag, 1, MPI_INT, partner, 0, 
		   ms->communicator);

	D8(fprintf (stderr, "server %d: received return flag %d .\n", 
		    _skampi_myid,return_flag);)
#if 1
	if (return_flag == FALSE) /* so measurements are stopped */
	{
	  MPI_Status
	    status;
#ifdef DEBUG_NODE_TIMES
	  node_times_buffer[0] = 0.001;
#else
	  node_times_buffer[0] = node_time;
#endif /*DEBUG_NODE_TIMES*/
	  MPI_Recv (node_times_buffer + 1, 1, MPI_DOUBLE, partner, SKAMPI_TAG, 
		    ms->communicator, &status);

	  D8(fprintf (stderr, "server %d: after receiving from node %d .\n", 
		      _skampi_myid, partner);)
	  

	}
#endif  /*1*/
      }
    }
  }
  else /* so not process 0 */
  {
    if (partner != NO_COMMUNICATION)
    {
      if (partner == USE_COMMUNICATOR)
      {
	MPI_Bcast (&return_flag, 1, MPI_INT, 0, local_communicator);
	MPI_Barrier (local_communicator);
	if (return_flag == FALSE) /* so measurements are stopped */
	  MPI_Gather (&node_time, 1, MPI_DOUBLE, node_times_buffer, 
		      1, MPI_DOUBLE, 0, local_communicator);
      }
      else /* you are the client and have to receive from proc 0 */
      {
	MPI_Status
	  status;

	MPI_Recv (&return_flag, 1, MPI_INT, 0, 0, 
		  ms->communicator, &status);

	D8(fprintf (stderr, "clientpartner %d: received return flag %d .\n", 
		    _skampi_myid,return_flag);)
#if 1
	if (return_flag == FALSE) /* so measurements are stopped */
	  MPI_Ssend (&node_time, 1, MPI_DOUBLE, 0, SKAMPI_TAG, 
		     ms->communicator);

	D8(fprintf (stderr, "clientpartner %d: after sending node_time .\n", 
		     _skampi_myid);)
#endif /*1*/

      }
    }
#endif /* ifndef SEQ */
  }

  return (return_flag);
}

/*
   @FUN:
   @DOES: fills the data (dummy_time, standard_error of the dummy time into 
   the actual measured data.
   @PARAMETERS: above
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: am_init has been called before. _critical_min_time set.
*/
/* du_ti_se dummy_time standard error */
void 
am_fill_data (measurement_t *ms, int arg, double dummy_time, double du_ti_se, 
	      data_t *data)
{

  /* The comment concering the variables "standard_error..." given at
     the beginning of function "am_control_end" is also valid here.  */

  int
    i,
    nop,
    quantile;

  double
    *tbm_buffer_ptr = tbm_buffer;

  qsort (tbm_buffer_ptr, counter, sizeof(double), double_cmp);

  if (mean_value_all < _critical_min_time)
  {
    sprintf (_skampi_msg,"The measurement %s with arg %d \n may has "\
	     "an systematic error.\n"\
	     "The actual standard error is %f of the mean value %f\n"\
	     "The measurement has been repeated %d times.\n",
	     ms->name, arg, standard_error_all,
	     mean_value_all, counter);
    write_to_log_file (_skampi_msg);
  }

  data->count_all = counter; /* must be done here, because counter is 
				manipulated later on */

  if (ms->cut_quantile > 0.001 ) /* fill direct result values, 
				    if cut_quantile is below */
  {  
    if (counter >=  (int) 1.0 / ms->cut_quantile)  
      quantile = (int) (counter * ms->cut_quantile);
    else
      quantile = 0;
    
    counter -= (2 * quantile);
    
    if (counter == 0) /* avoid div. by zero */
      counter = 1;
    
    tbm_buffer_ptr += quantile;
    
    result_sum_cleaned = square_result_sum_cleaned = 0.0;
    
    
    for (i = 0; i < counter; i++)
    {
      result_sum_cleaned += tbm_buffer_ptr[i];
      square_result_sum_cleaned += SQUARE(tbm_buffer_ptr[i]);
    }
    
    mean_value_cleaned = result_sum_cleaned / counter;
    
    if (counter > 1) /* cannot do calculation of standard_error */
    {
      standard_error_cleaned = sqrt ((square_result_sum_cleaned - 
				      (SQUARE(result_sum_cleaned) / 
				       counter))/ 
				     (counter *
				      (counter - 1)));
    }
    else 
    {
      standard_error_cleaned = -1.0;
      sprintf (_skampi_msg,"The measurement %s with arg %d \n may has "\
	       "has no meaning. There has been an insufficient number of" \
	       "repetitions \n",
	       ms->name, arg);
      write_to_log_file (_skampi_msg);      
    }
  }
  else /* ms->cut_qantile <= 0.001 */
  {
    mean_value_cleaned = mean_value_all;
    standard_error_cleaned = standard_error_all;
  }

  /* fill the data struct: note times in micro sec. now */
  data->result_all = mean_value_all * 1000000 - dummy_time;
  data->standard_error_all = standard_error_all * 1000000;
  data->result_cleaned = mean_value_cleaned * 1000000 - dummy_time;
  data->standard_error_cleaned = standard_error_cleaned * 1000000;
  data->arg = arg; /* usuallay overwritten in measure_suite */
  if (ms->variation == LENGTH) 
  {
    if (ms->send_kind_type_meas == ARRAY)
    {
      D18(fprintf(stderr, "in automeasure - 1: kind %d, arg %d, extend %ld",
		  ms->send_kind_type_meas, arg, 
		  (long int)ms->send_datatype_extent);)
      data->arg_bytes = ((long int)arg) * (long int)ms->send_datatype_extent;
    }
    else
    {
      D18(fprintf(stderr, "in automeasure - 1b: kind %d, arg %d, extend %ld",
		  ms->send_kind_type_meas, arg, 
		  (long int)ms->send_datatype_size);)

      if (arg == 0)
	data->arg_bytes = 0;
      else
	data->arg_bytes = (long int) ms->send_datatype_size;
    }
  }
  else
  {
    data->arg_bytes = (long int)arg; /* this is necessary because in write_to_file in
			      datalist.c we always write arg_bytes,
			      even when varying over nodes or chunks,
			      since we cannot know that there */
  }
  data->count_cleaned = counter;

#ifndef SEQ  
  if (ms->variation == LENGTH)
  {
    if (ms->pattern == P2P)
      nop = 2;
    else if (ms->pattern == MASTER_WORKER)
      nop = 0;
    else
      MPI_Comm_size(ms->communicator, &nop);
  
  /* in the p2p and mw patterns only the node times of two nodes
     are filled, although the communications equals to COMM_WORLD.
     (Because find_max_min needs to examine all nodes.)
     similar in mw 
     */
  }
  else
    nop = 0;

  nop = MIN(nop,data->used_nodes);

#else
  nop = 1;
#endif 

#ifndef SEQ
  if (ms->node_times && ms->pattern !=SIMPLE) 
    for (i= 0; i < nop; i++)
    {
      if (ms->pattern != P2P)
	data->node_times[i] = node_times_buffer[i] * 1000000.0;
      else
	data->node_times[i] = 0.0; /* the t3e insists on that */
    }
  /* conversion from seconds to microseconds */    
  /*  data->count_all = counter; is done above, before counter is 
      manipulated */
  data->nodes = nop;
  data->used_nodes = (nop != 0);
  D(fprintf (stderr,"automeasure: nodes %d used_nodes %d\n",data->nodes,
	     data->used_nodes);)

#endif /*SEQ*/
}

/*
   @FUN:
   @DOES: compares to doubles, used for qsort-calls
   @PARAMETERS: two pointers to doubles d1, d2
   @RETURNES: 0 iff equal, -1 iff d1 < d2, 1 else
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int 
double_cmp (const void *d1,const void *d2)
{
  if (*(double *)d1 < *(double *)d2)
    return (-1);
  else
    return (*(double *)d1 > *(double *)d2);
}









/* internal shorthands */
#define Length    (this->length)
#define MaxLength (this->maxLength)
#define Item(i)   (this->item[i])
#define Key(i)    (Item(i).key)
#define Parent(i) ((i-1) / 2)
#define Left(i)   ((i) * 2 + 1)
#define Right(i)  ((i) * 2 + 2)

#if 0
/********************* Debugging *************************************/
void pqPrint(Pq *this)
{  int i; 
   Pq temp[1000];
 
   memcpy(temp, this, pqLength(this) * sizeof(PqItem) + sizeof(Pq));
   while (pqLength(temp) != 0) {
      printf("%d ", pqMaxKey(temp));
      pqDeleteMax(temp);
   }
  
   printf("(");
   for (i = 0;  i < pqLength(this);  i++) {
      printf("%d ", Key(i));
   }
   printf(")");
}
/*********************************************************************/
#endif

/* iniatlize a sequential Priority queue which is able to
 * accept up to maxLength items
 */
Pq *pqInit(int maxLength)
{  Pq *this = malloc(sizeof(Pq) + (maxLength - 1) * sizeof(PqItem));

   NAssert(this != 0);
   Length    = 0;
   MaxLength = maxLength;
   return(this);
}


void pqClose(Pq *this)
{  free(this);
}


/* aux. function from CorEtAl149 */
static void heapify(Pq *this, int i)
{  int l, r, largest;
   PqItem temp;

   l = Left(i);
   r = Right(i);
   largest = (l < Length && Key(l) > Key(i      )) ? l : i;
   largest = (r < Length && Key(r) > Key(largest)) ? r : largest;
   if (largest != i) {
      temp = Item(largest); Item(largest) = Item(i); Item(i) = temp;
      heapify(this, largest);
   }
}


/* delete maximum item */
void pqDeleteMax(Pq *this) 
{  NAssert2(Length > 0);
   Length--;
   Item(0) = Item(Length);
   heapify(this, 0);
}


/* insert item */
void pqInsert(Pq *this, PqItem item){
   int   i;
   PqKey key = item.key;

   NAssert2(Length < MaxLength);
   NDebug3(pqPrint(this));
   NDebug3(printf("-ins>"));
   Length++;
   i = Length - 1;
   while (i > 0 && Key(Parent(i)) < key) {
      Item(i) = Item(Parent(i));
      i = Parent(i);
   }
   Item(i) = item;
   NDebug3(pqPrint(this));
   NDebug3(printf("\n"));
}
/*
   @FUN:
   @DOES: executes the master-worker pattern
   @PARAMETERS: the actual measurement
   @RETURNES: TRUE in case if success
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int 
mw_pattern (measurement_t *ms)
{
  int 
    mw_numprocs,
    local_myid;
  

  MPI_Comm_rank(ms->data.mw_data.communicator,&local_myid);
  MPI_Comm_size(ms->data.mw_data.communicator,&mw_numprocs);

  D17(fprintf (stderr,"mw_numprocs: %d\n",mw_numprocs);)

  if (mw_numprocs == 1)
  {
    ERROR(INTERN,"master worker pattern started with only one process\n"\
	  "no worker available.");
    output_error (TRUE);
  }

  if (local_myid == 0) /* so master */
  {
    int 
      worker,
      work;

    double 
      start_time,
      end_time = 0.0,
      tbm_time;

    D17(fprintf (stderr, "master: putting rec. ready  !\n");)
    /* post ready to receive */
    for (worker = 1; worker < mw_numprocs; worker++)
      ms->data.mw_data.master_receive_ready (worker, (ms->send_kind_type_meas 
						      == ONE ? 1:
						      ms->data.mw_data.len), 
					     ms->data.mw_data.communicator,
					     ms->send_datatype);

    if (params.cache_warmup > 0)
    {
      /* for cache warmup */
      work = 0;
      while (work < params.cache_warmup)
	work += (ms->data.mw_data.master_dispatch (mw_numprocs - 1, work, 
					params.cache_warmup, (ms->send_kind_type_meas 
					== ONE ? 1:ms->data.mw_data.len), 
					ms->data.mw_data.communicator,
					ms->send_datatype));
    }
    /* for real */
    am_init(ms->max_rep);
    do
    {
      start_time = MPI_Wtime();
      /* measure */
      work = 0;

      while (work < ms->data.mw_data.chunks)
	work += (ms->data.mw_data.master_dispatch (mw_numprocs - 1, work, 
		ms->data.mw_data.chunks, (ms->send_kind_type_meas == ONE ? 
		1:ms->data.mw_data.len), 
		ms->data.mw_data.communicator,
		ms->send_datatype));

      end_time = MPI_Wtime();
      tbm_time = end_time - start_time;
    }while (am_control_end(ms, ms->data.mw_data.len, tbm_time, 
			   NO_COMMUNICATION, tbm_time, 
			   MPI_COMM_NULL));

    am_fill_data (ms, ms->data.mw_data.len, ms->data.mw_data.dummy_time, 
		  ms->data.mw_data.dummy_time_se, ms->data.mw_data.result);
    am_free();

    /* sending stop signal to each worker */

    D17(fprintf (stderr, "master: sending stop signals!\n");)

    for (worker = 1; worker < mw_numprocs ; worker ++)
      ms->data.mw_data.master_worker_stop (worker, (ms->send_kind_type_meas 
					   == ONE ? 1:ms->data.mw_data.len),
					   ms->data.mw_data.communicator,
					   ms->send_datatype);
  }
  else /* so worker */
  {
    for (;;)
    {
      /* sending the work done, ordering new work */
      D17(fprintf (stderr,"Worker %d: sending with len %d\n",local_myid,
	       ms->data.mw_data.len);)

      ms->data.mw_data.worker_send ((ms->recv_kind_type_meas == ONE ? 
				    1:ms->data.mw_data.len), 
				    ms->data.mw_data.communicator,
				    ms->recv_datatype); /* eigtl. send_ */

      D17(fprintf (stderr,"Worker %d: sended with len %d\n",local_myid,
	       ms->data.mw_data.len);)

      if (ms->data.mw_data.worker_receive ((ms->recv_kind_type_meas == ONE ? 
				   1:ms->data.mw_data.len),
				   ms->data.mw_data.communicator,
				   ms->recv_datatype) == FALSE)
      {
     	break;
      }
    }    
  }
  return (TRUE);
}
/* Global */

/* char msg[max_msg_len]; */

#ifdef MODULE_TEST
extern char 
  _skampi_buffer[0x1000];
#else
extern char
  *_skampi_buffer;
#endif


extern int
  _skampi_buffer_size;

/*
   @FUN:
   @DOES: the collective pattern.
   @PARAMETERS: the actual measurement (which sould be one of the 
   collective pattern).
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
void 
col_pattern (measurement_t *ms)
{
  int
    _col_myid;

  double
    start_time,
    node_time;  /* this time is the time need on one node for the
		   routine to be measured with out the barriers */

  

  MPI_Comm_rank(ms->communicator,&_col_myid);

  _current_comm = ms->communicator;

  if (_col_myid == 0) /* so Server */
  {
    double 
      end_time = 0.0,
      tbm_time;

    int len;

    if (ms->data.col_data.len == 0)
      len = 0;
    else
      len = ms->send_kind_type_meas == ONE ? 1:ms->data.col_data.len;
    if (params.cache_warmup > 0)
    {
      /* cache warmups, not measured */
      am_init(params.cache_warmup);
      do
      {
	if (ms->data.col_data.init_routine_to_measure!=NULL)
	  ms->data.col_data.init_routine_to_measure(
					    len, 
					    ms->data.col_data.communicator,
					    ms->send_datatype, ms->recv_datatype);
      
	start_time = MPI_Wtime();
	/* measure */
	  ms->data.col_data.routine_to_measure(
					       len, 
					       ms->data.col_data.communicator,
					       ms->send_datatype, 
					       ms->recv_datatype);
	node_time = MPI_Wtime() - start_time;
	MPI_Barrier (ms->data.col_data.communicator);
	
	end_time = MPI_Wtime();
	tbm_time = end_time - start_time;
      }while (am_control_end(ms, (-1) * params.cache_warmup, tbm_time, 
			     USE_COMMUNICATOR, 0.0,
			     ms->data.col_data.communicator));
      am_free();
    }
    /* and now for real ! */
    am_init(ms->max_rep);
    do
    {
      if (ms->data.col_data.init_routine_to_measure!=NULL)
	ms->data.col_data.init_routine_to_measure(
					     len, 
						  ms->data.col_data.communicator,
						  ms->send_datatype, 
						  ms->recv_datatype);
      if (params.cache_warmup == 0)
	initialize_data(_skampi_buffer, MIN(_skampi_buffer_size,
					    len * 
					    (int) ms->send_datatype_extent));
		
      start_time = MPI_Wtime();
      /* measure */
      ms->data.col_data.routine_to_measure(
					len, 
					   ms->data.col_data.communicator,
					   ms->send_datatype, ms->recv_datatype);
      node_time = MPI_Wtime() - start_time;
      MPI_Barrier (ms->data.col_data.communicator);

      end_time = MPI_Wtime();
      tbm_time = end_time - start_time;
    }while (am_control_end(ms, ms->data.col_data.len, tbm_time,
			   USE_COMMUNICATOR, node_time,
			   ms->data.col_data.communicator));
    /* to call am_control_end with the message length for parameter
       arg is not correct in case of varying over nodes, but this 
       does not matter, because the correct argument is placed in the
       data_t - structure during measure_suite (module autodist).
       Here it is only improtant to call am_control_end with an
       value >= 0 for arg */

    D(sprintf(_skampi_msg, "in col_pattern: dummy_time %f", 
	      ms->data.col_data.dummy_time);
      write_to_log_file (_skampi_msg);)

    am_fill_data (ms, ms->data.col_data.len, ms->data.col_data.dummy_time, 
		  ms->data.col_data.dummy_time_se, ms->data.col_data.result);
    am_free();

  }
  else /* client */
  {
    int len;

    if (ms->data.col_data.len == 0)
      len = 0;
    else
      len = ms->recv_kind_type_meas == ONE ? 1:ms->data.col_data.len;
      
    if (params.cache_warmup > 0)
    {
      /* once for cache */
      do
      {
	if (ms->data.col_data.init_client_routine !=NULL)
	  ms->data.col_data.init_client_routine(
						len, 
						 ms->data.col_data.communicator,
						ms->send_datatype, 
						ms->recv_datatype);
	start_time = MPI_Wtime();
	ms->data.col_data.client_routine(
					 len, 
					 ms->data.col_data.communicator,
					 ms->send_datatype, ms->recv_datatype);
	node_time = MPI_Wtime() - start_time;
	MPI_Barrier (ms->data.col_data.communicator);
      }while (am_control_end(ms, 0, 0.0, USE_COMMUNICATOR, 0.0,
			     ms->data.col_data.communicator));
    }
    /* once for real */
    do
    {
      if (ms->data.col_data.init_client_routine!=NULL)
	ms->data.col_data.init_client_routine(
					      len, 
					      ms->data.col_data.communicator,
					      ms->send_datatype, 
					      ms->recv_datatype);
      if (params.cache_warmup == 0)
	initialize_data(_skampi_buffer, MIN(_skampi_buffer_size,
					    len * 
					    (int) ms->recv_datatype_extent));

      start_time = MPI_Wtime();
      ms->data.col_data.client_routine(len, 
				       ms->data.col_data.communicator,
				       ms->send_datatype,
				       ms->recv_datatype);
      node_time = MPI_Wtime() - start_time;
      MPI_Barrier (ms->data.col_data.communicator);
    }while (am_control_end(ms, 0, 0.0, USE_COMMUNICATOR, node_time, 
			   ms->data.col_data.communicator));
  }
}
/*
#define NO_BCAST
*/
/*
#define NO_COM
*/
#define MSG_LEN_TEST 512

extern int
  _skampi_myid;

#ifdef MODULE_TEST
extern char 
  _skampi_buffer[0x1000];
#else
extern char
  *_skampi_buffer;
#endif

extern int
  _skampi_buffer_size;

/* @FUN: @DOES: finds nodes with minimum/maximum latency @PARAMETERS:
am measurement with the p2p pattern.  @RETURNES: TRUE in case of
success @SIDEEFFECTS: modifies ms->data.p2p_data.max_node and
ms->data.p2p_data.min_node @ASSUMES: _skampi_myid set */
int 
p2p_find_max_min (measurement_t *ms)
{
  int 
    receiver,
    error,
    numprocs;

  double 
    start_time,
    end_time = 0,
    tbm_time;

  data_list_t 
    liste;

  data_t
    data;

  MPI_Status
    status;


  MPI_Comm_size (ms->data.p2p_data.communicator,&numprocs);

  D8(fprintf (stderr, "server %d: numprocs %d\n", 
		     _skampi_myid, numprocs);)

  init_data(&data, numprocs);
  D8(fprintf (stderr, "server %d: data.nodes %d\n", 
		     _skampi_myid, data.nodes);)

  if (_skampi_myid == 0)
  {        
    init_list (&liste);
    for (receiver = 1; receiver < numprocs; receiver++)
    {
      if (params.cache_warmup > 0)
      {
	/* cache warmups, not measured */
	if (!am_init(params.cache_warmup))
	{
	  ERROR(NO_MEM,"find min/max cache ");
	  output_error (TRUE); /* ok??????? */
	}
	
	do
	{
	  D8(fprintf (stderr, "server %d: starting test meas.(cache)to %d\n", 
		     _skampi_myid, receiver);)
	    start_time = MPI_Wtime();
	  /* measure */
#ifndef NO_COM
	  MPI_Send (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, receiver, 0, 
		    ms->data.p2p_data.communicator);
	  MPI_Recv (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, receiver, 1, 
		    ms->data.p2p_data.communicator, &status);
#endif	
	  end_time = MPI_Wtime();
	  tbm_time = end_time - start_time;
	}while (am_control_end(ms, (-1) * params.cache_warmup, tbm_time,
			       receiver, tbm_time, MPI_COMM_NULL));
	am_free();
      }

      /* and now for real ! */
      if (!am_init(ms->max_rep))
      {
	ERROR(NO_MEM,"find min/max");
	output_error (TRUE); /* ok??????? */
      }
      do
      {
	D8(fprintf (stderr, "server %d: starting test meas. (real to %d)\n", 
		   _skampi_myid, receiver);)
	start_time = MPI_Wtime();
	/* measure */
#ifndef NO_COM
	MPI_Send (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, receiver, 0, 
		  ms->data.p2p_data.communicator);
	MPI_Recv (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, receiver, 1, 
		  ms->data.p2p_data.communicator, &status);
#endif
	end_time = MPI_Wtime();
	tbm_time = end_time - start_time;
      }while (am_control_end(ms, receiver, tbm_time, receiver, 
			     tbm_time, MPI_COMM_NULL));
      
      am_fill_data (ms, receiver, ms->data.p2p_data.dummy_time, 
		    ms->data.p2p_data.dummy_time_se, &data);
      am_free();
      D8(fprintf (stderr, "server %d: before append data.nodes %d\n", 
	     _skampi_myid, data.nodes);)
      append(&liste,&data,&error);
      if (error != DL_NO_ERROR)
      {
	ERROR (NO_MEM,"p2p_pattern: max/min");
	return (FALSE);
      }
    }

    /* find max / min */
    maximum (&liste, &(ms->data.p2p_data.max_node));
    minimum (&liste, &(ms->data.p2p_data.min_node));

    free_data_list (&liste, STATIC);

#ifndef NO_BCAST
    MPI_Bcast (&(ms->data.p2p_data.max_node), 1, MPI_INT, 0,
	       ms->data.p2p_data.communicator);
    MPI_Bcast (&(ms->data.p2p_data.min_node), 1, MPI_INT, 0,
	       ms->data.p2p_data.communicator);
#endif

    D8(fprintf (stderr, "server %d: after Bcast. Max %d, Min %d\n", 
		_skampi_myid, ms->data.p2p_data.max_node, 
		ms->data.p2p_data.min_node);)
  }
  else /* not process 0 */
  {
    /* for cache */
    if (params.cache_warmup > 0)
    {
      do
      {
	D8(fprintf (stderr, "client %d: at recv (cache)\n", _skampi_myid);)
#ifndef NO_COM
	  MPI_Recv (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, 0, 0, 
		    ms->data.p2p_data.communicator, 
		    &status);
	MPI_Send (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, 0, 1, 
		  ms->data.p2p_data.communicator);
#endif	
      }while (am_control_end(ms, (-1) * params.cache_warmup, 0.0, 0, 0.0, 
			     MPI_COMM_NULL));
    }
    /* for measurement */
    do
    {
      D8(fprintf (stderr, "client %d: at recv (real)\n", _skampi_myid);)
#ifndef NO_COM
      MPI_Recv (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, 0, 0, 
		ms->data.p2p_data.communicator, 
		&status);
      MPI_Send (_skampi_buffer, MSG_LEN_TEST, MPI_CHAR, 0, 1, 
		ms->data.p2p_data.communicator);
#endif
    }while (am_control_end(ms, 0, 0.0, 0, 0.0, MPI_COMM_NULL));
#ifndef NO_BCAST
    MPI_Bcast (&(ms->data.p2p_data.max_node), 1, MPI_INT, 0,
	       ms->data.p2p_data.communicator);
    MPI_Bcast (&(ms->data.p2p_data.min_node), 1, MPI_INT, 0,
	       ms->data.p2p_data.communicator);
#endif

    D8(fprintf (stderr, "client %d: after Bcast\n", _skampi_myid);)
  }    
  return (TRUE);
}
/*
   @FUN:
   @DOES: the p2p pattern.
   @PARAMETERS: th actual measurement (which sould be one of the 
   p2p pattern).
   @RETURNES: TRUE in case of success.
   @SIDEEFFECTS: none.
   @ASSUMES: nothing.
*/
int 
p2p_pattern (measurement_t *ms)
{
  int 
    _p2p_myid,
    numprocs;

  double 
    start_time,
    end_time = 0,
    org_time,
    tbm_time;


  MPI_Comm_size (ms->data.p2p_data.communicator,&numprocs);
  MPI_Comm_rank (ms->data.p2p_data.communicator,&_p2p_myid);

  if (_p2p_myid == 0)
  {  
#if 0
    ms->data.p2p_data.server_init (ms->data.p2p_data.len * ms->max_rep);
#endif
    int 
      len;
    if (ms->data.p2p_data.len == 0)
      len = 0;
    else
      len = ms->send_kind_type_meas == ONE ? 1:ms->data.p2p_data.len;

    if (ms->data.p2p_data.which_to_measure == MEASURE_MAX)
    {
      /* measurements for max_node */
      D8(fprintf (stderr, "server %d: starting max meas.\n", _p2p_myid);)

      if (params.cache_warmup > 0)
      {
	/* cache warmups, not measured */
	am_init(params.cache_warmup);
	do
	{
	  D8(fprintf (stderr, "server %d: sending to proc. %d for cache.\n", 
		     _p2p_myid,ms->data.p2p_data.max_node);)
	    
	  start_time = MPI_Wtime();
	  /* measure */
	  ms->data.p2p_data.server_op (len, 
				       ms->data.p2p_data.max_node, 
				       ms->data.p2p_data.communicator,
				       ms->send_datatype);
	  
	  end_time = MPI_Wtime();
	  tbm_time = end_time - start_time;
	}while (am_control_end(ms, (-1) * params.cache_warmup, tbm_time,
			       ms->data.p2p_data.max_node, tbm_time,
			       MPI_COMM_NULL));
	am_free();
      }
      /* and now for real ! */
      am_init(ms->max_rep);
      do
      {
	D8(fprintf (stderr, "server %d: sending to proc. %d for real.\n", 
		   _p2p_myid,ms->data.p2p_data.max_node);)
        if (params.cache_warmup == 0)
	  initialize_data(_skampi_buffer, MIN(_skampi_buffer_size,
					      len * 
					      (int) ms->send_datatype_extent));
	start_time = MPI_Wtime();
	/* measure */
	ms->data.p2p_data.server_op (len, 
				     ms->data.p2p_data.max_node, 
				     ms->data.p2p_data.communicator,
				     ms->send_datatype);
	
	end_time = MPI_Wtime();
	tbm_time = end_time - start_time;
      }while (am_control_end(ms, ms->data.p2p_data.len, tbm_time,
			     ms->data.p2p_data.max_node, tbm_time,
			     MPI_COMM_NULL));
      
      am_fill_data (ms, ms->data.p2p_data.len, ms->data.p2p_data.dummy_time, 
		    ms->data.p2p_data.dummy_time_se, ms->data.p2p_data.result);
      am_free();
    }
    else  /* measure min node */
    {
      /* measurements for min_node */
      D8(fprintf (stderr, "server %d: starting min measurement\n", _p2p_myid);)
      if (params.cache_warmup > 0)
      {
	/* cache warmups, not measured */
	am_init(params.cache_warmup);
	do
	{
	  start_time = MPI_Wtime();
	  /* measure */
	  ms->data.p2p_data.server_op (len, 
				       ms->data.p2p_data.min_node, 
				       ms->data.p2p_data.communicator,
				       ms->send_datatype);
	  
	  end_time = MPI_Wtime();
	  tbm_time = end_time - start_time;
	}while (am_control_end(ms, (-1) * params.cache_warmup, tbm_time,
			       ms->data.p2p_data.min_node, 
			       tbm_time, MPI_COMM_NULL));
	am_free();
      }
      /* and now for real ! */
      am_init(ms->max_rep);
      do
      {
	if (params.cache_warmup == 0)
	  initialize_data(_skampi_buffer, MIN(_skampi_buffer_size,
					      (ms->send_kind_type_meas == ONE ?
					       1:ms->data.p2p_data.len) * 
					      (int) ms->send_datatype_extent));

	start_time = MPI_Wtime();
	/* measure */
	ms->data.p2p_data.server_op (len, 
				     ms->data.p2p_data.min_node, 
				     ms->data.p2p_data.communicator,
				     ms->send_datatype);
	
	end_time = MPI_Wtime();
	tbm_time = end_time - start_time;
      }while (am_control_end(ms, ms->data.p2p_data.len, tbm_time,
			     ms->data.p2p_data.min_node, 
			     tbm_time, MPI_COMM_NULL));
      
      am_fill_data (ms, ms->data.p2p_data.len, ms->data.p2p_data.dummy_time, 
		    ms->data.p2p_data.dummy_time_se, ms->data.p2p_data.result);
      am_free();   
    }
#if 0
    ms->data.p2p_data.server_free (ms->data.p2p_data.len * ms->max_rep);
#endif
  }
  else /* so I am not process 0 */
  {
    int 
      len;
    if (ms->data.p2p_data.len == 0)
      len = 0;
    else
      len = ms->recv_kind_type_meas == ONE ? 1:ms->data.p2p_data.len;
    D8(fprintf (stderr, "client %d:which_to_measure %d\n"\
	       "max_node %d, min_node %d\n"\
	       "cond: %d\n", _p2p_myid,
	       ms->data.p2p_data.which_to_measure,
	       ms->data.p2p_data.max_node,
	       ms->data.p2p_data.min_node,
	       ((ms->data.p2p_data.which_to_measure == MEASURE_MAX &&
		_p2p_myid == ms->data.p2p_data.max_node) 
	       || (ms->data.p2p_data.which_to_measure == MEASURE_MIN &&
		   _p2p_myid == ms->data.p2p_data.min_node)));)

#if 1
    if ((ms->data.p2p_data.which_to_measure == MEASURE_MAX &&
	 _p2p_myid == ms->data.p2p_data.max_node) 
       || (ms->data.p2p_data.which_to_measure == MEASURE_MIN &&
	   _p2p_myid == ms->data.p2p_data.min_node))
#else
    if (1)
#endif
    {
#if 0
      ms->data.p2p_data.client_init (ms->data.p2p_data.len * ms->max_rep);
#endif
      if (params.cache_warmup > 0)
      {
	/* for cache */
	do
	{
	  D8(fprintf (stderr, "client %d: receiving from server for cache.\n", 
		     _p2p_myid);)
	    
	  start_time = MPI_Wtime();
	  ms->data.p2p_data.client_op (len, 0, 
				       ms->data.p2p_data.communicator,
				       ms->recv_datatype);
	  end_time = MPI_Wtime();
	  tbm_time = end_time - start_time;
	}while (am_control_end(ms, 0, 0.0, 0, tbm_time, MPI_COMM_NULL));
      }
      /* for real */
      do
      {
	D8(fprintf (stderr, "client %d: receiving from server for real"\
		   "with len %d.\n", _p2p_myid,ms->data.p2p_data.len );)
	  if (params.cache_warmup == 0)
	    initialize_data(_skampi_buffer, MIN(_skampi_buffer_size,
						(len * 
						 (int) ms->recv_datatype_extent)));
	  
	  ms->data.p2p_data.client_op (len, 0, 
				       ms->data.p2p_data.communicator,
				       ms->recv_datatype);
      }while (am_control_end(ms, 0, 0.0, 0, tbm_time,
			     MPI_COMM_NULL));
#if 0
      ms->data.p2p_data.client_free (ms->data.p2p_data.len * ms->max_rep);
#endif
    } /* if involved */
  }   /* if proc 0 */
  return (TRUE);
}

/*
   @FUN:
   @DOES: the simple pattern.
   @PARAMETERS: th actual measurement (which sould be one of the 
   simple pattern).
   @RETURNES: nothing.
   @SIDEEFFECTS: none.
   @ASSUMES: none.
*/
void 
simple_pattern (measurement_t *ms)
{

#ifndef SEQ
  double 
#else
  clock_t
#endif /*SEQ*/
    start_time,
    end_time;
  double
    tbm_time;

  long int
    i;

#ifndef SEQ
  int
    _simple_myid;
  MPI_Comm_rank(ms->communicator,&_simple_myid);
  if (_simple_myid == 0)
#endif /*SEQ*/
  {
    if (params.cache_warmup > 0)
    {
      /* cache warmups, not measured */
      am_init(params.cache_warmup);
      do
      {
	end_time = start_time = MEASURE_TIME;
	/* measure */
	for (i = 0; end_time == start_time; i++)
	{
	  ms->data.simple_data.routine_to_measure();
	  end_time = MEASURE_TIME;
	}
	tbm_time = (double) (end_time - start_time) / 
			     (SKALIB_CLOCKS_PER_SEC * ((double)i));
#ifndef SEQ
      }while (am_control_end(ms, (-1) * params.cache_warmup, tbm_time, 
			     NO_COMMUNICATION, tbm_time,
			     MPI_COMM_NULL));
#else
      }while (am_control_end(ms, (-1) * params.cache_warmup, tbm_time, 
			     NO_COMMUNICATION));
#endif /*SEQ*/
      am_free();
    }
    /* and now for real ! */
    am_init(ms->max_rep);
    do
    {
      end_time = start_time = MEASURE_TIME;
      /* measure */
      for (i = 0; end_time == start_time; i++)
      {
	ms->data.simple_data.routine_to_measure();
	end_time = MEASURE_TIME;
      }
      tbm_time = (double) (end_time - start_time) / 
			   (SKALIB_CLOCKS_PER_SEC * ((double)i));
#ifndef SEQ
    }while (am_control_end(ms, 0, tbm_time, 
			   NO_COMMUNICATION, 
			   tbm_time, MPI_COMM_NULL));
#else
    }while (am_control_end(ms, 0, tbm_time, 
			   NO_COMMUNICATION));
#endif /*SEQ*/
    am_fill_data (ms, 0, ms->data.simple_data.dummy_time, 
		  ms->data.simple_data.dummy_time_se, 
		  ms->data.simple_data.result);
    am_free();
  }
}
